function Esosets.InitSets()
    Esosets.PVP = "PvP"
    Esosets.PVE = "PvE"
    Esosets.NICHE = "Niche"
    Esosets.BEGINNER = "Beginner"

    Esosets.ALL_SETS = {
        {
            name = "Affliction",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.DISEASE_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) 50% chance when causing damage to also cause 2979 Disease Damage. This effect has a cooldown of 4 seconds."
        },
        {
            name = "Alessia's Bulwark",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.REDUCE_WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVE, Esosets.PVP },
            traits = 5,
            obtained = {
                ad = "Malabal Tor - Chancel of Divine Entreaty",
                dc = "Alik'r Desert - Alezer Kotu",
                ep = "Eastmarch - Hammerhome",
                zones = { Esosets.MALABAL_TOR, Esosets.ALIKR, Esosets.EASTMARCH }
            },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Physical Resistance;(5 items) Being damaged by a melee attack has a 15% chance to reduce attacker's Weapon Damage by 10% for 5 seconds"
        },
        {
            name = "Almalexia's Mercy",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) 20% chance when taking damage to heal allies within 7 meters for 2429. This effect has a cooldown of 3 seconds."
        },
        {
            name = "Alessian Order",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.BREAK_FREE },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) Increases the immunity to disabling effects after using Break Free by 3 seconds."
        },
        {
            name = "Agility",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            obtained = {
                location = "Bloody Claws {Arboretum}, Monstrous Teeth {Temple}"
            },
            displayText = "(2 items) Adds 1451 Max Stamina;(3 items) Adds 193 Weapon Damage"
        },

        {
            name = "Arch-Mage",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) Fully-charged heavy attacks restore 834 Magicka."
        },
        {
            name = "Armor Master",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 9,
            obtained = {
                location = "Memorial District"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) While you have an Armor Ability slotted, increase your Max Health by 5%. When you activate an Armor Ability you gain 5332 Physical and Spell Resistance for 10 seconds."
        },
        {
            name = "Armor of the Seducer",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC, Esosets.REDUCE_MAGIC_COST },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            traits = 3,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.BEGINNER },
            obtained = {
                ad = "Grahtwood - Temple of the Eight",
                dc = "StormHaven - Fisherman's Island",
                ep = "Deshaan - Berezan's Mine",
                zones = { Esosets.GRAHTWOOD, Esosets.STORMHAVEN, Esosets.DESHAAN }
            },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Reduce the Magicka cost of abilities by 8%."
        },
        {
            name = "Ashen Grip",
            bonuses = { Esosets.MAX_HEALTH, Esosets.WEAPON_DAMAGE, Esosets.WEAPON_CRIT, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.BEGINNER },
            traits = 2,
            obtained = {
                ad = "Auridon - Beacon Falls",
                dc = "Glenumbra - Par Molag",
                ep = "Stonefalls - Magmaflow Overlook",
                zones = { Esosets.AURIDON, Esosets.GLENUMBRA, Esosets.STONEFALLS }
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) 10% chance to breath fire for 1544 Flame Damage on melee hits. This effect can occur once every 4 seconds."
        },
        {
            name = "Bastion of the Heartland",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.REDUCE_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Reduce damage taken from players by 5%.;(5 items) Reduce damage taken from siege weapons and player AoE spells by 20%."
        },
        {
            name = "Beckoning Steel",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) 40% to intercept projectiles for allies within 5m."
        },
        {
            name = "Blessing of the Potentates",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.ULTIMATE },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            obtained = {
                location = "Pvp Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Reduce cost of Ultimate abilities by 10%."
        },
        {
            name = "Blood Spawn",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.ULTIMATE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GLENUMBRA,
            dungeons = { Esosets.SPINDLE_CLUTCH_II },
            shouldersChest = Esosets.MAJ_AL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 129 Stamina Recovery;(2 items) 6% chance when hit to gain 6450 Armor and Spell Resist for 6.0 seconds and restore 14 Ultimate."
        },
        {
            name = "Bloodthorn's Touch",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.PVP, Esosets.BEGINNER },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you deal direct damage, you restore 660 Magicka and Stamina. This effect can occur once every 5 seconds."
        },
        {
            name = "Brands of Imperium",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.DAMAGE_SHIELD },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            dungeons = { Esosets.WHITE_GOLD_TOWER },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) 6% chance when taking damage to grant yourself and nearby allies a 12040 Damage Shield that lasts for 8 seconds. This effect has a cooldown of 15 seconds."
        },
        {
            name = "Briarheart",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) 10% chance when you deal Critical Damage to create Briarthorns which increases your Weapon Damage by 449 for 10 seconds. While Briarthorns is active, your Critical Hits will heal you for 609 Health. Briarthorns can apply once every 15 seconds."
        },
        {
            name = "Black Rose",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;5 items) Increases the Magicka and Stamina restoration benefit from the Constitution Passive by 50% and increases Weapon and Spell Damage by 154."
        },
        {
            name = "Buffer of the Swift",
            bonuses = { Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.REDUCE_DAMAGE, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Reduce damage taken from players by 5%.;(5 items) 10% chance to gain a 2520 point Damage Shield for 6 seconds when damaged by a spell. This effect can occur once every 4 seconds."
        },
        {
            name = "Burning Spellweave",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.SPELL_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.CITY_OF_ASH_I, Esosets.CITY_OF_ASH_II },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) When you deal damage with a Flame Damage ability, you have a 15% chance to apply the burning status effect to the enemy and gain 525 Spell Damage for 8 seconds. This effect can occur once every 12 seconds."
        },
        {
            name = "Clever Alchemist",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE, Esosets.MAX_HEALTH },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.HEWS_BANE,
            bestUsedIn = { Esosets.PVP },
            traits = 7,
            obtained = {
                location = "Hew's Bane - No Shira Workshop"
            },
            displayText = "(2 Items) Adds 1206 Max Health;(3 Items) Adds 1206 Max Health;(4 Items) Adds 129 Spell Damage / Weapon Damage;(5 Items) When you drink a potion you feel a rush of energy, gaining 661 Weapon and Spell Damage for 15 seconds."
        },
        {
            name = "Combat Physician",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.BEGINNER },
            dungeons = { Esosets.WAYREST_SEWERS_I, Esosets.WAYREST_SEWERS_II },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 688 Spell Critical;(5 items) Critically Healing an ally grants them a 8195 Damage Shield for 8 seconds. This effect has a cooldown of 6 seconds."
        },
        {
            name = "Crest of Cyrodiil",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN},
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) After successfully blocking, heal for 8000 Health. This effect can occur every 5 seconds."
        },
        {
            name = "Crusader",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.DODGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) After roll dodging, continue to dodge attacks for an additional 0.3 seconds."
        },
        {
            name = "Curse Eater",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAX_MAGIC, Esosets.MAX_HEALTH, Esosets.REDUCENEGATIVE_EFFECTS },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1039 Max Health;(2 items) Adds 1096 Max Magicka;(4 items) Adds 126 Magicka Recovery;(5 items) Reduce the duration of negative effects on you by 20%"
        },
        {
            name = "Darkstride",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.REDUCESTAM_COST },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces Stamina cost for sprinting or crouching by 35%."
        },
        {
            name = "Deadly Strikes",
            bonuses = { Esosets.MAX_HEALTH, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            obtained = {
                location = "Pvp Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 833 Weapon Critical"
        },
        {
            name = "Death's Wind",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.STUN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVE, Esosets.BEGINNER },
            traits = 2,
            obtained = {
                ad = "Auridon - Eastshore Islets Camp",
                dc = "Glenumbra - Chill House",
                ep = "Stonefalls - Armatures Upheaval",
                zones = { Esosets.AURIDON, Esosets.GLENUMBRA, Esosets.STONEFALLS }
            },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) If struck by a melee attack while below 35% Health, nearby enemies are knocked back and stunned for 4 seconds. This effect can only happen once every 30 seconds."
        },
        {
            name = "Desert Rose",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Magicka;(5 items) 10% chance when taking damage to recover 2408 Magicka. This effect has a 1 second cooldown."
        },
        {
            name = "Destructive Mage",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            dungeons = { Esosets.HEL_RA },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage with a fully-charged Heavy Attack, you place a bomb on the enemy for 10 seconds. When another player hits the same enemy with a fully-charged Heavy Attack they detonate the bomb, dealing 7875 Magic Damage all enemies within 8 meters. This effect can occur once every 10 seconds."
        },
        {
            name = "Draugr's Heritage",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.THE_RIFT,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) Knockdown nearby enemies and heal self for 4730 if you are damaged while under 20% Health. This effect can happen once every 20 seconds."
        },
        {
            name = "Dreugh King Slayer",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.BRUTALITY, Esosets.EXPEDITION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.FUNGAL_GROTTO_I, Esosets.FUNGAL_GROTTO_II },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Passively grants Major Brutality, increasing your Weapon Damage by 20%. Killing an enemy grants you Major Expedition for 10 seconds, increasing your movement speed by 30%."
        },
        {
            name = "Eagle Eye",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.BOW },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            obtained = {
                location = "Pvp Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Increases range of Bow abilities by 3 meters."
        },
        {
            name = "Elf Bane",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) Increases duration of your damaging fire effect by 2 seconds."
        },

        {
            name = "Elemental Succession",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) While in combat, you gain a rotating bonus to either Flame, Shock or Frost damage. The active element changes every 4 seconds. Your attacks dealing damage with the active element gain 515 Spell Damage."
        },
        {
            name = "Endurance",
            bonuses = { Esosets.MAX_HEALTH, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            obtained = {
                location = "Planar Armor Scraps{Elven Gardens}, Mark of the Legion{Nobles}"
            },
            displayText = "(2 items) Adds 1596 Max Health;(3 items) Adds 193 Stamina Recovery"
        },
        {
            name = "Engine Guardian",
            bonuses = { Esosets.HEALTH_REGEN, Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            dungeons = { Esosets.DARKSHADE_CAVERNS_II },
            zone = Esosets.DESHAAN,
            shouldersChest = Esosets.MAJ_AL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(1 items) Adds 129 Health Recovery;(2 items) 10% chance on ability use to summon a dwemer automation to restore 1162 Health, Stamina, or Magicka every 0.5 seconds for 6.5 seconds."
        },

        {
            name = "Essence Thief",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            dungeons = { Esosets.WHITE_GOLD_TOWER },
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) 15% chance when causing damage with light attacks to draw essence from an enemy. Collecting the essence restores 4300 Health and Stamina and increases your damage by 12% for 10 seconds."
        },

        {
            name = "Eternal Hunt",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.POISON_DAMAGE, Esosets.DODGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.HEWS_BANE,
            bestUsedIn = { Esosets.PVP },
            traits = 9,
            obtained = {
                location = "Hew's Bane - The Lost Pavillion"
            },
            displayText = "(2 Items) Adds 1096 Maximum Stamina;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Stamina Recovery;(5 Items) When you roll dodge you leave behind a rune that detonates when enemies come close dealing 8125 Poison Damage and immobilizing them for 1.5 seconds."
        },
        {
            name = "Eternal Warrior",
            bonuses = { Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.RESURRECTION },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.SANCTUM, Esosets.HEL_RA, Esosets.ATHERIAN_ARCHIVE },
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Grants Major Aegis, causing you to take 5% less damage from Boss Monsters;(4 items) Adds 1206 Max Health;(5 items) When you die, you instead turn into a statue for 3 seconds and gain 200 Ultimate. While a statue, you are immune to all negative effects, but can still be healed. This effect has a cooldown of 10 minutes. Adds 4% Healing Taken"
        },

        {
            name = "Eyes of Mara",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.REDUCEMAGIC_COST },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.EYEVEA,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "Any Mages Guild Portal - Eyevea"
            },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Reduce the Magicka cost of restoration staff abilities by 12%."
        },

        {
            name = "Fasalla's Guile",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.DEFILE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1206 Maximum Health;(4 Items) Adds 4% Healing Taken;(5 Items) Apply Minor Defile to all nearby enemies, reducing their healing received by 15% for 2 seconds."
        },
        {
            name = "Flanking Strategist",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) Attacks from behind and enemy gain an additional 345 Weapon Damage."
        },
        {
            name = "Galerion's Revenge",
            bonuses = { Esosets.SPELL_CRIT, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 688 Spell Critical;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you hit an enemy with a Light or Heavy Attack you put a Mark of Revenge on them for 15 seconds, after stacking 6 Marks on a target they will detonate for 7561 Magic Damage."
        },
        {
            name = "Glorious Defender",
            bonuses = { Esosets.MAX_HEALTH, Esosets.WEAPON_DAMAGE, Esosets.DODGE },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Weapon Damage;(5 items) 9% chance when you hit an enemy with a light or heavy attack to dodge the next attack against you."
        },
        {
            name = "Grace of the Ancients",
            bonuses = { Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            obtained = {
                location = "Pvp Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Increase Maximum Magicka by 4%."
        },
        {
            name = "Hawk's Eye",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.BOW },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Reduce cost of bow abilities by 5% and increase their damage by 5%."
        },
        {
            name = "Healer's Habit",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE, Esosets.HEAL, Esosets.MENDING },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            dungeons = { Esosets.DSA },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) Gain Minor Mending, increasing healing done by 8%"
        },
        {
            name = "Hide of Morihaus",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_STAMINA, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds Adds 1096 Max Stamina;(5 items) Rolling through enemies deals 1932 Physical Damage and knocks them down."
        },
        {
            name = "Hist Bark",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.HEALTH_REGEN, Esosets.MAX_HEALTH, Esosets.EVASION },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 4,
            obtained = {
                ad = "Greenshade - Rootwatch Tower",
                dc = "Rivenspire Trader's Rest",
                ep = "Shadowfen Hatchling's Crown",
                zones = { Esosets.GREENSHADE, Esosets.RIVENSPIRE, Esosets.SHADOWFEN }
            },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 129 Health Recovery;(4 items) Adds 1206 Max Health;(5 items) Gain Major Evasion while blocking, increasing Dodge chance by 15%."
        },
        {
            name = "Hunding's Rage",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 6,
            obtained = {
                ad = "Reaper's March - Broken Arch",
                dc = "Bangkori - Wether's Cleft",
                ep = "The Rift - Trollslayer Gully",
                zones = { Esosets.THE_RIFT, Esosets.REAPERS_MARCH, Esosets.BANGKORAI }
            },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) Increase Weapon Damage by 300."
        },
        {
            name = "Hunt Leader",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Gain 1216 Stamina and 2433 Health when your pets attack an enemy you have also attacked recently. Can occur once per 5 seconds."
        },
        {
            name = "Infallible Mage",
            bonuses = { Esosets.SPELL_CRIT, Esosets.SLAYER, Esosets.SPELL_DAMAGE, Esosets.VULNERABILITY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.HEL_RA, Esosets.ATHERIAN_ARCHIVE, Esosets.SANCTUM },
            displayText = "(2 items) Adds 833 Spell Critical;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%.;(4 items) Adds 129 Spell Damage;(5 items) Your fully charged heavy attacks do an additional 903 damage.Enemies you damage with fully charged Heavy Attacks are afflicted with Minor Vulnerability for 10 seconds, increasing their damage taken by 8%.;(5 items) Adds 833 Spell Critical"
        },
        {
            name = "Imperial Physique",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN, Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1096 Max Stamina;(5 items) While you are in Imperial City, you tap into the power of the Tel Var stones you are carrying, increasing your Health, Magicka and Stamina by 996. While you have a 4x Tel Var Stone multiplier this effect is increased by 600%."
        },
        {
            name = "Juggernaut",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Max Health;(5 items) When Health drops below 30%, heal for 12900. This effect can occur once every 1 minute."
        },
        {
            name = "Kagrenac's Hope",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.RESURRECTION },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 8,
            obtained = {
                location = "3rd Zone Major City Fighters Guild - Earth Forge"
            },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1206 Max Health;(5 items)  Decrease time to resurrect an ally by 25% and restore 1720 Magicka when you successfully resurrect an ally. Adds 222 Spell Damage"
        },
        {
            name = "Knightmare",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.WEAPON_DAMAGE, Esosets.REDUCE_DAMAGE, Esosets.MAIM },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            dungeons = { Esosets.SPINDLECLUTCH_I, Esosets.SPINDLECLUTCH_II },
            displayText = "(2 items) Adds 1898 Physical Resistance;(3 items) Adds 1039 Max Health;(4 items) Adds 126 Weapon Damage;(5 items) 20% Chance on melee attack to apply Minor Maim to nearby enemies for 5 seconds, reducing the damage they deal by 15%."
        },
        {
            name = "Kvatch Gladiator",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            traits = 7,
            obtained = {
                location = "Gold Coast - Marja's Mill"
            },
            displayText = "(2 items) Adds 688 Weapon Critical ;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) Your Light and Heavy Attacks deal an additional 690 Weapon Damage to targets below 25% Health."
        },
        {
            name = "Kyne's Kiss",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.WEAPON_CRIT, Esosets.HEAL, Esosets.BOW },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 688 Weapon Critical;(5 items) Bow attacks have a 10% chance to restore 1216 Stamina and Health. This effect will not proc off damage over time effects."
        },
        {
            name = "Lamia's Song",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.ULTIMATE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.SHADOWFEN,
            dungeons = { Esosets.ARX },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magica Recovery;(4 items) Adds 1096 Max Magicka;(5 items) When you activate your Ultimate, you heal you and your allies within 20 meters of you for 30 Health per point of the Ultimate's cost."
        },
        {
            name = "Law Of Julianos",
            bonuses = { Esosets.SPELL_CRIT, Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 6,
            obtained = {
                location = "Wrothgar - Boreal Forge"
            },
            displayText = "(2 items) Adds 688 Spell Critical;(3 items) Adds 1096 Max Magicka;(4 items) Adds 688 Spell Critical;(5 items) Increase Spell Damage by 299"
        },
        {
            name = "Light Speaker",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVE, Esosets.BEGINNER },
            dungeons = { Esosets.ELDEN_HOLLOW_I, Esosets.ELDEN_HOLLOW_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your Restoration Staff abilities."
        },
        {
            name = "Light of Cyrodiil",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.REDUCE_DAMAGE,Esosets.REDUCE_COST },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) While casting or channeling a spell, incoming damage is reduced by 15%."
        },
        {
            name = "Leeching Plate",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.POISON_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.IMPERIAL_CITY_PRISON },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 4% Healing Taken;(5 items) 8% chance when damaged to summon a cloud of leeching poison under the attacker that deals 1204 Poison Damage every second for 5.5 seconds and heals you for the damage caused."
        },
        {
            name = "Leki's Focus",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.REDUCE_AOE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 Items) Adds 129 Weapon Damage;(3 Items) Adds 1096 Maximum Stamina;(4 Items) Adds 129 Stamina Recovery;(5 Items) You take 25% less damage from players' area effect abilities but the damage and healing of your own area effect abilities is also reduced by 25%"
        },
        {
            name = "Lord Warden",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            dungeons = { Esosets.IMPERIAL_CITY_PRISON },
            shouldersChest = Esosets.URG,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) 6% chance when hit to summon a shadow orb that adds 3870 Spell Resistance to nearby allies for 12.0 seconds."
        },
        {
            name = "Lunar Bastion",
            bonuses = { Esosets.HEALING_TAKEN, Esosets.AEGIS, Esosets.MAX_HEALTH, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.MAW_OF_LORKAJ },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 Items) Adds 4% Healing Taken;(3 Items) Grants Minor Aegis, causing you to take 5% less damage from Boss Monsters;(4 Items) Adds 1206 Maximum Health;(5 Items) When you use a synergy you create a lunar blessing for 10 seconds that grants a 2399 Damage Shield to nearby allies every 2 seconds."
        },
        {
            name = "Magicka Furnace",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            dungeons = { Esosets.DIREFROST_KEEP },
            obtained = {
                location = "Direfrost Keep"
            },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) When you take damage from a melee attack while you are under 80% Magicka, restore 8000 Magicka. This effect can occur once every 30 seconds."
        },
        {
            name = "Mark of the Pariah",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) Increases your Physical and Spell Resistance by up to 8807 based on your missing Health."
        },
        {
            name = "Marksman's Crest",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.BOW },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 Items) Adds 129 Stamina Recovery;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Weapon Damage;(5 Items) Reduce the Stamina cost of abilities by 5% and increase the damage of your bow abilities against players by 8%"
        },
        {
            name = "Maw of the Inferno",
            bonuses = { Esosets.MAX_HEALTH, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            dungeons = { Esosets.BANISHED_CELLS_II },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 1206 Max Health;(2 items) 5% chance on light or heavy attack to summon a fire breathing daedroth for 15.0 seconds. Basic attack deals 3067 Flame Damage."
        },
        {
            name = "Magnus' Gift",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE, Esosets.REDUCEMAGIC_COST },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.BEGINNER },
            obtained = {
                ad = "Greenshade - Aranaga",
                dc = "Rivenspire - Valenwood Ede",
                ep = "-Shadowfen - Xal haj-ei Shrine",
                zones = { Esosets.GREENSHADE, Esosets.RIVENSPIRE, Esosets.SHADOWFEN }
            },
            traits = 4,
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) 8% Chance to negate the Magicka cost of a spell."
        },
        {
            name = "Meritorious Service",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) While you cast a Support Ability up to 4 nearby allies gain 3010 Physical and Spell Resistance for 2 minutes."
        },
        {
            name = "Molag Kena",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.WHITE_GOLD_TOWER },
            shouldersChest = Esosets.URG,
            displayText = "(1 items) Adds 129 Weapon and Spell Damage;(2 items) Causing damage with 2 consecutive light attacks triggers Overkill, which increases the cost of all abilities by 33% and increases your Spell Damage and Weapon Damage by 516 for 6 seconds."
        },
        {
            name = "Moondancer",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SLAYER, Esosets.SPELL_DAMAGE, Esosets.MAGIC_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.MAW_OF_LORKAJ },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 Items) Adds 1096 Maximum Magicka;(3 Items) Grants Minor Slayer, causing your attacks to deal 5% more damage to Boss Monsters;(4 Items) Adds 129 Spell Damage;(5 Items) When you activate a synergy gain either shadow blessing that increases Spell Damage by 448, or a lunar blessing that increases Magicka Recovery by 448. Each lasts 30 seconds and you can only have one blessing at a time."
        },
        {
            name = "Morang Tong",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Your attacks cause targets to take 15% more damage from Poisons for 5 seconds."
        },
        {
            name = "Mother's Sorrow",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;3 items) Adds 688 Spell Critical;(4 items) Adds 688 Spell Critical;(5 items) Adds 1924 Spell Critical"
        },
        {
            name = "Morkuldin",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.PVP },
            traits = 9,
            obtained = {
                location = "Wrothgar - Morkuldin Forge"
            },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Weapon Damage;(5 items) 10% chance when using Light or Heavy attacks to summon an animated weapon to attack your enemies. The weapon's basic attack deals 4551 Physical Damage."
        },
        {
            name = "Necropotence",
            bonuses = { Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) While you have a pet active, your Max Magicka is increased by 3150."
        },
        {
            name = "Nerien'eth",
            bonuses = { Esosets.MAX_HEALTH },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.RIVENSPIRE,
            dungeons = { Esosets.CRYPT_OF_HEARTS_II },
            shouldersChest = Esosets.GILIRION,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 1206 Max Health;(2 items) 10% chance when causing damage to create a Lich crystal that explodes after 3 seconds, dealing 7408 Magic Damage."
        },
        {
            name = "Bogdan Night Flame",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.ELDEN_HOLLOW_II },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 1206 Max Health;(2 items) 2% chance when healing an ally to create a totem for 10.0 seconds. Totem heals allies in area for 1120 every 1.0 second. This effect has a cooldown of 6.seconds."
        },
        {
            name = "Night Mother's Embrace",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.STAMINA_REGEN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Reduce the range you can be detected while hidden by 2 meters. Reduces crouch cost by 25%;(5 items) Adds 129 Weapon Damage"
        },
        {
            name = "Night Mother's Gaze",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.REDUCEPHYSICAL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY, Esosets.FRACTURE },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVE, Esosets.BEGINNER },
            traits = 6,
            obtained = {
                ad = "Reaper's March - Old Town Cavern",
                dc = "Bangkori - Silaseil Ruins",
                ep = "The Rift - Eldbjorg's Hideaway",
                zones = { Esosets.REAPERS_MARCH, Esosets.BANGKORAI, Esosets.THE_RIFT }
            },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Applies Major Fracture to the enemy when you deal Critical Damage reducing their Physical Resistance by 2580."
        },
        {
            name = "Night's Silence",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.WEAPON_CRIT },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.NICHE },
            traits = 2,
            obtained = {
                ad = "Auridon - Hightide Keep",
                dc = "Glenumbra - Mesanthano's Tower",
                ep = "Stonefalls - Steamfont Cavern",
                zones = { Esosets.AURIDON, Esosets.GLENUMBRA, Esosets.STONEFALLS }
            },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 688 Weapon Critical;(5 items) Ignore movement speed penalty while sneaking."
        },
        {
            name = "Noble's Conquest",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.HEALING_TAKEN, Esosets.HEAL, Esosets.VULNERABILITY },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            traits = 5,
            zone = Esosets.CYRODIIL,
            obtained = {
                location = "Noble District"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 4% Healing Taken;(5 items) When you interrupt a casting enemy, you heal for 4300 Health and apply minor vulnerability increasing the enemy's damage taken by 8% for 10 seconds."
        },
        {
            name = "Noble Duelist's Skills",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            dungeons = { Esosets.BLESSED_CRUCIBLE },
            zone = Esosets.THE_RIFT,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Weapon Damage;(5 items) After dodging an attack, light and heavy attacks deal ? increased damage for 8 seconds."
        },
        {
            name = "Oblivion's Foe",
            bonuses = { Esosets.HEALTH_REGEN, Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "Coldharbour - Font of Schemes"
            },
            displayText = "(2 items) Adds 129 Health Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Magicka Recovery;(5 items) Increase the damage of your Soul Trap abilities by 100%."
        },
        {
            name = "Orgnum's Scales",
            bonuses = { Esosets.HEALTH_REGEN, Esosets.MAX_HEALTH, Esosets.HEALTH_REGEN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "3rd Zone Major City Fighters Guild - Earth Forge"
            },
            displayText = "(2 items) Adds 129 Health Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) If below 60% Health, increase Health Recovery by 50%."
        },
        {
            name = "Overwhelming Surge",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.MALABAL_TOR,
            dungeons = { Esosets.TEMPEST_ISLAND },
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) 8% chance when activating a Class Ability to surround yourself in a torrent that strikes out at a nearby enemy dealing 1376 Shock Damage every seconds for 6 seconds."
        },
        {
            name = "Para Bellum",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Stamina;(5 items) After not taking damage for 10 seconds gain a 12040 Damage Shield."
        },
        {
            name = "Pelinal's Aptitude",
            bonuses = { Esosets.MAX_HEALTH, Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN, Esosets.WEAPON_DAMAGE, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.NICHE },
            traits = 9,
            obtained = {
                location = "Gold Coast - Colovian Revolt Forge Yard"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Magicka Recovery;(5 items) Your Weapon Damage and Spell Damage both become the highest of the two values."
        },
        {
            name = "Permafrost",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.HEALTH_REGEN },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Gain 885 Health Recovery while you have a Damage Shield."
        },
        {
            name = "Phoenix",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE, Esosets.RESURRECTION },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you die, instead become immune to all negative effects and healing for 3 seconds. When the effect ends you heal yourself for 17200 and explode for 8600 Flame Damage to nearby enemies. The effect has a cooldown of 10 minutes."
        },
        {
            name = "Powerful Assault",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1206 Max Health ;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you cast an Assault Ability, up to 4 nearby allies gain 164 Weapon and Spell Damage for 15 seconds."
        },
        {
            name = "Prayer Shawl",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.SPINDLECLUTCH_I, Esosets.SPINDLECLUTCH_II },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 tiems) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) 6% chance to grant a 2340 point Damage Shield when you heal an ally."
        },
        {
            name = "Prisoner's Rags",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost of Sprint by 50%. While Sprinting, restore 1000 Magicka every 1 second."
        },
        {
            name = "Queen's Elegance",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.PVE, Esosets.PVP },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) Increases your Light and Heavy Attack damage by 20%."
        },
        {
            name = "Ravager",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_HEALTH, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 672 Weapon Critical;(3 items) Adds 1039 Max Health;(4 items) Adds 126 Weapon Damage;5 items) Your melee attacks have an 8% chance to increase Weapon Damage by 630 for 10 seconds."
        },
        {
            name = "Reactive Armor",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.MAX_HEALTH, Esosets.REDUCE_DAMAGE, Esosets.STUN },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1206 Max Health;(5 items) While affected by Stun, Immobilize, Fear, Knockdown or Disorient effects, damage you take is reduced by 35%."
        },
        {
            name = "Redistributor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            traits = 7,
            obtained = {
                location = "Arboretum District"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) When you heal yourself while at full Health, heal a nearby ally for 2347. This effect can happen once every 3 seconds."
        },
        {
            name = "Roar of Alkosh",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.SLAYER, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.MAW_OF_LORKAJ },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 Items) Adds 688 Weapon Critical;(3 Items) Grants Minor Slayer, causing your attacks to deal 5% more damage to Boss Monsters.;(4 Items) Adds 129 Weapon Damage;(5 Items) Activating a synergy sends a shockwave from your position that deals 1905 Physical Damage. Enemies hit have their Physical and Spell Resistance reduced by 3010 and take 13340 Physical Damage over 10 seconds."
        },
        {
            name = "Robes Alteration Mastery",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.SPELL_CRIT, Esosets.REDUCE_COST },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 688 Spell Critical;(5 items) Reduce all costs by 6%"
        },
        {
            name = "Robes of the Hist",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) Reduces the duration of all disabling effects applied to you by 20%. While you are affected by a disabling effect, heal for 2000 Health every 1 second."
        },
        {
            name = "Robes of Transmutation",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.SPELL_CRIT, Esosets.CRIT_RESIST },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 Items) Adds 129 Magicka Recovery;(3 Items) Adds 129 Magicka Recovery;(4 Items) Adds 688 Spell Critical;(5 Items) When you heal an ally with a healing over time effect, grant them 1304 critical resistance for 20 seconds."
        },
        {
            name = "Robes of Onslaught",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) Duration of Snare, Stuns and Disorient effects are reduced by 20%."
        },
        {
            name = "Robes of the Withered Hand",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.ALIKR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.BEGINNER },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1002 Max Health;(5 items) When an enemy within 28 meters dies, heal for 1290 Health and gain 1290 Magicka. This effect can occur once every 3 seconds."
        },
        {
            name = "Sanctuary",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.MAX_MAGIC, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.BANISHED_CELLS_I, Esosets.BANISHED_CELLS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1096 Max Magicka;(5 items) Increases your healing received by 12% for you and your group within 10 meters."
        },
        {
            name = "Scathing Mage",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            dungeons = { Esosets.IMPERIAL_CITY_PRISON },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 833 Spell Critical;(4 items) Adds 833 Spell Critical;(5 items) When you deal direct Critical Damage, you have a 20% chance to increase your Spell Damage by 516 for 6 seconds. This effect can occur once every 6 seconds."
        },
        {
            name = "Scourge Harvester",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.STORMHAVEN,
            dungeons = { Esosets.WAYREST_SEWERS_II },
            shouldersChest = Esosets.MAJ_AL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 1206 Max Health;(2 items) 6% chance when hit to create a beam that steals 5652 Health from target. Beam breaks from targets greater than 10 meters away. While beam holds gain 30.0% increased healing from all sources."
        },
        {
            name = "Sergeant's Mail",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALTH_REGEN, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.WAYREST_SEWERS_I, Esosets.WAYREST_SEWERS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Add 129 Weapon Damage;(5 items) Your fully charged Heavy Attacks deal ?? additional damage."
        },
        {
            name = "Sentry",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.WEAPON_CRIT },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Weapon Critical;(5 items) Damage dealt to Sneaking targets increased by 20%. Stealth detection radius increased by 20%."
        },
        {
            name = "Shadow Walker",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.STAMINA_REGEN, Esosets.HEALTH_REGEN },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Restore ?? Health and Stamina every second while hidden and not moving."
        },
        {
            name = "Shadow Dancer's Raimnet",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Ignore movement speed penalty while sneaking. Adds 129 Stamina Recovery"
        },
        {
            name = "Shalidor's Curse",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.EYEVEA,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "Any Mages Guild Portal - Eyevea"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) While you are below 50% Health, light attacks restore 559 Health."
        },
        {
            name = "Shield of the Valiant",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.REDUCE_DAMAGE, Esosets.BREAK_FREE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds Max Health;(3 items) Adds 4% Healing Taken;(4 items) Reduces damage taken from players by 5%.;(5 items) Reduce the cost of Break Free by 40%."
        },
        {
            name = "Sheer Venom",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.POISON_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.IMPERIAL_CITY_PRISON },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Weapon Damage;(5 items) Causing damage with an Execute ability infects the enemy, dealing 1204 Poison Damage every second for 6 seconds. The effect has a cool down of 6 seconds."
        },
        {
            name = "Shroud of the Lich",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.CRYPT_OF_HEARTS_I, Esosets.CRYPT_OF_HEARTS_II },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Once per minute, when below 33% Magicka, gain 1032 Magicka Recovery for 20.0 seconds"
        },
        {
            name = "Silks of the Sun",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVE, Esosets.PVP },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Flame Damage abilities."
        },
        {
            name = "Sithis' Touch",
            bonuses = { Esosets.MAX_HEALTH, Esosets.WEAPON_CRIT, Esosets.BERSERK },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 688 Weapon Critical;(5 items) Using Blade of Woe grants Major Berserk for 6 seconds."
        },
        {
            name = "Shield Breaker",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.DAMAGE_SHIELD },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Weapon Damage;(5 items) Your Light and Heavy Attacks deal 2257 irresistible damage against enemies with a Damage Shield."
        },
        {
            name = "Spawn of Mephala",
            bonuses = { Esosets.MAX_STAMINA },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.FUNGAL_GROTTO_II },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 1096 Max Stamina;(2 items) Fully charged heavy attacks have a 100% chance to create a web for 10 seconds. Web deals 1130 Magic Damage every 1.0 second and reduces Movement Speed by 50%."
        },
        {
            name = "Spectre's Eye",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAX_HEALTH, Esosets.EVASION, Esosets.PHYSICAL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "Coldharbour - Deathspinner's Lair"
            },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1096 Max Magicka ;(4 items) Adds 1206 Max Health;(5 items) Gain Major Evasion for 3 seconds after casting a spell that costs Magicka. This effect can apply once every 6 seconds. Major Evasion increases Dodge chance by 15%."
        },
        {
            name = "SpellPower Cure",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE, Esosets.COURAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            dungeons = { Esosets.WHITE_GOLD_TOWER },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Healing an ally at 100% Health has a 50% chance of granting them Major Courage 258 increased Weapon and Spell Damage for 10 seconds."
        },
        {
            name = "Spider Cultist Cowl",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.FUNGAL_GROTTO_I, Esosets.FUNGAL_GROTTO_II },
            displayText = "(2 items) Adds 1206 Max Health;3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your Destruction Staff abilities."
        },
        {
            name = "Song of Lamae",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.DAMAGE_SHIELD },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.NICHE },
            traits = 5,
            obtained = {
                ad = "Malabal Tor - Sleepy Senche Overlook",
                dc = "Alik'r Desert - Rkulftzel",
                ep = "Eastmarch - Tinkerer Tobin's Workshop",
                zones = { Esosets.MALABAL_TOR, Esosets.ALIKR, Esosets.EASTMARCH }
            },
            displayText = "(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Max Health;(5 items) When Health drops below 30%, deal 5329 Magic Damage to the attacker and recover 3870 Health. This can only happen once every 30 seconds."
        },
        {
            name = "Stendarr's Embrace",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) When you heal a friendly target, you have a 50% chance to remove 5 negative effects from them. This can happen no more than once every 30 seconds."
        },
        {
            name = "Syrabane's Grip",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVP, Esosets.BEGINNER, Esosets.PVE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) When you block a Flame, Frost, Shock or Magic Damage ability, you restore 860 Magicka. This effect can occur once every 1 second."
        },
        {
            name = "Tava's Favor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.STAMINA_REGEN, Esosets.MAGIC_REGEN, Esosets.ULTIMATE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.HEWS_BANE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 5,
            obtained = {
                location = "Hew's Bane - Forebear's Junction"
            },
            displayText = "(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Magicka Recovery;(5 Items) When you dodge an attack you receive the blessing of Tava and gain 9 Ultimate over 3 seconds."
        },
        {
            name = "Thews of the Harbringer",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Spell Damage;(5 items) When you successfully block an attack with no duration, you deal damage to your attacker equal to 4% of your Max Health."
        },
        {
            name = "Torug's Pact",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.REDUCEENCHANT_COOLDOWN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.PVE },
            traits = 2,
            obtained = {
                ad = "Grahtwood - Fisherman's Isle",
                dc = "Stormhaven - Hammerdeath Workshop",
                ep = "Deshaan - Lake Hiaalu Retreat",
                zones = { Esosets.GRAHTWOOD, Esosets.STORMHAVEN, Esosets.DESHAAN }
            },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) Reduce weapon enchantment's internal cooldown by 1 second. Increases enchantment potency by 30%."
        },
        {
            name = "Treasure Hunter",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE, Esosets.PROPHECY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            dungeons = { Esosets.VOLENFELL },
            bestUsedIn = { Esosets.NICHE },
            obtained = {
                location = "Volenfell"
            },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 833 Spell Critical;(4 items) Adds 833 Spell Critical;(5 items) Gain Major Prophecy at all times, increasing your Spell Critical rating by 2191.;(5 items) Adds 100 Spell Damage"
        },
        {
            name = "Trinimac's Valor",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC, Esosets.HEAL, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) 20% chance when you cast a Damage Shield on an ally to call down a fragment of Trinimac that heals allies and damages enemies in the area for 3667. Can only occur once every 3 seconds."
        },
        {
            name = "Trial by Fire",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.HEALING_TAKEN, Esosets.ELEMENTAL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            bestUsedIn = { Esosets.NICHE },
            traits = 3,
            obtained = {
                location = "Wrothgar - Malacath Statue"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 4% Healing Taken;(5 items) When you take elemental damage, gain 7727 Resistance to that element for 4 seconds. You can only be resistant to one element at a time."
        },
        {
            name = "Twice-Born Star",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.MUNDUS },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            traits = 9,
            obtained = {
                location = "Craglorn - Atelier of the Twice-Born Star"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) Allows you to have two Mundus Stone Boons at the same time."
        },
        {
            name = "Twilights Embrace",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.NICHE },
            traits = 3,
            obtained = {
                ad = "Grahtwood - Vineshade Lodge",
                dc = "StormHaven - Windridge Warehouse",
                ep = "Deshaan - Avayan's Farm",
                zones = { Esosets.GRAHTWOOD, Esosets.DESHAAN, Esosets.STORMHAVEN }
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you are healed, gain 10% additional healing."
        },
        {
            name = "Twilights Remedy",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.AEGIS, Esosets.SPELL_DAMAGE, Esosets.FORCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.MAW_OF_LORKAJ },
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            displayText = "(2 Items) Adds 129 Magicka Recovery;(3 Items) Grants Minor Aegis, causing you to take 5% less damage from Boss Monsters.;(4 Items) Adds 129 Spell Damage;(5 Items) When other players activate your synergies they are healed for 18920 over 10 seconds and gain Minor Force, increasing their Critical Strike damage by 12%."
        },
        {
            name = "Twin Sisters",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 126 Stamina Recovery;(3 items) Adds 965 Max Stamina;(4 items) Adds 672 Weapon Critical;(5 items) When Blocking, 20% chance to cause attacker to bleed for 8820 Physical Damage over 8 seconds. Attacker must be within 5m."
        },
        {
            name = "Undaunted Infiltrator",
            bonuses = { Esosets.MAX_MAGIC, Esosets.WEAPON_CRIT, Esosets.HEAVY_ATTACKS },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.SHADOWFEN,
            dungeons = { Esosets.ARX },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 688 Weapon Critical;(5 items) After casting an ability that costs Magicka, Light Attacks deal 774 additional damage and Heavy Attacks deal 1161 additional damage for 10 seconds."
        },
        {
            name = "Valkyn Skoria",
            bonuses = { Esosets.MAX_HEALTH, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.BASE,
            zone = Esosets.GREENSHADE,
            dungeons = { Esosets.CITY_OF_ASH_II },
            shouldersChest = Esosets.GILIRION,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 1206 Max Health;(2 items) 4% chance when damaging an enemy with a damage over time effect to call a meteor dealing 5805 Flame Damage to target and 3076 Flame Damage to other nearby enemies."
        },
        {
            name = "Vampire's Kiss",
            bonuses = { Esosets.HEALTH_REGEN, Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.BEGINNER },
            traits = 5,
            obtained = {
                ad = "Malabal Tor - Matthild's Last Venture",
                dc = "Alik'r Desert - Artisan's Oasisi",
                ep = "Eastmarch - Crimson Kada's Crafting Cavern",
                zones = { Esosets.MALABAL_TOR, Esosets.ALIKR, Esosets.EASTMARCH }
            },
            displayText = "(2 items) Adds 129 Health Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Killing an opponent heals you for 5160 over 6 seconds."
        },
        {
            name = "Vampire Lord",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.SPELL_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) Adds 400 Spell Damage to your Vampire abilities. Reduces the cost of your Vampire abilities by 5%."
        },
        {
            name = "Varen's Legacy",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.HEALING_TAKEN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.DARK_BROTHERHOOD,
            zone = Esosets.GOLD_COAST,
            bestUsedIn = { Esosets.NICHE },
            traits = 7,
            obtained = {
                location = "Gold Coast - Strid River Artisan's Camp"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 4% Healing Taken;(5 items) 10% chance on Block that the next Area of Effect Attack you use will deal an additional 3450 Damage."
        },
        {
            name = "Vengeance Leech",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEAL, Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            obtained = {
                location = "Pvp Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) When you kill an enemy, you heal for 1505 Health and restore 1505 Magicka and Stamina."
        },
        {
            name = "Vestements of the Warlock",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.SELENES_WEB },
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you fall below 33% Magicka, restore 9000 Magicka. This effect can occur once every 1 minute."
        },
        {
            name = "Vicecannon of Venom",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.STAMINA_REGEN, Esosets.POISON_DAMAGE, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.TELVAR_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Your attacks from stealth inject a leeching poison that deals 13936 Poison Damage over 15 seconds and heals you for the damage done."
        },
        {
            name = "Vicious Death",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.SPELL_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 Items) Adds 129 Spell Damage;(3 Items) Adds 1096 Maximum Magicka;(4 Items) Adds 688 Spell Critical;(5 items) When you kill a player they violently explode for 16605 Flame Damage"
        },
        {
            name = "Vicious Serpent",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.REDUCESTAM_COST, Esosets.WEAPON_DAMAGE, Esosets.EXPEDITION },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.HEL_RA, Esosets.ATHERIAN_ARCHIVE, Esosets.SANCTUM },
            dlc = Esosets.BASE,
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) Reduce the cost of Stamina abilities by 8%. When you kill an enemy, you restore 2075 Stamina and gain Major Expedition, increasing your Movement Speed by 30% for 20 seconds.;(5 items) Adds 129 Weapon Damage"
        },
        {
            name = "Ward of Cyrodiil",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.DEFILE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.MEDIUM },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 126 Stamina Recovery;(4 items) Adds 126 Stamina Recovery;(5 items) When you deal melee damage, you apply Major Defile to the enemy for 3 seconds, reducing their healing received and Health Recovery by 30%. This effect can occur once every 5 seconds."
        },
        {
            name = "Way of the Arena",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAX_STAMINA, Esosets.BREAK_FREE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = "Craglorn - Lanista's Waystation"
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Stamina;(5 items) Reduce cost of Break Free by 40%."
        },
        {
            name = "Way of Martial Knowledge",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.BASE,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage, you cause the enemy to take 10% additional damage from the next attack. This effect can occur once every 4 seconds."
        },
        {
            name = "Warrior's Fury",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.CYRODIIL_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Stamina;(4 Items) Adds 129 Weapon Damage;(5 Items) When you take critical damage, your Weapon Damage is increased by 30 for 6 seconds. This effect can stack up to 25 times."
        },
        {
            name = "Willows Path",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN, Esosets.HEALTH_REGEN },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.BEGINNER },
            traits = 6,
            obtained = {
                ad = "Reaper's March - Greenspeaker's Grove",
                dc = "Bangkori - Viridian Hideaway",
                ep = "The Rift - Smokefrost Vigil",
                zones = { Esosets.REAPERS_MARCH, Esosets.BANGKORAI, Esosets.THE_RIFT }
            },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Health Recovery;(5 items) Increase all recovery in combat by 15%."
        },
        {
            name = "Willpower",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.IMPERIAL_CITY,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            obtained = {
                location = "Bone Shards {Memorial}, Dark Ether {Arena}"
            },
            displayText = "(2 items) Adds 1451 Max Magicka;(3 items) Adds 193 Spell Damage"
        },
        {
            name = "Winterborn",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.FROST_DAMAGE },
            hasJewelry = true,
            hasWeapons = false,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ORSINIUM,
            zone = Esosets.WROTHGAR,
            dungeons = { Esosets.MAELSTROM },
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage with a Cold Damage ability, you have an 8% chance to summon an ice pillar that deals 7967 Cold Damage to all enemies in a 3 meter radius. The ice pillar persists for 2 seconds and reduces the Movment Speed of all enemies within the radius by 60%."
        },
        {
            name = "Wise Mage",
            bonuses = { Esosets.SPELL_CRIT, Esosets.VULNERABILITY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            zone = Esosets.CRAGLORN,
            dlc = Esosets.BASE,
            dungeons = { Esosets.SANCTUM },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 833 Spell Critical;(3 items) Adds 833 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Enemies you damage with fully-charged Heavy Attacks are afflicted with Minor Vulnerability for 10 seconds, increasing their damage taken by 8%."
        },
        {
            name = "Whitestrake's Retribution",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.HEALTH_REGEN, Esosets.DAMAGE_SHIELD },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.BASE,
            bestUsedIn = { Esosets.NICHE },
            traits = 4,
            obtained = {
                ad = "Greenshade - Lenalda Pond",
                dc = "Rivenspire - Westwind Lighthouse",
                ep = "Shadowfen Weeping Wamasu Falls",
                zones = { Esosets.GREENSHADE, Esosets.RIVENSPIRE, Esosets.SHADOWFEN }
            },
            displayText = "(2 items) Adds 1206 Max Health ;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 129 Health Recovery;(5 items) If wearers Health is below 30%, gain a 10320 Damage Shield for 8 seconds. This effect can occur no more than once per 15 seconds."
        },
        {
            name = "Wrath of the Imperium",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.SPELL_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = {},
            type = Esosets.ACCESSORY_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CYRODIIL,
            bestUsedIn = { Esosets.NICHE },
            obtained = {
                location = "PVP Rewards/ Vendors"
            },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 833 Spell Critical"
        },
        {
            name = "Worm's Raiment",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.HEALING_TAKEN, Esosets.REDUCEMAGIC_COST },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.BASE,
            zone = Esosets.COLDHARBOUR,
            dungeons = { Esosets.VAULTS_OF_MADNESS },
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 4% Healing Taken;(5 items) Reduce Magicka costs for up to 12 group members by 5%."
        },
        {
            name = "Ysgramor's Birthright",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.FROST_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.THE_RIFT,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Frost Damage abilities."
        },














        --ONEE TAMRIEL SETS
        {
            name = "Netch's Touch",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.DARKSHADE_CAVERNS_I, Esosets.DARKSHADE_CAVERNS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Shock Damage abilities."
        },
        {
            name = "Skooma Smuggler",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE, Esosets.EXPEDITION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you drink a potion, you gain Major Expedition for 30 seconds, increasing your Movement Speed by 30%."
        },
        {
            name = "Spinner's Garment's",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.SPELL_PEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 3450 Spell Penetration"
        },
        {
            name = "Bone Pirate's Tatters",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.BLACKHEART_HAVEN },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) While you have a drink buff active, your Max Stamina is increased by 2000 and Stamina Recovery by 300."
        },
        {
            name = "Draugr Hulk",
            bonuses = { Esosets.MAX_STAMINA },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.DIREFROST_KEEP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;(5 items) Adds 2540 Max Stamina"
        },
        {
            name = "Jailbreaker",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.EXPEDITION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            dungeons = { Esosets.BANISHED_CELLS_I, Esosets.BANISHED_CELLS_II },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) Gain Minor Expedition at all times, increasing your Movement Speed by 10%."
        },
        {
            name = "Leviathan",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.CRYPT_OF_HEARTS_I, Esosets.CRYPT_OF_HEARTS_II },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Adds 1924 Weapon Critical"
        },
        {
            name = "Spelunker",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.SPINDLECLUTCH_I, Esosets.SPINDLECLUTCH_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon and Spell Damage to your Undaunted abilities. When an ally uses one of your Undaunted ability synergies you restore 1500 Stamina."
        },
        {
            name = "Spriggan's Thorns Set",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_PEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 3450 Physical Penetration"
        },
        {
            name = "Strength of the Automaton",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.DARKSHADE_CAVERNS_I, Esosets.DARKSHADE_CAVERNS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon Damage to your Physical Damage abilities."
        },
        {
            name = "Sword Singer",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.ALIKR,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Adds 400 Weapon Damage to your Two Handed abilities."
        },
        {
            name = "Sword Dancer",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.THE_RIFT,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLESSED_CRUCIBLE },
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon Damage to your Dual Wield abilities."
        },
        {
            name = "Toothrow",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.SAVAGERY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.WAYREST_SEWERS_I, Esosets.WAYREST_SEWERS_II },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Gain Major Savagery at all times, increasing your Weapon Critical rating by 2191.;(5 items) Adds 100 Weapon Damage"
        },
        {
            name = "Armor of the Trainee",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            bestUsedIn = { Esosets.BEGINNER },
            obtained = {
                ad = Esosets.KHENARTHIS_ROOST,
                dc = Esosets.STROS_MKAI .. " " .. Esosets.BETNIKH,
                ep = Esosets.BAL_FOYEN,
                location = "Starter Islands",
                zones = { Esosets.BAL_FOYEN, Esosets.BLEAKROCK, Esosets.KHENARTHIS_ROOST, Esosets.STROS_MKAI, Esosets.BETNIKH }
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Stamina;(5 items) Increases your Max Health, Magicka and Stamina by 1250."
        },
        {
            name = "Beekeeper's Gear",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALTH_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 129 Health Recovery;(5 items) Adds 400 Health Recovery"
        },
        {
            name = "Green Pact",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALTH_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 1206 Max Health;(5 items) While you have a food buff active, your Max Health is increased by 2500 and Health Recovery by 250."
        },
        {
            name = "Knight Errants Mail",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.BLACKHEART_HAVEN },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 200 Weapon Damage to your One Hand and Shield abilities. When you use a One Hand and Shield ability, you heal for 1250 Health."
        },
        {
            name = "Medusa",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.FORCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            dungeons = { Esosets.ARX },
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Gain Minor Force at all times, increasing your Critical Damage by 12%."
        },
        {
            name = "Order of Diagna",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.VITALITY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.ALIKR,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Gain Minor Vitality at all times, increasing your healing received by 8%."
        },
        {
            name = "Plague Doctor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(2 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Adds 4000 Max Health"
        },
        {
            name = "Rattlecage",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.SORCERY },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.COLDHARBOUR,
            dungeons = { Esosets.VAULTS_OF_MADNESS },
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) Gain Major Sorcery at all times, increasing your Spell Damage by 20%.;(5 items) Adds 100 Spell Damage."
        },
        {
            name = "Shalk Exoskeleton",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.ULTIMATE, Esosets.HEROISM },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) Gain Minor Heroism at all times while in combat, generating 1.5 Ultimate every 1 seconds."
        },
        {
            name = "Vampire Cloak",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.PROTECTION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1206 Max Health;(5 items) Gain Minor Protection at all times, reducing your damage taken by 8%."
        },
        {
            name = "Chokethorn",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.ELDEN_HOLLOW_I },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 129 Magicka Recovery;(2 items) When you use a heal ability, you have a 15% chance to summon a strangler sapling that heals you or an ally for 19565 Health over 4 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Grothdar",
            bonuses = { Esosets.MAX_MAGIC, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.VAULTS_OF_MADNESS },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 1096 Max Magicka;(2 items) When you deal damage, you have a 10% chance to create lava pools that swirl around you, dealing 2000 Flame Damage to all enemies within 8 meters of you every 1 second for 5 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Iceheart",
            bonuses = { Esosets.SPELL_CRIT, Esosets.FROST_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.DIREFROST_KEEP },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 688 Spell Critical;(2 items) When you deal Critical Damage, you have a 20% chance to gain a damage shield that absorbs 8600 damage for 6 seconds. While the damage shield holds, you deal 770 Frost Damage to all enemies within 5 meters of you every 1 second. This effect can occur once every 6 seconds."
        },
        {
            name = "Ilambris",
            bonuses = { Esosets.MAX_MAGIC, Esosets.FLAME_DAMAGE, Esosets.SHOCK_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.CRYPT_OF_HEARTS_I },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 1096 Max Magicka;(2 items) When you deal Flame or Shock Damage, you have a 10% chance to summon a meteor shower of the damage type that deals 1300 Damage to all enemies within 4 meteres every 1 seconds for 5 seconds. Each effect can occur once every 8 seconds."
        },
        {
            name = "Infernal Gaurdian",
            bonuses = { Esosets.MAX_MAGIC, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.CITY_OF_ASH_I },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 1096 Max Magicka;(2 items) When you use a damage shield ability, you have a 50% chance to lob 3 mortars over 2 seconds at the further enemy from you that each deal 5500 Flame Damage to all enemies within 5 meters of the blast area. This effect can occur once every 6 seconds."
        },
        {
            name = "Kra'gh",
            bonuses = { Esosets.PHYSICAL_PEN, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.FUNGAL_GROTTO_I },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 1935 Physical Penetration;(2 items) When you deal damage, you have a 10% chance to spawn dreugh limbs that create shockwaves in front of you dealing 1300 Physical Damage every 0.4 seconds for 1.2 seconds. This effect can occur once every 3 seconds."
        },
        {
            name = "Mighty Chudan",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.WARD, Esosets.RESOLVE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.RUINS_OF_MAZZ },
            shouldersChest = Esosets.URG,
            obtained = {
                location = "Ruins of Mazzutun / Urgalarg Chief-bane"
            },
            displayText = "(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) Gain Major Ward and Major Resolve at all times, increasing your Physical and Spell Resistance by 5280.;(2 items) Adds 1206 Max Health"
        },

        {
            name = "Pirate Skeleton",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.PROTECTION, Esosets.DEFILE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.BLACKHEART_HAVEN },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) When you take damage, you have a 6% chance to transform into a skeleton and gain Major Protection and Minor Defile for 12 seconds, reducing your damage taken by 30% but reducing your healing received by 15%. This effect can occur once every 15 seconds."
        },
        {
            name = "Selene",
            bonuses = { Esosets.MAX_STAMINA, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.SELENES_WEB },
            shouldersChest = Esosets.GILIRION,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(1 items) Adds 1096 Max Stamina;(2 items) When you deal direct melee damage, you have a 15% chance to call on a primal spirit that mauls the closest enemy in front of you for 12000 Physical Damage. This effect can occur once every 4 seconds."
        },
        {
            name = "Sellistrix",
            bonuses = { Esosets.MAX_STAMINA, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            dungeons = { Esosets.ARX },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 1096 Max Stamina;(2 items) When you deal damage, you have a 10% chance to create an earthquake under the enemy that errupts after 2 seconds, dealing 3870 Physical Damage to all enemies within 4 meters and stunning them for 3 seconds. This effect can occur once every 5 seconds."
        },
        {
            name = "Sentinel of Rkugamz",
            bonuses = { Esosets.HEAL, Esosets.STAMINA_REGEN },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.DESHAAN,
            dungeons = { Esosets.DARKSHADE_CAVERNS_I },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target, you have a 10% chance to summon a dwemer spider that heals for 1049 Health and restores 524 Stamina to you and your allies within 5 meters every 1 second for 8 seconds. This effect can occur once every 8 seconds."
        },
        {
            name = "Shadowrend",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.MAGIC_DAMAGE, Esosets.MAIM },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.AURIDON,
            dungeons = { Esosets.BANISHED_CELLS_I },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 129 Magica Recovery;(2 items) When you deal damage, you have a 15% chance to summon a shadowy Clanfear for 15 seconds. The Clanfear's basic attack deals 3440 Magic Damage and apply Minor Maim to any enemy hit for 10 seconds, reducing their damage done by 15%. This effect can occur once every 15 seconds."
        },
        {
            name = "Slimecraw",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.SPELL_CRIT, Esosets.BERSERK },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STORMHAVEN,
            dungeons = { Esosets.WAYREST_SEWERS_I },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.MAJ_AL,
            displayText = "(1 items) Adds 833 Weapon Critical;(1 items) Adds 833 Spell Critical;(2 items) Gain Minor Berserk at all times, increasing your damage done by 8%."
        },
        {
            name = "Stormfist",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.SHOCK_DAMAGE, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            dungeons = { Esosets.TEMPEST_ISLAND },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 129 Stamina Recovery;(2 items) When you deal damage, you have a 10% chance to create a thunderfist to crush the enemy, dealing 1500 Shock Damage every 1 second for 3 seconds to all enemies within 4 meters and a final 8000 Physical Damage when the fist closes. This effect can occur once every 8 seconds."
        },
        {
            name = "Swarm Mother",
            bonuses = { Esosets.STAMINA_REGEN },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.SPINDLECLUTCH_I },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 129 Stamina Recovery;(2 items) When you block an attack from an enemy that is further than 5 meters from you, you spin strands of spider silk to pull the enemy to you. This effect can occur once every 2 seconds."
        },
        {
            name = "Tremorscale",
            bonuses = { Esosets.MAX_STAMINA, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            dungeons = { Esosets.VOLENFELL },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 1096 Max Stamina;(2 items) When you taunt an enemy, you have a 50% chance to cause a duneripper to burst from the ground beneath them, dealing 6500 Physical Damage to all enemies within 4 meters and reducing their Movement Speed by 70% for 8 seconds. This effect can occur once every 4 seconds."
        },
        {
            name = "Troll King",
            bonuses = { Esosets.HEALTH_REGEN, Esosets.HEAL },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.THE_RIFT,
            dungeons = { Esosets.BLESSED_CRUCIBLE },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.GILIRION,
            displayText = "(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target, if they are still below 60% Health, their Health Recovery is increased by 1548 for 10 seconds."
        },
        {
            name = "Velidreth",
            bonuses = { Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            dungeons = { Esosets.CRADLE_OF_SHADOWS },
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            shouldersChest = Esosets.URG,
            displayText = "(1 items) Adds 129 Weapon Damage;(2 items) When you deal damage, you have a 20% chance to spawn 3 disease spores in front of you that deal 10320 Disease Damage to the first enemy hit. This effect can occur once every 9 seconds."
        },
        {
            name = "Defending Warrior",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.MAGIC_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.ATHERIAN_ARCHIVE },
            displayText = "(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Maximum Health;(5 items) When you block an attack, you deal 4000 Magic Damage to all enemies within 10 meters of you and heal for 100% of the damage done. This effect can occur once every 10 seconds."
        },
        {
            name = "Healing Mage",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.ATHERIAN_ARCHIVE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 2% Healing Done;(5 items) When you use an area of effect heal ability, you reduce the Weapon Damage of all enemies within 10 meters of you by 430 for 3 seconds."
        },
        {
            name = "Quick Serpent",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.REDUCE_COST, Esosets.EXPEDITION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.ATHERIAN_ARCHIVE },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;(5 items) Reduces the cost of Stamina abilities by 8%. When you kill an enemy, you gain Major Expedition for 20 seconds, increasing your Movement Speed by 30%."
        },
        {
            name = "Twice-Fanged Serpent",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_PEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.SANCTUM },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage, your Physical Penetration is increased by 860 for 3 seconds, stacking up to 5 times."
        },
        {
            name = "Immortal Warrior",
            bonuses = { Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.RESURRECTION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.SANCTUM },
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you die, you instead turn into a statue for 3 seconds. While a statue, you are immune to all negative effects, but can still be healed. This effect can occur once every 20 minutes."
        },
        {
            name = "Poisonous Serpent",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.HEL_RA },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Max Stamina;(5 items) When you deal damage with a Light or Heavy Attack against an enemy who has a Poison Damage ability on them, you have a 50% chance to deal an additional 3400 Poison Damage."
        },
        {
            name = "Berserking Warrior",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            dungeons = { Esosets.HEL_RA },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) When you deal melee damage, your Critical Strike rating is increased by 400 for 5 seconds, stacking up to 5 times."
        },
        {
            name = "Tormentor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE, Esosets.TAUNT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.AURIDON,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BANISHED_CELLS_I, Esosets.BANISHED_CELLS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 4% Healing Taken;(5 items) When you deal damage with a Charge ability,you gain 3642 Physical and Spell Resistance and taunt the enemy to attack you for 15 seconds."
        },
        {
            name = "Undaunted Unweaver",
            bonuses = { Esosets.MAX_STAMINA, Esosets.SPELL_CRIT, Esosets.HEAVY_ATTACKS },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLACKHEART_HAVEN },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Spell Critical;(5 items) When you use an ability that costs Stamina, your Light Attacks deal an additional 774 damage and Heavy Attacks deal an additional 1161 damage for 10 seconds."
        },
        {
            name = "Nikula's Heavy Armor",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.MAX_HEALTH },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.THE_RIFT,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLESSED_CRUCIBLE },
            displayText = "(2 items) Adds 1822 Spell Resistance;(3 items) Adds 1822 Spell Resistance;(4 items) Adds 1002 Max Health;(5 items) Blocking Projectile Spells has a 25% chance of Reflecting the spell on its caster."
        },
        {
            name = "Sunderflame",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.FLAME_DAMAGE, Esosets.REDUCEPHYSICAL_RESISTANCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.CITY_OF_ASH_I, Esosets.CITY_OF_ASH_II },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) When you hit an enemy with a fully charged Heavy Attack, deal 4000 Flame Damage and applies Minor Breach and Minor Fracture to the enemy reduce target’s Physical and Spell Resistance by 1320 for 8 seconds."
        },
        {
            name = "Embershield",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.FLAME_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.CITY_OF_ASH_I, Esosets.CITY_OF_ASH_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) When you deal damage with a fully-charged Heavy Attack, you have a 50% chance to increase your Spell Resistance by 3440 and deal 1032 Flame Damage to all enemies within 5 meters every 1 second for 6 seconds."
        },
        {
            name = "Ebon Armory",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.RIVENSPIRE,
            bestUsedIn = { Esosets.PVP, Esosets.PVP },
            dungeons = { Esosets.CRYPT_OF_HEARTS_I, Esosets.CRYPT_OF_HEARTS_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Increase Max Health of up to 12 group members by 1118."
        },
        {
            name = "Armor of Truth",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.DESHAAN,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.DARKSHADE_CAVERNS_I, Esosets.DARKSHADE_CAVERNS_II },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you set an enemy off-balance, your Weapon Damage is increased by 450 for 10 seconds."
        },
        {
            name = "Ice Furnace",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.WEAPON_DAMAGE, Esosets.FLAME_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.DIREFROST_KEEP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal direct damage with a Frost Damage ability, you have a 50% chance to deal an additional 1046 Flame Damage to all enemies within 8 meters around the initial target. This effect can occur once every 1 second."
        },
        {
            name = "Robes of Destruction Mastery",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.DSA },
            displayText = "(2 items) Adds 969 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) While you have a Destruction Staff equipped, your Max Magicka is increased by 2400."
        },
        {
            name = "Archer's Mind",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.DSA },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Increases your Critical Damage done by 5%. Increases your Critical Damage done by an additional 10% when attacking from Sneak or invisibility."
        },
        {
            name = "Footmans Fortune",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.DSA },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) Increase block mitigation by 8%."
        },
        {
            name = "Undaunted Bastion",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.TAUNT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.ELDEN_HOLLOW_I, Esosets.ELDEN_HOLLOW_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) When you taunt an enemy while you are under 60% Health, gain a damage shield that absorbs 13760 damage for 6 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Barkskin",
            bonuses = { Esosets.MAX_HEALTH, Esosets.STAMINA_REGEN, Esosets.PHYSICAL_RESISTANCE, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVE, Esosets.BEGINNER },
            dungeons = { Esosets.ELDEN_HOLLOW_I, Esosets.ELDEN_HOLLOW_II },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1935 Physical Resistance;(5 items) Reduces the duration of immobilizations and snares on you by 50%. When an immobilization or snare is applied to you, heal for 2000 Health and restore 1000 Stamina. This effect can occur once every 5 seconds."
        },
        {
            name = "Viper's Sting",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.MAX_STAMINA, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GRAHTWOOD,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.FUNGAL_GROTTO_I, Esosets.FUNGAL_GROTTO_II },
            displayText = "(2 items) Adds 672 Weapon Critical;(3 items) Adds 965 Max Stamina;(4 items) Adds 672 Weapon Critical;(5 items) Your Melee Attacks deal 6720 Poison damage over 4 seconds."
        },
        {
            name = "Hircine's Veneer",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN, Esosets.REDUCE_STAM_COST },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.SELENES_WEB },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost of all Stamina abilities by 4% for your and your group"
        },
        {
            name = "Durok's Bane",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.HEALTH_REGEN, Esosets.DEFILE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.SELENES_WEB },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 4% Healing Taken;(5 items) When you take damage, you apply Major Defile to the attacker for 4 seconds, reducing their healing received and Health Recovery by 30%. This effect can occur once every 8 seconds per enemy."
        },
        {
            name = "Storm Master",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.SHOCK_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.TEMPEST_ISLAND },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal Critical Damage with a fully charged Heavy Attack, your Light Attacks deal additional 1333 Shock Damage for 20 seconds."
        },
        {
            name = "Jolting Arms",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.SHOCK_DAMAGE, Esosets.SPELL_RESISTANCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.TEMPEST_ISLAND },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) When you block an attack, you have a 50% chance to charge your arms, causing your next Bash attack to deal 5805 Shock Damage as well as granting yourself 6450 Spell Resistance for 6 seconds."
        },
        {
            name = "Oblivion's Edge",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.VAULTS_OF_MADNESS },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) When killing an enemy, fill an empty Soul Gem and heal self for 1720;(5 items) Adds 129 Weapon Damage"
        },
        {
            name = "Syvarra's Scales",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.REDUCE_DAMAGE, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.THIEVES_GUILD,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            zone = Esosets.HEWS_BANE,
            displayText = "(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Stamina;(3 Items) Reduces your damage taken from guards by 20%;(4 Items) Adds 1096 Maximum Magicka;(5 Items) When you deal damage, you have a 5% chance to cause a burst of lamia poison that deals 1096 Poison Damage in a 5 meter radius and an additional 5802 Poison Damage over 6 seconds to all enemies hit. This effect can occur once every 6.5 seconds."
        },
        {
            name = "Armor of the Veiled Heritance",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_RESISTANCE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            bestUsedIn = { Esosets.BEGINNER },
            zone = Esosets.AURIDON,
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage, you have a 10% to increase your Weapon Damage by 400 for 5 seconds."
        },
        {
            name = "Seventh Legion Brute",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.HEALTH_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.BANGKORAI,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Health Recovery;(4 items) Adds 688 Weapon Critical;(5 items) When you take damage, you have a 10% chance to gain 500 Weapon Damage for 5 seconds and heal for 1260 Health."
        },
        {
            name = "Stygian",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.MAX_STAMINA },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) While you are Sneaking or invisible, your Spell Damage and Max Magicka is increased by 20%."
        },
        {
            name = "Meridia's Blessed Armor",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.COLDHARBOUR,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1935 Spell Resistance;(5 items) When you block an attack, you have a 33% chance to blind your attacker, causing them to miss all of their attacks for 5 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Way of Air",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.SPELL_DAMAGE, Esosets.DODGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.IMPERIAL_CITY,
            zone = Esosets.CRAGLORN,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 126 Stamina Recovery;(3 items) Adds 126 Stamina Recovery;(4 items) Increases stealth detection radius by 2 meters;(5 items) When you use Roll Dodge, your Weapon and Spell Damage is increased by 344 for 6 seconds."
        },
        {
            name = "Way of Fire",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.FLAME_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.IMPERIAL_CITY,
            bestUsedIn = { Esosets.NICHE },
            zone = Esosets.CRAGLORN,
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage with a Weapon ability, you have a 20% chance to deal an additional 4000 Flame Damage. This effect can occur once every 2 seconds."
        },
        {
            name = "Fiord's Legacy",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            bestUsedIn = { Esosets.NICHE },
            zone = Esosets.EASTMARCH,
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost and increases the Movement Speed bonus of Sprint by 15%."
        },
        {
            name = "Akaviri Dragonguard",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.ULTIMATE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.EASTMARCH,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) Reduces the cost of Ultimate abilities by 15%."
        },
        {
            name = "Hide of the Werewolf",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.WEAPON_DAMAGE, Esosets.ULTIMATE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you take damage, you generate 5 Ultimate. This effect can occur once every 5 seconds."
        },
        {
            name = "Wyrd Tree's Blessing",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GLENUMBRA,
            bestUsedIn = { Esosets.PVP, Esosets.BEGINNER },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) Casting a spell has a 100% chance to remove 5 negative effect, this can occur every 15 seconds."
        },
        {
            name = "Ranger's Gait",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            bestUsedIn = { Esosets.NICHE },
            zone = Esosets.GRAHTWOOD,
            displayText = "(2 items) Adds 121 Stamina Recovery;(3 items) Adds 648 Weapon Critical;(4 items) Adds 911 Max Stamina;(5 items) Reduce the effectiveness of snares applied to you by 50%;(5 items) Adds 121 Stamina Recovery"
        },
        {
            name = "Wilderqueen's Arch",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.BOW },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.GREENSHADE,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) Bow attacks snare the target reducing their movement speed by 30% for 3 seconds."
        },
        {
            name = "Bahraha's Curse",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAX_STAMINA, Esosets.REDUCE_DAMAGE, Esosets.MAGIC_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.THIEVES_GUILD,
            zone = Esosets.HEWS_BANE,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            displayText = "(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Magicka;(4 Items) Take 40% less damage from traps;(4 Items) Adds 1096 Maximum Stamina;(5 Items) When you deal damage, you have a 25% chance to create desecrated ground for 5 seconds, which reduces the Movment Speed of enemies within by 70%, damages them for 1138 Magic Damage every 1 second and heals you for 100% of the damage done."
        },
        {
            name = "Salvation",
            bonuses = { Esosets.MAX_STAMINA, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) Savior's Hide Reduces cost of Werewolf Transformation by 33%. While in werewolf form Weapon Damage is increased by 150."
        },
        {
            name = "Thunderbug's Carapace",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.SPELL_DAMAGE, Esosets.SHOCK_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.MALABAL_TOR,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 129 Spell Damage;(5 items) When you take Physical Damage, you have a 50% chance to deal 5160 Shock Damage in a 5 meter radius around you. This effect can occur once every 3 seconds."
        },
        {
            name = "Soulshine",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your cast time and channeled abilities."
        },
        {
            name = "Senche's Bite",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.REAPERS_MARCH,
            bestUsedIn = { Esosets.PVP },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 688 Weapon Critical;(4 items) Adds 1096 Max Stamina;(5 items) When you use Roll Dodge, your Weapon Damage is increased by 420 and Weapon Critical by 657 for 5 seconds."
        },
        {
            name = "Swamp Raider",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Max Stamina;(5 items) Adds 400 Weapon Damage to your Poison and Disease Damage abilities."
        },
        {
            name = "Hatchling's Shell",
            bonuses = { Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1206 Max Health;(5 items)  Gain a damage shield equal to 20% of your Max Health for 15 seconds every 15 seconds."
        },
        {
            name = "Shadow of the Red Mountain",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.FLAME_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STONEFALLS,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage with a Weapon ability, you have a 10% chance to deal an additional 8400 Flame Damage. This effect can occur once every 2 seconds."
        },
        {
            name = "Dreamer's Mantle",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Magicka;(5 items) When you take damage while you are under 35% Health, you knockdown all enemies within 4 meters of you for 2 seconds and heal for 7000 Health. This effect can occur once every 20 seconds."
        },
        {
            name = "Night Terror",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Reduces the radius you can be detected while Sneaking by 2 meters. Reduces the cost of Sneak cost by 26%;(4 items) Adds 1206 Max Health;(5 items) When you take melee damage, you deal 2000 Poison Damage to the attacker. This effect can occur once every 1 second."
        },
        {
            name = "Storm Knight's Plate",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.SHOCK_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            zone = Esosets.STORMHAVEN,
            bestUsedIn = { Esosets.NICHE },
            displayText = "(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1206 Max Health;(5 items) When you take non-physical damage, you have a 10% chance to deal 4374 Shock Damage all to all enemies within 5 meters of you every 2 seconds for 6 seconds. This effect can occur once every 6 seconds."
        },
        {
            name = "Witchman Armor",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.WEAPON_DAMAGE, Esosets.MAX_HEALTH, Esosets.ULTIMATE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.ONE_TAMRIEL,
            bestUsedIn = { Esosets.NICHE },
            zone = Esosets.THE_RIFT,
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1206 Max Health;(5 items) When you use an Ultimate ability, you heal for 30 Health and you restore 30 Stamina per point of the Ultimate's cost."
        },















        --SHADOWSEsosets.OF THEEsosets.HIST,
        {
            name = "Amber Plasm",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE, Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.RUINS_OF_MAZZ },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Adds 250 Stamina Recovery;(5 items) Adds 250 Magicka Recovery"
        },
        {
            name = "Gossamer",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.EVASION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.PVP },
            dungeons = { Esosets.CRADLE_OF_SHADOWS },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) When you heal a friendly target, you have a 10% chance to grant them Major Evasion, for 6 seconds, increaseing their dodge chance by 15%."
        },
        {
            name = "Heem-Jas' Retribution",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.BERSERK },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            dungeons = { Esosets.RUINS_OF_MAZZ },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When an enemy within 28 meters of you dies, you gain Major Berserk, increasing your damage done by 25% for 3 seconds."
        },
        {
            name = "Widowmaker",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.CRADLE_OF_SHADOWS },
            displayText = "(2 items) Adds 688 Weapon Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 1096 Max Stamina;(5 items) When your alchemical poison fires, deal 7740 Poison Damage to all enemies within 5 meters of you."
        },
        {
            name = "Aspect of Mazzatun",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.RUINS_OF_MAZZ },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) When you fall below 30%  Health, heal for 7052 Health and gain 6020 Magicka and Stamina. This effect can occur once every 45 seconds."
        },
        {
            name = "Hand of Mephala",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.PHYSICAL_RESISTANCE, Esosets.POISON_DAMAGE, Esosets.FRACTURE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.SHADOWSOFTHE_HIST,
            zone = Esosets.SHADOWFEN,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.CRADLE_OF_SHADOWS },
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Physical Resistance;(5 items) When you take damage, you have a 10% chance to cast a web around you for 5 seconds, reducing the Movement Speed of enemies within by 50%. After 5 seconds  the web bursts in to venom, dealing 2580 Poison Damage and applying Minor Fracture to any enemy hit for 5 seconds, reducing their Physical Resistance by 1320."
        },















        --Esosets.MORROWIND,
        {
            name = "Defiler",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.WEAPON_CRIT, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVE, Esosets.PVP },
            zone = Esosets.VVARDENFELL,
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) When you deal Critical Damage, you have an {8%} chance to summon a Hunger that spews poison to all enemies in front of it, dealing {9999} Poison Damage and stunning enemies hit for 5 seconds. This effect can occur once every 5 seconds."
        },
        {
            name = "War Maiden",
            bonuses = { Esosets.SPELL_CRIT, Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP },
            zone = Esosets.VVARDENFELL,
            displayText = "(2 items) Adds 688 Spell Critical;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Magic Damage abilities"
        },
        {
            name = "Warrior Poet",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE, Esosets.TOUGHNESS },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.VVARDENFELL,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 2??? Spell Resistance;(4 items) Adds 2??? Physical Resistance;(5 items) Gain Minor Toughness at all times, increasing your Max Health by 10%."
        },
        {
            name = "Assassin's Guile",
            bonuses = { Esosets.SPELL_CRIT, Esosets.WEAPON_CRIT, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.MORROWIND,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            traits = 3,
            obtained = {
                location = Esosets.VVARDENFELL
            },
            displayText = "(2 items) Adds 688 Spell Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Spell Damage and Weapon Damage;(5 items) Increases the duration of your alchemical poisons by 4 seconds."
        },
        {
            name = "Shacklebreaker",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE, Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            zone = Esosets.VVARDENFELL,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP },
            traits = 6,
            obtained = {
                location = Esosets.VVARDENFELL
            },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery and Stamina Recovery;(5 items) Adds 2000 Max Magicka and Max Stamina."
        },
        {
            name = "Daedric Trickery",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.EXPEDITION, Esosets.MENDING, Esosets.PROTECTION, Esosets.HEROISM, Esosets.VITALITY },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.MORROWIND,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            traits = 8,
            obtained = {
                location = Esosets.VVARDENFELL
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) While in combat you gain one of 5 random Major Buffs for 10 seconds every 20 seconds. Eligible buffs are Expedition, Protection, Mending, Heroism, or Vitality."
        },
        {
            name = "Coward's Gear",
            bonuses = { Esosets.MAX_HEALTH, Esosets.STAMINA_REGEN, Esosets.EXPEDITION, Esosets.PROTECTION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.BATTLEGROUNDS_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVE, Esosets.NICHE },
            zone = Esosets.BATTLE_GROUNDS,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) While Sprinting you gain Major Expedition and Major Protection, increasing your Movement Speed by 20% and reducing your damage taken by 30%."
        },
        {
            name = "Knight Slayer",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.OBLIVION_DAMAGE, Esosets.HEAVY_ATTACKS },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.BATTLEGROUNDS_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            zone = Esosets.BATTLE_GROUNDS,
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1206 Max Health;(5 items) Your fully-charged Heavy Attacks against Players deal and additional 10% of their Max Health as Oblivion Damage."
        },
        {
            name = "Impregnable Armor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAX_MAGIC, Esosets.MAX_STAMINA, Esosets.CRIT_RESIST },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.BATTLEGROUNDS_SET,
            zone = Esosets.BATTLE_GROUNDS,
            bestUsedIn = { Esosets.PVP },
            dlc = Esosets.MORROWIND,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) Adds 2500 Critical Resistance."
        },
        {
            name = "Vanguard’s Challenge",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALING_TAKEN, Esosets.TAUNT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.BATTLEGROUNDS_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.NICHE },
            zone = Esosets.BATTLE_GROUNDS,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you taunt an enemy Player, they deal 50% less damage to all other Players but 100% more damage to you for 15 seconds."
        },
        {
            name = "Wizard’s Riposte",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.MAGIC_REGEN, Esosets.MAIM },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.BATTLE_GROUNDS,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP },
            zone = Esosets.VVARDENFELL,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) When you take Critical Damage, you apply Minor Maim to the enemy for 5 seconds, reducing their damage done by 15%"
        },
        {
            name = "Automated Defense",
            bonuses = { Esosets.MAX_HEALTH, Esosets.AEGIS, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            zone = Esosets.VVARDENFELL,
            dungeons = { Esosets.HALLS_OF_FABRICATION },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Gain Minor Aegis at all times;(4 items) Adds 4% Healing Taken;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Aegis for 10 seconds, reducing your damage taken from Dungeons and Trials Monsters by 15%"
        },
        {
            name = "Inventor's Gaurd",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.AEGIS, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            zone = Esosets.VVARDENFELL,
            dungeons = { Esosets.HALLS_OF_FABRICATION },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Gain Minor Aegis at all times;(4 items) Adds 2% Healing Done;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Aegis for 10 seconds, reducing your damage taken from Dungeons and Trials Monsters by 15%."
        },
        {
            name = "Master Architect",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SLAYER, Esosets.SPELL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.MORROWIND,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.PVE },
            dungeons = { Esosets.HALLS_OF_FABRICATION },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Gain Minor Slayer at all times;(4 items) Adds 129 Spell Damage;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Slayer for 10 seconds, increasing your damage done to Dungeons and Trials Monsters by 15%."
        },
        {
            name = "War Machine",
            bonuses = { Esosets.MAX_STAMINA, Esosets.SLAYER, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.MORROWIND,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.VVARDENFELL,
            dungeons = { Esosets.HALLS_OF_FABRICATION },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Gain Minor Slayer at all times;(4 items) Adds 129 Weapon Damage;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Slayer for 10 seconds, increasing your damage done to Dungeons and Trials Monsters by 15%."
        },








        --Esosets.HORNS OFEsosets.THE REACH ,
        {
            name = "Draugr’s Rest",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            dungeons = { Esosets.FALKREATH_HOLD },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 2% Healing Done;(5 items) When you deal damage with a fully-charged Heavy Attack, you create a circle of consecrated ground that heals you and your allies within 5 meters for 11,000 Health over 10 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Pillar of Nirn",
            bonuses = { Esosets.MAX_STAMINA, Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE, Esosets.BLEED },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.FALKREATH_HOLD },
            displayText = "(2 items) Adds 1096 Max Stamina;(3 items) Adds 833 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal damage, you have a 10% chance to create a fissure underneath the enemy after 1 second, dealing 2,000 Physical Damage to all enemies within 2.5 meters and causing them to bleed for an additional 8,000 Physical Damage over 10 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Ironblood",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE, Esosets.PROTECTION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.FALKREATH_HOLD },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 2975 Physical Resistance;(4 items) Adds 2975 Spell Resistance;(5 items) When you take damage, you have an 8% chance to turn your blood into pure iron and gain Major Protection for 10 seconds, reducing your damage taken by 30%, but your Movement Speed is reduced by 50%. This effect can occur once every 15 seconds."
        },
        {
            name = "Domihaus",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.FLAME_DAMAGE, Esosets.PHYSICAL_DAMAGE, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            shouldersChest = Esosets.URG,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.FALKREATH_HOLD },
            displayText = "(1 items) 1096 Max Stamina;(1 items) 1096 Max Magicka;(2 items) When you deal damage, you have a 15% chance to create either a ring of fire or a ring of molten earth around you for 10 seconds, which deals 1,000 Flame Damage or 1,000 Physical Damage every 1 second. Standing within the ring grants you 200 Spell Damage or 200 Weapon Damage. This effect can occur once every 15 seconds."
        },
        {
            name = "Flame Blossom",
            bonuses = { Esosets.MAX_MAGIC, Esosets.SPELL_DAMAGE, Esosets.SPELL_PEN, Esosets.FLAME_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLOODROOT_FORGE },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1487 Spell Penetration;(5 items) When you deal damage, you have a 10% chance to summon a line of flame that moves forward, dealing 8,000 Flame Damage to any enemy in its path. This effect can occur once every 10 seconds."
        },
        {
            name = "Blooddrinker",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.BLEED },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLOODROOT_FORGE },
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 833 Weapon Critical;(5) Increases the damage you deal with bleed damage over time effects by 20%."
        },
        {
            name = "Hagraven’s Garden",
            bonuses = { Esosets.MAX_HEALTH, Esosets.HEALTH_REGEN, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.NICHE },
            dungeons = { Esosets.BLOODROOT_FORGE },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 4% Healing Taken;(5 items) When you take damage while under 50% Health, you summon a preservation of nature around you for 5 seconds. Any damage you take from enemies outside of the preservation is reduced by 50%, and the first time an enemy tries to enter the preservation they are knocked back 5 meters. This effect can occur once every 45 seconds."
        },
        {
            name = "Earthgore",
            bonuses = { Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            shouldersChest = Esosets.URG,
            dlc = Esosets.HORNS_OF_THE_REACH,
            zone = Esosets.VVARDENFELL,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            dungeons = { Esosets.BLOODROOT_FORGE },
            displayText = "(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target that is under 50% Health you conjure a pool of quenching blood underneath them, which soaks up 1 enemy  placed effect instantly and heals all friendly targets in the area for 30000 Health over 6 seconds. This effect can occur once every 35 seconds."
        },






        --CLOCKWORKEsosets.CITY 
        {
            name = "Mad Tinkerer",
            bonuses = { Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE, Esosets.SHOCK_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.CLOCKWORKCITY,
            zone = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 833 Spell Critical;(3 items) Adds 833 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage, you have a 10% chance to summon a Verminous Fabricant that charges the nearest enemy, dealing 10,000 Shock Damage to all enemies in its path, knocking them into the air, and stunning them for 2 seconds. This effect can occur once every 10 seconds."
        },
        {
            name = "Unfathomable Darkness",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.PHYSICAL_PEN, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.CLOCKWORKCITY,
            zone = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVE },
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Adds 1487 Physical Penetration;(4 items) Adds 129 Weapon Damage;(5 items) When you deal damage, you have a 10% chance to call a murder of crows around you for 12 seconds. Every 3 seconds a crow will be sent to peck the closest enemy within 12 meters of you, dealing 4000 Physical Damage. This effect can occur once every 15 seconds."
        },
        {
            name = "Livewire",
            bonuses = { Esosets.HEALING_TAKEN, Esosets.MAX_HEALTH, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            zone = Esosets.CLOCKWORKCITY,
            displayText = "(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you take damage, you have a 25% chance to overload your circuits, applying Concussion to enemies within 8 meters of you and healing for 1000 Health for each enemy hit. This effect can occur once every 10 seconds."
        },

        {
            name = "Innate Axiom",
            bonuses = { Esosets.MAX_STAMINA, Esosets.MAX_MAGIC, Esosets.SPELL_CRIT, Esosets.WEAPON_CRIT, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.CLOCKWORKCITY,
            zone = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVP },
            traits = 2,
            obtained = {
                location = "The Refurbishing Yard - " .. Esosets.CLOCKWORKCITY
            },
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Stamina;(4 items) Adds 833 Spell Critical and 833 Weapon Critical.;(5 items) Adds 400 Spell and Weapon Damage to your Class abilities."
        },
        {
            name = "Fortified Brass",
            bonuses = { Esosets.MAX_HEALTH, Esosets.PHYSICAL_RESISTANCE, Esosets.SPELL_RESISTANCE },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.CLOCKWORKCITY,
            zone = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVP },
            traits = 4,
            obtained = {
                location = "Restricted Brassworks - " .. Esosets.CLOCKWORKCITY
            },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 2975 Physical Resistance;(4 items) Adds 2975 Spell Resistance.;(5 items) Adds 5170 Physical Resistance and 5170 Spell Resistance."
        },
        {
            name = "Mechanical Acuity",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.SPELL_DAMAGE, Esosets.MAX_MAGIC, Esosets.MAX_STAMINA, Esosets.SPELL_CRIT, Esosets.WEAPON_CRIT },
            hasJewelry = false,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.CLOCKWORKCITY,
            zone = Esosets.CLOCKWORKCITY,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            traits = 6,
            obtained = {
                location = "Pavillion of Artifice - " .. Esosets.CLOCKWORKCITY
            },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Stamina and 1096 Max Magicka.;(5 items) When you deal direct damage, you have a 15% chance to gain unerring mechanical vision for 5 seconds, causing your attacks to always be a Critical Strike. This effect can occur once every 18 seconds."
        },


        --DRAGONEBONES DLC
        {
            name = "Caluurion’s Legacy",
            bonuses = { Esosets.SPELL_CRIT, Esosets.SPELL_DAMAGE, Esosets.FLAME_DAMAGE, Esosets.SHOCK_DAMAGE, Esosets.FROST_DAMAGE, Esosets.DISEASE_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.PVP },
            zone = "",
            dungeons = { Esosets.FANG_LAIR },
            displayText = "(2 items) Adds 833 Spell Critical;(3 items) Adds 129 Spell Damage;(4 items) Adds 833 Spell Critical;(5 items) When you deal Critical Damage with a single target Magicka ability, you launch a Fire, Ice, Shock, or Disease ball at your target that deals 12,900 damage and applies a status effect. This effect can occur once every 10 seconds."
        },
        {
            name = "Jorvuld’s Guidance",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.HEAL, Esosets.DAMAGE_SHIELD },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.PVE },
            zone = "",
            dungeons = { Esosets.SCALECALLER_PEAK },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 2% Healing Done;(5 items) Increases the duration of all Major buffs, Minor buffs, and damage shields you apply to yourself and allies by 40%."
        },
        {
            name = "Trappings of Invigoration",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_STAMINA },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.NICHE },
            zone = "",
            dungeons = { Esosets.FANG_LAIR },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) When you cast an ability while under 33% Stamina, you restore 9000 Stamina. This effect can occur once every 1 minute."
        },
        {
            name = "Plague Slinger",
            bonuses = { Esosets.WEAPON_DAMAGE, Esosets.MAX_HEALTH, Esosets.POISON_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.PVP, Esosets.NICHE },
            zone = "",
            dungeons = { Esosets.SCALECALLER_PEAK },
            displayText = "(2 items) Adds 129 Weapon Damage;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Weapon Damage;(5 items) When you take damage, you summon a Skeever corpse which will launch a poison ball that deals 5160 Poison Damage every 1.5 seconds at the nearest enemy for 6 seconds. This effect can occur once every 15 seconds."
        },
        {
            name = "Ulfnor’s Favor",
            bonuses = { Esosets.MAX_HEALTH, Esosets.MAGIC_REGEN, Esosets.STAMINA_REGEN, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.NICHE },
            zone = "",
            dungeons = { Esosets.FANG_LAIR },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 4% Healing Taken;(5 items) Increases the Magicka or Stamina your Heavy Attacks restore by 30%."
        },
        {
            name = "Curse of Doylemish",
            bonuses = { Esosets.MAX_HEALTH, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE, Esosets.TAUNT },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.NICHE },
            zone = "",
            dungeons = { Esosets.SCALECALLER_PEAK },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Spell Damage;(4 items) Adds 129 Weapon Damage;(5 items) When you hit a taunted monster with a fully-charged Heavy Attack or any enemy that is stunned or immobilized with a fully-charged Heavy Attack, you deal an additional 12040 Physical Damage. This effect can occur once every 7 seconds."
        },
        {
            name = "Thurvokun",
            bonuses = { Esosets.MAX_HEALTH, Esosets.DISEASE_DAMAGE, Esosets.MAIM, Esosets.DEFILE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            zone = "",
            dungeons = { Esosets.FANG_LAIR },
            shouldersChest = Esosets.URG,
            displayText = "(1 items) Adds 1206 Max Health;(2 items) When a nearby enemy damages you, summon a growing pool of desecrated bile for 8 seconds. Enemies in the bile receive 430 Disease Damage every 1 second and are afflicted with Minor Maim and Minor Defile, reducing their damage done and healing received by 15%. This effect can occur once every 8 seconds."
        },
        {
            name = "Zaan",
            bonuses = { Esosets.SPELL_CRIT, Esosets.FLAME_DAMAGE },
            hasJewelry = false,
            hasWeapons = false,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.MONSTER_SET,
            dlc = Esosets.DRAGON_BONES,
            bestUsedIn = { Esosets.PVP, Esosets.PVE },
            zone = "",
            dungeons = { Esosets.SCALECALLER_PEAK },
            shouldersChest = Esosets.URG,
            displayText = "(1 items) Adds 833 Spell Critical;(2 items) When you deal Critical Damage with a Light or Heavy Attack to a nearby enemy, a beam of fire will connect you to your enemy. The beam deals 3440 Flame Damage every 1 second for 5 seconds. Every second, this damage increases by 50%. The beam is broken if the enemy moves 8 meters away from you. This effect can occur every 15 seconds."
        },







        -- SUMMERSET

        {
            name = "Adept Rider",
            bonuses = { Esosets.SPELL_RESISTANCE, Esosets.PHYSICAL_RESISTANCE, Esosets.MAX_HEALTH, Esosets.EVASION, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = true,
            hasWeapons = tue,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVP },
            zone = Esosets.SUMMERSET_ISLE,
            traits = 3,
            obtained = {
                location = "Northern Shimmerene" .. Esosets.SUMMERSET_ISLE
            },
            displayText = "(2 Items) 2975 Spell Resist;(3 Items) 2975 Physical Resist;(4 Items) 1206 Max Health;(5 Items) While mounted, you gain Major Evasion, increasing your dodge chance by 15%. Dismounting spawns a dust cloud at your position for 12 seconds that deals 1436 Physical Damage every 1 second to enemies who stand inside it. You and group members inside the dust cloud gain Major Evasion. The dust cloud can be created once every 12 seconds."
        },
        {
            name = "Sload’s Semblance",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAX_STAMINA, Esosets.SPELL_DAMAGE, Esosets.WEAPON_DAMAGE, Esosets.OBLIVION_DAMAGE },
            hasJewelry = true,
            hasWeapons = tue,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVP },
            zone = Esosets.ARTAEUM,
            traits = 6,
            obtained = {
                location = Esosets.ARTAEUM
            },
            displayText = "(2 items) Adds 1096 Maximum Magicka;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 129 Spell Damage;(4 items) Adds 129 Weapon Damage;(5 items) Damaging an enemy has a 10% chance to put a Leeching Shadow on them, dealing 853 Oblivion Damage every 1 second for 6 seconds. This effect can occur every 6 seconds."
        },
        {
            name = "Nocturnal’s Favor",
            bonuses = { Esosets.STAMINA_REGEN, Esosets.MAX_HEALTH, Esosets.DODGE, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT, Esosets.MEDIUM, Esosets.HEAVY },
            type = Esosets.CRAFTED_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVP },
            zone = Esosets.SUMMERSET_ISLE,
            traits = 9,
            obtained = {
                location = Esosets.SUMMERSET_ISLE
            },
            displayText = "(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) Whenever you successfully Dodge, heal yourself for 4000. This effect can occur every 2 seconds."
        },
        {
            name = "Mantle of Siroria",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.SLAYER, Esosets.MAX_MAGIC },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            dungeons = { Esosets.CLOUDREST },
            displayText = "(2 items) Adds 129 Spell Damage;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%;(4 items) Adds 1096 Maximum Magicka;(5 items) Dealing direct damage to an enemy with a single target ability creates a ring of fire beneath you for 10 seconds. Standing in the ring grants you a stack of Siroria's Boon for 5 seconds. Each stack increases your Spell Damage by 30. 20 stacks max."
        },
        {
            name = "Vestment of Olorime",
            bonuses = { Esosets.MAGIC_REGEN, Esosets.AEGIS, Esosets.COURAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            dungeons = { Esosets.CLOUDREST },
            displayText = "(2 items) Adds 129 Magicka Recovery;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon and Trial Monsters by 5%;(4 items) Adds 129 Magicka Recovery;(5 items) Casting ground effect abilities in combat will create a circle of might on the ground for 10 seconds. You and your allies in the circle gain Major Courage for 30 seconds, increasing your Weapon and Spell Damage by 258 for 30 seconds. This effect can occur every 10 seconds."
        },
        {
            name = "Arms of Relequen",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.SLAYER, Esosets.PHYSICAL_DAMAGE },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            dungeons = { Esosets.CLOUDREST },
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%;(4 items) Adds 833 Weapon Critical;(5 items) Your Light and Heavy attacks apply a stack of harmful winds to your target for 5 seconds. Harmful winds deal 378 Physical Damage every 1 second. Each stack increases the damage by 189 Physical Damage. 20 stacks max."
        },
        {
            name = "Aegis of Galanwe",
            bonuses = { Esosets.MAX_HEALTH, Esosets.AEGIS, Esosets.HEALING_TAKEN },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.TRIAL_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            dungeons = { Esosets.CLOUDREST },
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon and Trial Monsters by 5%;(4 items) Adds 4% Healing Taken;(5 items) After successfully blocking, you have a 50% chance to grant Empower to 3 allies within 15 meters, increasing the damage of their next Light Attack by 40%. This effect can occur every 1 seconds."
        },
        {
            name = "Wisdom of Vanus",
            bonuses = { Esosets.MAX_MAGIC, Esosets.MAGIC_REGEN, Esosets.MENDING },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            displayText = "(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1096 Max Magicka;(5 items) After landing a Full Heavy Attack, gain Major Mending for 3 seconds, increasing your healing done by 25%. This duration is increased with each rank of the Restoration Staff Passive Essence Drain when using a Restoration Staff."
        },
        {
            name = "Gryphon’s Ferocity",
            bonuses = { Esosets.WEAPON_CRIT, Esosets.WEAPON_DAMAGE, Esosets.FORCE, Esosets.EXPEDITION },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.MEDIUM },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            displayText = "(2 items) Adds 833 Weapon Critical;(3 items) Adds 833 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) After dealing direct damage, gain Minor Force and Minor Expedition for 3 seconds, increasing your Critical Damage done by 10% and increasing your Movement Speed by 10%."
        },
        {
            name = "Grace of Gloom",
            bonuses = { Esosets.MAX_HEALTH, Esosets.EVASION, Esosets.HEALING_TAKEN, Esosets.HEAL },
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.HEAVY },
            type = Esosets.OVERLAND_SET,
            dlc = Esosets.SUMMERSET,
            bestUsedIn = { Esosets.PVE },
            zone = Esosets.SUMMERSET_ISLE,
            displayText = "(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) When you take damage from a single target direct attack or ability, you have a 10% chance to become a living shadow, causing your light and heavy attacks to heal you for 3440 and gaining Major Evasion for 5 seconds, increasing your dodge chance by 15%. This effect can occur every 15 seconds."
        },



        --- - WOLFHUNTER DLC
        {
            name = "Moon Hunter",
            bonuses = { Esosets.SPELL_DAMAGE, Esosets.SPELL_CRIT} ,
            hasJewelry = true,
            hasWeapons = true,
            weights = { Esosets.LIGHT } ,
            type = Esosets.DUNGEON_SET,
            dlc = Esosets.WOLFHUNTER,
            zone = Esosets.REAPERS_MARCH,
            dungeons = { Esosets.MOON_HUNTER_KEEP },
            displayText = "(2 items) 129 Spell Damage;(3 items) 129 Spell Damage;(4 items) 833 Spell Critical;(5 items) When your alchemical poison fires, increase your Spell Damage by 600 for 6 seconds."
        } ,
        {
            name="Savage Werewolf",
            bonuses={ Esosets.MAX_STAMINA , Esosets.WEAPON_DAMAGE, Esosets.PHYSICAL_DAMAGE, Esosets.BLEED} ,
            hasJewelry=true,
            hasWeapons=true,
            weights={ Esosets.MEDIUM } ,
            type=Esosets.DUNGEON_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.REAPERS_MARCH,
            dungeons={ Esosets.MOON_HUNTER_KEEP} ,
            displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Your Light and Heavy Attacks rend flesh, causing your enemy to bleed for 1000 Physical Damage every 2 seconds for 6 seconds."
        } ,
        {
            name="Jailer’s Tenacity",
            bonuses={ Esosets.HEALING_TAKEN , Esosets.MAX_HEALTH, VITALITY} ,
            hasJewelry=true,
            hasWeapons=true,
            weights={ Esosets.HEAVY} ,
            type=Esosets.DUNGEON_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.REAPERS_MARCH,
            dungeons={ Esosets.MOON_HUNTER_KEEP} ,
            displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you lose 7000 or more Health from a single attack, you gain Major Vitality for 6 seconds, increasing your healing received by 30%."
        } ,
        {
            name="Vykosa",
            bonuses={ Esosets.HEALING_TAKEN , Esosets.MAIM, TAUNT} ,
            hasJewelry=false,
            hasWeapons=false,
            weights={ Esosets.LIGHT , Esosets.MEDIUM, Esosets.HEAVY} ,
            type=Esosets.MONSTER_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.REAPERS_MARCH,
            dungeons={ Esosets.MOON_HUNTER_KEEP} ,
            shouldersChest=Esosets.URG,
            displayText="(1 items) Adds 4% Healing Taken;(2 items) When you Bash an enemy you have taunted, you frighten them with a deafening howl, applying Major Maim to them for 3 seconds, lowering their damage done by 30%. This effect can occur once every 15 seconds."
        } ,
        {
            name="Hanu’s Compassion",
            bonuses={ Esosets.MAX_MAGIC , Esosets.MAGIC_REGEN, Esosets.HEROISM} ,
            hasJewelry=true,
            hasWeapons=true,
            weights={ Esosets.LIGHT} ,
            type=Esosets.DUNGEON_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.GREENSHADE,
            dungeons={ Esosets.MARCH_OF_SACRIFICES} ,
            displayText="(2 items) Adds129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you resurrect another player while in combat, you and the player gain Major Heroism for 15 seconds, granting you 3 Ultimate every 1.5 seconds."
        } ,
        {
            name="Blood Moon",
            bonuses={ Esosets.WEAPON_CRIT , Esosets.WEAPON_DAMAGE} ,
            hasJewelry=true,
            hasWeapons=true,
            weights={ Esosets.MEDIUM} ,
            type=Esosets.DUNGEON_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.GREENSHADE,
            dungeons={ Esosets.MARCH_OF_SACRIFICES} ,
            displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 833 Weapon Critical;(4 items)  Adds 833 Weapon Critical;(5 items) When you deal Critical Damage with a melee Light Attack, you gain a stack of Blood Scent for 8 seconds. When you gain 5 stacks, you become Frenzied for 5 seconds, increasing your melee Light Attack damage by 30% and attack speed by 50%. This effect can occur every 18 seconds."
        } ,
        {
            name="Haven of Ursus",
            bonuses={ Esosets.MAX_HEALTH , Esosets.HEALING_TAKEN, Esosets.DAMAGE_SHIELD} ,
            hasJewelry=true,
            hasWeapons=true,
            weights={ Esosets.HEAVY} ,
            type=Esosets.DUNGEON_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.GREENSHADE,
            dungeons={ Esosets.MARCH_OF_SACRIFICES} ,
            displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) When you take damage while you are under 50% Health, summon Ursus’s spirit for 6 seconds. You or an ally can activate a synergy on Ursus to grant you a shield that protects you and the activator from 13954 damage for 6 seconds. This effect can occur once every 12 seconds."
        } ,
        {
            name="Balorgh",
            bonuses={ Esosets.WEAPON_DAMAGE , Esosets.SPELL_DAMAGE, Esosets.ULTIMATE} ,
            hasJewelry=false,
            hasWeapons=false,
            weights={ Esosets.LIGHT , Esosets.MEDIUM, Esosets.HEAVY} ,
            type=Esosets.MONSTER_SET,
            dlc=Esosets.WOLFHUNTER,
            zone=Esosets.GREENSHADE,
            dungeons={ Esosets.MARCH_OF_SACRIFICES} ,
            shouldersChest=Esosets.URG,
            displayText="(1 items) Adds 129 Weapon Damage;(1 items) Adds 129 Spell Damage;(2) When you use an Ultimate ability, you gain Weapon and Spell Damage for 10 seconds equal to twice the amount of total Ultimate consumed."
        }




    } -- end Esosets.ALL_SETS





    Esosets.ALL_SETS2 = 
    

{
{name="Affliction",bonuses={"Weapon Damage","Max Stamina","Max Magicka","Disease Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) 50% chance when causing damage to also cause 2979 Disease Damage. This effect has a cooldown of 4 seconds."},
{name="Alessia's Bulwark",bonuses={"Physical Resistance","Max Health","Physical Resistance","Reduce Enemy Weapon Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=5,obtained={ad="Malabal Tor - Chancel of Divine Entreaty",dc="Alik'r Desert - Alezer Kotu",ep="Eastmarch - Hammerhome",zones={"Malabal Tor","Alik'r Desert","Eastmarch"}},displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Physical Resistance;(5 items) Being damaged by a melee attack has a 15% chance to reduce attacker's Weapon Damage by 10% for 5 seconds"},
{name="Almalexia's Mercy",bonuses={"Max Health","Spell Resistance","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) 20% chance when taking damage to heal allies within 7 meters for 2429. This effect has a cooldown of 3 seconds."},
{name="Alessian Order",bonuses={"Stamina Recovery","Healing Taken","Max Health","Break Free"},hasJewelry=true,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) Increases the immunity to disabling effects after using Break Free by 3 seconds."},
{name="Agility",bonuses={"Max Stamina","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="Imperial City",zone="Cyrodiil",obtained={location="Bloody Claws --Arboretum, Monstrous Teeth {Temple}"},displayText="(2 items) Adds 1451 Max Stamina;(3 items) Adds 193 Weapon Damage"},
{name="Arch-Mage",bonuses={"Max Magicka","Magicka Recovery","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) Fully-charged heavy attacks restore 834 Magicka."},
{name="Armor Master",bonuses={"Max Health","Physical Resistance","Spell Resistance"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Imperial City",zone="Cyrodiil",traits=9,obtained={location="Memorial District"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) While you have an Armor Ability slotted, increase your Max Health by 5%. When you activate an Armor Ability you gain 5332 Physical and Spell Resistance for 10 seconds."},
{name="Armor of the Seducer",bonuses={"Magicka Recovery","Max Magicka","Reduce Magic Cost"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=3,obtained={ad="Grahtwood - Temple of the Eight",dc="StormHaven - Fisherman's Island",ep="Deshaan - Berezan's Mine",zones={"Grahtwood","Stormhaven","Deshaan"}},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Reduce the Magicka cost of abilities by 8%."},
{name="Ashen Grip",bonuses={"Max Health","Weapon Damage","Weapon Critical","Flame Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=2,obtained={ad="Auridon - Beacon Falls",dc="Glenumbra - Par Molag",ep="Stonefalls - Magmaflow Overlook",zones={"Auridon","Glenumbra","Stonefalls"}},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) 10% chance to breath fire for 1544 Flame Damage on melee hits. This effect can occur once every 4 seconds."},
{name="Bastion of the Heartland",bonuses={"Max Health","Healing Taken","Reduce Damage"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Reduce damage taken from players by 5%.;(5 items) Reduce damage taken from siege weapons and player AoE spells by 20%."},
{name="Beckoning Steel",bonuses={"Spell Resistance","Max Health"},hasJewelry=true,hasWeapons=false,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) 40% to intercept projectiles for allies within 5m."},
{name="Blessing of the Potentates",bonuses={"Stamina Recovery","Ultimate"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="Pvp Rewards/ Vendors"},displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Reduce cost of Ultimate abilities by 10%."},
{name="Blood Spawn",bonuses={"Stamina Recovery","Physical Resistance","Spell Resistance","Ultimate"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Glenumbra",dungeons={"Spindle Clutch II"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 129 Stamina Recovery;(2 items) 6% chance when hit to gain 6450 Armor and Spell Resist for 6.0 seconds and restore 14 Ultimate."},
{name="Bloodthorn's Touch",bonuses={"Spell Damage","Max Magicka","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Glenumbra",displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you deal direct damage, you restore 660 Magicka and Stamina. This effect can occur once every 5 seconds."},
{name="Brands of Imperium",bonuses={"Max Health","Healing Taken","Damage Shield"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",dungeons={"White Gold Tower"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) 6% chance when taking damage to grant yourself and nearby allies a 12040 Damage Shield that lasts for 8 seconds. This effect has a cooldown of 15 seconds."},
{name="Briarheart",bonuses={"Weapon Critical","Max Stamina","Weapon Damage","Healing"},hasJewelry=true,hasWeapons=false,weights={"Medium"},type="Overland Set",dlc="Orsinium",zone="Wrothgar",displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) 10% chance when you deal Critical Damage to create Briarthorns which increases your Weapon Damage by 449 for 10 seconds. While Briarthorns is active, your Critical Hits will heal you for 609 Health. Briarthorns can apply once every 15 seconds."},
{name="Black Rose",bonuses={"Max Health","Max Stamina","Magicka Recovery","Stamina Recovery","Weapon Damage","Spell Damage"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;5 items) Increases the Magicka and Stamina restoration benefit from the Constitution Passive by 50% and increases Weapon and Spell Damage by 154."},
{name="Buffer of the Swift",bonuses={"Healing Taken","Max Health","Reduce Damage","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Reduce damage taken from players by 5%.;(5 items) 10% chance to gain a 2520 point Damage Shield for 6 seconds when damaged by a spell. This effect can occur once every 4 seconds."},
{name="Burning Spellweave",bonuses={"Max Magicka","Spell Damage","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Greenshade",dungeons={"City of Ash I","City of Ash II"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) When you deal damage with a Flame Damage ability, you have a 15% chance to apply the burning status effect to the enemy and gain 525 Spell Damage for 8 seconds. This effect can occur once every 12 seconds."},
{name="Clever Alchemist",bonuses={"Spell Damage","Weapon Damage","Max Health"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Thieves Guild",zone="Hew's Bane",traits=7,obtained={location="Hew's Bane - No Shira Workshop"},displayText="(2 Items) Adds 1206 Max Health;(3 Items) Adds 1206 Max Health;(4 Items) Adds 129 Spell Damage / Weapon Damage;(5 Items) When you drink a potion you feel a rush of energy, gaining 661 Weapon and Spell Damage for 15 seconds."},
{name="Combat Physician",bonuses={"Max Magicka","Spell Critical","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Imperial City",zone="Stormhaven",dungeons={"Wayrest Sewers I","Wayrest Sewers II"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 688 Spell Critical;(5 items) Critically Healing an ally grants them a 8195 Damage Shield for 8 seconds. This effect has a cooldown of 6 seconds."},
{name="Crest of Cyrodiil",bonuses={"Stamina Recovery","Max Health","Healing"},hasJewelry=true,hasWeapons=false,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) After successfully blocking, heal for 8000 Health. This effect can occur every 5 seconds."},
{name="Crusader",bonuses={"Max Stamina","Stamina Recovery","Dodge"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) After roll dodging, continue to dodge attacks for an additional 0.3 seconds."},
{name="Curse Eater",bonuses={"Max Magicka","Max Magicka","Max Health","Reduce Negative Effects"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1039 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 126 Magicka Recovery;(5 items) Reduce the duration of negative effects on you by 20%"},
{name="Darkstride",bonuses={"Max Stamina","Stamina Recovery","Reduce Stamina Cost"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Base Game",zone="Rivenspire",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces Stamina cost for sprinting or crouching by 35%."},
{name="Deadly Strikes",bonuses={"Max Health","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="Pvp Rewards/ Vendors"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 833 Weapon Critical"},
{name="Death's Wind",bonuses={"Physical Resistance","Max Health","Stun Enemy"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=2,obtained={ad="Auridon - Eastshore Islets Camp",dc="Glenumbra - Chill House",ep="Stonefalls - Armatures Upheaval",zones={"Auridon","Glenumbra","Stonefalls"}},displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) If struck by a melee attack while below 35% Health, nearby enemies are knocked back and stunned for 4 seconds. This effect can only happen once every 30 seconds."},
{name="Desert Rose",bonuses={"Spell Resistance","Max Health","Max Magicka","Magicka Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Magicka;(5 items) 10% chance when taking damage to recover 2408 Magicka. This effect has a 1 second cooldown."},
{name="Destructive Mage",bonuses={"Max Magicka","Spell Critical","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Base Game",zone="Craglorn",dungeons={"Hel Ra Citidel"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage with a fully-charged Heavy Attack, you place a bomb on the enemy for 10 seconds. When another player hits the same enemy with a fully-charged Heavy Attack they detonate the bomb, dealing 7875 Magic Damage all enemies within 8 meters. This effect can occur once every 10 seconds."},
{name="Draugr's Heritage",bonuses={"Max Health","Healing Taken","Healing"},hasJewelry=false,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Base Game",zone="The Rift",displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) Knockdown nearby enemies and heal self for 4730 if you are damaged while under 20% Health. This effect can happen once every 20 seconds."},
{name="Dreugh King Slayer",bonuses={"Weapon Critical","Weapon Damage","Brutality","Expedition"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Base Game",zone="Stonefalls",dungeons={"Fungal Grotto I","Fungal Grotto II"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Passively grants Major Brutality, increasing your Weapon Damage by 20%. Killing an enemy grants you Major Expedition for 8 seconds, increasing your movement speed by 30%."},
{name="Eagle Eye",bonuses={"Weapon Critical","Bow"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="Pvp Rewards/ Vendors"},displayText="(2 items) Adds 833 Weapon Critical;(3 items) Increases range of Bow abilities by 3 meters."},
{name="Elf Bane",bonuses={"Max Magicka","Spell Damage"},hasJewelry=false,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) Increases duration of your damaging fire effect by 2 seconds."},
{name="Elemental Succession",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=false,weights={"Light"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) While in combat, you gain a rotating bonus to either Flame, Shock or Frost damage. The active element changes every 4 seconds. Your attacks dealing damage with the active element gain 515 Spell Damage."},
{name="Endurance",bonuses={"Max Health","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="Imperial City",zone="Cyrodiil",obtained={location="Planar Armor Scraps{Elven Gardens}, Mark of the Legion{Nobles}"},displayText="(2 items) Adds 1596 Max Health;(3 items) Adds 193 Stamina Recovery"},
{name="Engine Guardian",bonuses={"Health Recovery","Stamina Recovery","Magicka Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",dungeons={"Darkshade Caverns II"},zone="Deshaan",shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 129 Health Recovery;(2 items) 10% chance on ability use to summon a dwemer automation to restore 1162 Health, Stamina, or Magicka every 0.5 seconds for 6.5 seconds."},
{name="Essence Thief",bonuses={"Max Stamina","Weapon Damage","Healing"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Dungeon Drop",dlc="Imperial City",dungeons={"White Gold Tower"},zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) 15% chance when causing damage with light attacks to draw essence from an enemy. Collecting the essence restores 4300 Health and Stamina and increases your damage by 12% for 10 seconds."},
{name="Eternal Hunt",bonuses={"Max Stamina","Stamina Recovery","Poison Damage","Dodge"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Thieves Guild",zone="Hew's Bane",traits=9,obtained={location="Hew's Bane - The Lost Pavillion"},displayText="(2 Items) Adds 1096 Maximum Stamina;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Stamina Recovery;(5 Items) When you roll dodge you leave behind a rune that detonates when enemies come close dealing 8125 Poison Damage and immobilizing them for 1.5 seconds."},
{name="Eternal Warrior",bonuses={"Healing Taken","Max Health","Resurrection"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Trial Set",dlc="Base Game",zone="Craglorn",dungeons={"Sanctum Ophidia","Hel Ra Citidel","Aetherian Archive"},displayText="(2 items) Adds 4% Healing Taken;(3 items) Grants Major Aegis, causing you to take 5% less damage from Boss Monsters;(4 items) Adds 1206 Max Health;(5 items) When you die, you instead turn into a statue for 3 seconds and gain 200 Ultimate. While a statue, you are immune to all negative effects, but can still be healed. This effect has a cooldown of 10 minutes. Adds 4% Healing Taken"},
{name="Eyes of Mara",bonuses={"Magicka Recovery","Max Magicka","Spell Damage","Reduce Magic Cost"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Eyevea",traits=8,obtained={location="Any Mages Guild Portal - Eyevea"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Reduce the Magicka cost of restoration staff abilities by 12%."},
{name="Fasalla's Guile",bonuses={"Max Health","Healing Taken","Defile"},hasJewelry=false,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Thieves Guild",zone="Cyrodiil",displayText="(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1206 Maximum Health;(4 Items) Adds 4% Healing Taken;(5 Items) Apply Minor Defile to all nearby enemies, reducing their healing received by 15% for 2 seconds."},
{name="Flanking Strategist",bonuses={"Max Stamina","Weapon Critical","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Dark Brotherhood",zone="Gold Coast",displayText="(2 items) Adds Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) Attacks from behind and enemy gain an additional 345 Weapon Damage."},
{name="Galerion's Revenge",bonuses={"Spell Critical","Magicka Recovery","Spell Damage"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 688 Spell Critical;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you hit an enemy with a Light or Heavy Attack you put a Mark of Revenge on them for 15 seconds, after stacking 6 Marks on a target they will detonate for 7561 Magic Damage."},
{name="Glorious Defender",bonuses={"Max Health","Weapon Damage","Dodge"},hasJewelry=true,hasWeapons=false,weights={"Heavy"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Weapon Damage;(5 items) 9% chance when you hit an enemy with a light or heavy attack to dodge the next attack against you."},
{name="Grace of the Ancients",bonuses={"Max Magicka"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="Pvp Rewards/ Vendors"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Increase Maximum Magicka by 4%."},
{name="Hawk's Eye",bonuses={"Max Stamina","Weapon Damage","Bow"},hasJewelry=true,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Reduce cost of bow abilities by 5% and increase their damage by 5%."},
{name="Healer's Habit",bonuses={"Max Magicka","Magicka Recovery","Spell Damage","Healing","Mending"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Craglorn",dungeons={"Dragon Star Arena"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) Gain Minor Mending, increasing healing done by 8%"},
{name="Hide of Morihaus",bonuses={"Max Health","Physical Resistance","Max Stamina","Physical Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Dark Brotherhood",zone="Gold Coast",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds Adds 1096 Max Stamina;(5 items) Rolling through enemies deals 1932 Physical Damage and knocks them down."},
{name="Hist Bark",bonuses={"Physical Resistance","Health Recovery","Max Health","Evasion"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=4,obtained={ad="Greenshade - Rootwatch Tower",dc="Rivenspire Trader's Rest",ep="Shadowfen Hatchling's Crown",zones={"Greenshade","Rivenspire","Shadowfen"}},displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 129 Health Recovery;(4 items) Adds 1206 Max Health;(5 items) Gain Major Evasion while blocking, increasing Dodge chance by 15%."},
{name="Hunding's Rage",bonuses={"Weapon Critical","Max Stamina","Weapon Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=6,obtained={ad="Reaper's March - Broken Arch",dc="Bangkori - Wether's Cleft",ep="The Rift - Trollslayer Gully",zones={"The Rift","Reaper's March","Bangkorai"}},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) Increase Weapon Damage by 300."},
{name="Hunt Leader",bonuses={"Max Stamina","Weapon Damage","Max Health"},hasJewelry=true,hasWeapons=false,weights={"Medium"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Gain 1216 Stamina and 2433 Health when your pets attack an enemy you have also attacked recently. Can occur once per 5 seconds."},
{name="Infallible Mage",bonuses={"Spell Critical","Slayer","Spell Damage","Vulnerability"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Craglorn",dungeons={"Hel Ra Citidel","Aetherian Archive","Sanctum Ophidia"},displayText="(2 items) Adds 833 Spell Critical;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%.;(4 items) Adds 129 Spell Damage;(5 items) Your fully charged heavy attacks do an additional 903 damage.Enemies you damage with fully charged Heavy Attacks are afflicted with Minor Vulnerability for 10 seconds, increasing their damage taken by 8%.;(5 items) Adds 833 Spell Critical"},
{name="Imperial Physique",bonuses={"Stamina Recovery","Magicka Recovery","Max Stamina","Max Health","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1096 Max Stamina;(5 items) While you are in Imperial City, you tap into the power of the Tel Var stones you are carrying, increasing your Health, Magicka and Stamina by 996. While you have a 4x Tel Var Stone multiplier this effect is increased by 600%."},
{name="Juggernaut",bonuses={"Max Health","Physical Resistance","Healing"},hasJewelry=false,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Max Health;(5 items) When Health drops below 30%, heal for 12900. This effect can occur once every 1 minute."},
{name="Kagrenac's Hope",bonuses={"Max Magicka","Magicka Recovery","Max Health","Spell Damage","Resurrection"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=8,obtained={location="3rd Zone Major City Fighters Guild - Earth Forge"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1206 Max Health;(5 items) Decrease time to resurrect an ally by 25% and restore 1720 Magicka when you successfully resurrect an ally. Adds 222 Spell Damage"},
{name="Knightmare",bonuses={"Max Health","Physical Resistance","Weapon Damage","Reduce Damage","Maim"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Base Game",zone="Glenumbra",dungeons={"Spindle Clutch I","Spindle Clutch II"},displayText="(2 items) Adds 1898 Physical Resistance;(3 items) Adds 1039 Max Health;(4 items) Adds 126 Weapon Damage;(5 items) 20% Chance on melee attack to apply Minor Maim to nearby enemies for 5 seconds, reducing the damage they deal by 15%."},
{name="Kvatch Gladiator",bonuses={"Weapon Critical","Weapon Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dark Brotherhood",zone="Gold Coast",traits=7,obtained={location="Gold Coast - Marja's Mill"},displayText="(2 items) Adds 688 Weapon Critical ;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) Your Light and Heavy Attacks deal an additional 690 Weapon Damage to targets below 25% Health."},
{name="Kyne's Kiss",bonuses={"Max Stamina","Stamina Recovery","Weapon Critical","Healing","Bow"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 688 Weapon Critical;(5 items) Bow attacks have a 10% chance to restore 1216 Stamina and Health. This effect will not proc off damage over time effects."},
{name="Lamia's Song",bonuses={"Max Magicka","Magicka Recovery","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Shadowfen",dungeons={"Arx Corinium"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magica Recovery;(4 items) Adds 1096 Max Magicka;(5 items) When you activate your Ultimate, you heal you and your allies within 20 meters of you for 30 Health per point of the Ultimate's cost."},
{name="Law Of Julianos",bonuses={"Spell Critical","Max Magicka","Spell Critical","Spell Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Orsinium",zone="Wrothgar",traits=6,obtained={location="Wrothgar - Boreal Forge"},displayText="(2 items) Adds 688 Spell Critical;(3 items) Adds 1096 Max Magicka;(4 items) Adds 688 Spell Critical;(5 items) Increase Spell Damage by 299"},
{name="Light Speaker",bonuses={"Max Health","Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Grahtwood",dungeons={"Elden Hollow I","Elden Hollow II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your Restoration Staff abilities."},
{name="Light of Cyrodiil",bonuses={"Spell Damage","Max Magicka","Reduce Damage","Reduce Magic Cost"},hasJewelry=true,hasWeapons=false,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) While you are casting or channeling an ability, your damage taken is reduced by 15%. When you are interrupted, your next Magicka ability will cost no Magicka."},
{name="Leeching Plate",bonuses={"Max Health","Healing Taken","Poison Damage"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Dungeon Drop",dlc="Imperial City",zone="Cyrodiil",dungeons={"Imperial City Prison"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 4% Healing Taken;(5 items) 8% chance when damaged to summon a cloud of leeching poison under the attacker that deals 1204 Poison Damage every second for 5.5 seconds and heals you for the damage caused."},
{name="Leki's Focus",bonuses={"Weapon Damage","Max Stamina","Stamina Recovery","Reduced AOE Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Thieves Guild",zone="Cyrodiil",displayText="(2 Items) Adds 129 Weapon Damage;(3 Items) Adds 1096 Maximum Stamina;(4 Items) Adds 129 Stamina Recovery;(5 Items) You take 25% less damage from players' area effect abilities but the damage and healing of your own area effect abilities is also reduced by 25%"},
{name="Lord Warden",bonuses={"Spell Resistance","Physical Resistance"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Imperial City",zone="Cyrodiil",dungeons={"Imperial City Prison"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) 6% chance when hit to summon a shadow orb that adds 3870 Spell Resistance to nearby allies for 12.0 seconds."},
{name="Lunar Bastion",bonuses={"Healing Taken","Aegis","Max Health","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="Thieves Guild",zone="Reaper's March",dungeons={"Maw of Lorkhaj"},displayText="(2 Items) Adds 4% Healing Taken;(3 Items) Grants Minor Aegis, causing you to take 5% less damage from Boss Monsters;(4 Items) Adds 1206 Maximum Health;(5 Items) When you use a synergy you create a lunar blessing for 10 seconds that grants a 2399 Damage Shield to nearby allies every 2 seconds."},
{name="Magicka Furnace",bonuses={"Physical Resistance","Spell Damage","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Eastmarch",dungeons={"Direfrost Keep"},obtained={location="Direfrost Keep"},displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) When you take damage from a melee attack while you are under 80% Magicka, restore 8000 Magicka. This effect can occur once every 30 seconds."},
{name="Mark of the Pariah",bonuses={"Max Health","Physical Resistance","Spell Resistance"},hasJewelry=true,hasWeapons=false,weights={"Heavy"},type="Overland Set",dlc="Orsinium",zone="Wrothgar",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) Increases your Physical and Spell Resistance by up to 8807 based on your missing Health."},
{name="Marksman's Crest",bonuses={"Stamina Recovery","Weapon Damage","Bow"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Thieves Guild",zone="Cyrodiil",displayText="(2 Items) Adds 129 Stamina Recovery;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Weapon Damage;(5 Items) Reduce the Stamina cost of abilities by 5% and increase the damage of your bow abilities against players by 8%"},
{name="Maw of the Inferno",bonuses={"Max Health","Flame Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Auridon",dungeons={"Banished Cells II"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 1206 Max Health;(2 items) 5% chance on light or heavy attack to summon a fire breathing daedroth for 15.0 seconds. Basic attack deals 3067 Flame Damage."},
{name="Magnus' Gift",bonuses={"Max Magicka","Magicka Recovery","Spell Damage","Reduce Magic Cost"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",obtained={ad="Greenshade - Aranaga",dc="Rivenspire - Valenwood Ede",ep="-Shadowfen - Xal haj-ei Shrine",zones={"Greenshade","Rivenspire","Shadowfen"}},traits=4,displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) 8% Chance to negate the Magicka cost of a spell."},
{name="Meritorious Service",bonuses={"Max Health","Max Magicka","Spell Damage","Physical Resistance","Spell Resistance"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Tel Var Set",dlc="Orsinium",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) While you cast a Support Ability up to 4 nearby allies gain 3010 Physical and Spell Resistance for 2 minutes."},
{name="Molag Kena",bonuses={"Spell Damage","Weapon Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Imperial City",zone="Cyrodiil",dungeons={"White Gold Tower"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 129 Weapon and Spell Damage;(2 items) Causing damage with 2 consecutive light attacks triggers Overkill, which increases the cost of all abilities by 33% and increases your Spell Damage and Weapon Damage by 516 for 6 seconds."},
{name="Moondancer",bonuses={"Max Magicka","Slayer","Spell Damage","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Thieves Guild",zone="Reaper's March",dungeons={"Maw of Lorkhaj"},displayText="(2 Items) Adds 1096 Maximum Magicka;(3 Items) Grants Minor Slayer, causing your attacks to deal 5% more damage to Boss Monsters;(4 Items) Adds 129 Spell Damage;(5 Items) When you activate a synergy gain either shadow blessing that increases Spell Damage by 448, or a lunar blessing that increases Magicka Recovery by 448. Each lasts 30 seconds and you can only have one blessing at a time."},
{name="Morang Tong",bonuses={"Max Stamina","Weapon Damage","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Your attacks cause targets to take 15% more damage from Poisons for 5 seconds."},
{name="Mother's Sorrow",bonuses={"Max Magicka","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Deshaan",displayText="(2 items) Adds 1096 Max Magicka;3 items) Adds 688 Spell Critical;(4 items) Adds 688 Spell Critical;(5 items) Adds 1924 Spell Critical"},
{name="Morkuldin",bonuses={"Max Stamina","Stamina Recovery","Weapon Damage","Physical Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Orsinium",zone="Wrothgar",traits=9,obtained={location="Wrothgar - Morkuldin Forge"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Weapon Damage;(5 items) 10% chance when using Light or Heavy attacks to summon an animated weapon to attack your enemies. The weapon's basic attack deals 4551 Physical Damage."},
{name="Necropotence",bonuses={"Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Rivenspire",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) While you have a pet active, your Max Magicka is increased by 3150."},
{name="Nerien'eth",bonuses={"Max Health"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Rivenspire",dungeons={"Crypt of Hearts II"},shouldersChest="Gilirion",displayText="(1 items) Adds 1206 Max Health;(2 items) 10% chance when causing damage to create a Lich crystal that explodes after 3 seconds, dealing 7408 Magic Damage."},
{name="Bogdan Night Flame",bonuses={"Max Health","Healing"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Grahtwood",shouldersChest="Maj Al-Ragath",dungeons={"Elden Hollow II"},displayText="(1 items) Adds 1206 Max Health;(2 items) 2% chance when healing an ally to create a totem for 10.0 seconds. Totem heals allies in area for 1120 every 1.0 second. This effect has a cooldown of 6.seconds."},
{name="Night Mother's Embrace",bonuses={"Max Stamina","Weapon Damage","Stamina Recovery"},hasJewelry=false,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Base Game",zone="Deshaan",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Reduce the range you can be detected while hidden by 2 meters. Reduces crouch cost by 25%;(5 items) Adds 129 Weapon Damage"},
{name="Night Mother's Gaze",bonuses={"Weapon Critical","Weapon Damage","Reduce Enemy Physical Resistance","Fracture"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=6,obtained={ad="Reaper's March - Old Town Cavern",dc="Bangkori - Silaseil Ruins",ep="The Rift - Eldbjorg's Hideaway",zones={"Reaper's March","Bangkorai","The Rift"}},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Critical attacks applies Major Fracture to the enemy reduce the target's Physical Resistance by 5280 for 6 seconds."},
{name="Night's Silence",bonuses={"Max Stamina","Stamina Recovery","Weapon Critical"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=2,obtained={ad="Auridon - Hightide Keep",dc="Glenumbra - Mesanthano's Tower",ep="Stonefalls - Steamfont Cavern",zones={"Auridon","Glenumbra","Stonefalls"}},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 688 Weapon Critical;(5 items) Ignore movement speed penalty while sneaking."},
{name="Noble's Conquest",bonuses={"Max Health","Max Stamina","Healing Taken","Healing","Vulnerability"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=5,zone="Cyrodiil",obtained={location="Noble District"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 4% Healing Taken;(5 items) When you interrupt a casting enemy, you heal for 4300 Health and apply minor vulnerability increasing the enemy's damage taken by 8% for 10 seconds."},
{name="Noble Duelist's Skills",bonuses={"Stamina Recovery","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Imperial City",dungeons={"Blessed Crucible"},zone="The Rift",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Weapon Damage;(5 items) After dodging an attack, light and heavy attacks deal ? increased damage for 8 seconds."},
{name="Oblivion's Foe",bonuses={"Health Recovery","Stamina Recovery","Magicka Recovery"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Coldharbour",traits=8,obtained={location="Coldharbour - Font of Schemes"},displayText="(2 items) Adds 129 Health Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Magicka Recovery;(5 items) Increase the damage of your Soul Trap abilities by 100%."},
{name="Orgnum's Scales",bonuses={"Health Recovery","Max Health","Health Recovery"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=8,obtained={location="3rd Zone Major City Fighters Guild - Earth Forge"},displayText="(2 items) Adds 129 Health Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) If below 60% Health, increase Health Recovery by 50%."},
{name="Overwhelming Surge",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Malabal Tor",dungeons={"Tempest Island"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) 8% chance when activating a Class Ability to surround yourself in a torrent that strikes out at a nearby enemy dealing 1376 Shock Damage every seconds for 6 seconds."},
{name="Para Bellum",bonuses={"Max Stamina","Max Health","Damage Shield"},hasJewelry=true,hasWeapons=false,weights={"Medium"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Stamina;(5 items) After not taking damage for 10 seconds gain a 12040 Damage Shield."},
{name="Pelinal's Aptitude",bonuses={"Max Health","Stamina Recovery","Magicka Recovery","Weapon Damage","Spell Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dark Brotherhood",zone="Gold Coast",traits=9,obtained={location="Gold Coast - Colovian Revolt Forge Yard"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Magicka Recovery;(5 items) Your Weapon Damage and Spell Damage both become the highest of the two values."},
{name="Permafrost",bonuses={"Max Health","Max Magicka","Magicka Recovery","Health Recovery"},hasJewelry=true,hasWeapons=false,weights={"Heavy"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Gain 885 Health Recovery while you have a Damage Shield."},
{name="Phoenix",bonuses={"Max Magicka","Magicka Recovery","Spell Damage","Resurrection"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you die, instead become immune to all negative effects and healing for 3 seconds. When the effect ends you heal yourself for 17200 and explode for 8600 Flame Damage to nearby enemies. The effect has a cooldown of 10 minutes."},
{name="Powerful Assault",bonuses={"Max Health","Max Stamina","Weapon Damage","Spell Damage"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health ;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you cast an Assault Ability, up to 4 nearby allies gain 164 Weapon and Spell Damage for 15 seconds."},
{name="Prayer Shawl",bonuses={"Spell Damage","Magicka Recovery","Max Magicka","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",zone="Glenumbra",dungeons={"Spindle Clutch I","Spindle Clutch II"},displayText="(2 items) Adds 1096 Max Magicka;(3 tiems) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) 6% chance to grant a 2340 point Damage Shield when you heal an ally."},
{name="Prisoner's Rags",bonuses={"Max Stamina","Stamina Recovery","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Coldharbour",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost of Sprint by 50%. While Sprinting, restore 1000 Magicka every 1 second."},
{name="Queen's Elegance",bonuses={"Spell Damage","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Auridon",displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) Increases your Light and Heavy Attack damage by 20%."},
{name="Ravager",bonuses={"Weapon Critical","Max Health","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 672 Weapon Critical;(3 items) Adds 1039 Max Health;(4 items) Adds 126 Weapon Damage;5 items) Your melee attacks have an 8% chance to increase Weapon Damage by 630 for 10 seconds."},
{name="Reactive Armor",bonuses={"Max Stamina","Stamina Recovery","Max Health","Reduce Damage","Stun Enemy"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1206 Max Health;(5 items) While affected by Stun, Immobilize, Fear, Knockdown or Disorient effects, damage you take is reduced by 35%."},
{name="Redistributor",bonuses={"Max Health","Max Stamina","Max Magicka","Healing"},hasJewelry=false,hasWeapons=true,weights={"Medium"},type="Crafted Set",dlc="Imperial City",zone="Cyrodiil",traits=7,obtained={location="Arboretum District"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) When you heal yourself while at full Health, heal a nearby ally for 2347. This effect can happen once every 3 seconds."},
{name="Roar of Alkosh",bonuses={"Weapon Critical","Slayer","Weapon Damage","Physical Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Thieves Guild",zone="Reaper's March",dungeons={"Maw of Lorkhaj"},displayText="(2 Items) Adds 688 Weapon Critical;(3 Items) Grants Minor Slayer, causing your attacks to deal 5% more damage to Boss Monsters.;(4 Items) Adds 129 Weapon Damage;(5 Items) Activating a synergy sends a shockwave from your position that deals 1905 Physical Damage. Enemies hit have their Physical and Spell Resistance reduced by 3010 and take 13340 Physical Damage over 10 seconds."},
{name="Robes Alteration Mastery",bonuses={"Magicka Recovery","Spell Critical","Reduce Cost"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 688 Spell Critical;(5 items) Reduce all costs by 6%"},
{name="Robes of the Hist",bonuses={"Max Health","Spell Damage","Max Magicka","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Shadowfen",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) While you are affected by a disabling effect, immobilization, or snare, you heal for 2500 Health every 1 second."},
{name="Robes of Transmutation",bonuses={"Magicka Recovery","Spell Critical","Critical Resistance"},hasJewelry=false,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 Items) Adds 129 Magicka Recovery;(3 Items) Adds 129 Magicka Recovery;(4 Items) Adds 688 Spell Critical;(5 Items) When you heal an ally with a healing over time effect, grant them 1304 critical resistance for 20 seconds."},
{name="Robes of Onslaught",bonuses={"Max Health","Spell Damage","Max Magicka"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) Duration of Snare, Stuns and Disorient effects are reduced by 20%."},
{name="Robes of the Withered Hand",bonuses={"Max Health","Max Magicka","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Alik'r Desert",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1002 Max Health;(5 items) When an enemy within 28 meters dies, heal for 1290 Health and gain 1290 Magicka. This effect can occur once every 3 seconds."},
{name="Sanctuary",bonuses={"Max Health","Healing Taken","Max Magicka","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Auridon",dungeons={"Banished Cells I","Banished Cells II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1096 Max Magicka;(5 items) Increases your healing received by 12% for you and your group within 10 meters."},
{name="Scathing Mage",bonuses={"Max Magicka","Spell Critical","Spell Damage"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Dungeon Drop",dlc="Imperial City",zone="Cyrodiil",dungeons={"Imperial City Prison"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 833 Spell Critical;(4 items) Adds 833 Spell Critical;(5 items) When you deal direct Critical Damage, you have a 20% chance to increase your Spell Damage by 516 for 6 seconds. This effect can occur once every 6 seconds."},
{name="Scourge Harvester",bonuses={"Max Health","Healing"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Stormhaven",dungeons={"Wayrest Sewers II"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 1206 Max Health;(2 items) 6% chance when hit to create a beam that steals 5652 Health from target. Beam breaks from targets greater than 10 meters away. While beam holds gain 30.0% increased healing from all sources."},
{name="Sergeant's Mail",bonuses={"Max Health","Health Recovery","Weapon Damage"},hasJewelry=false,hasWeapons=false,weights={"Heavy"},type="Dungeon Drop",dlc="Imperial City",zone="Stormhaven",dungeons={"Wayrest Sewers I","Wayrest Sewers II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Add 129 Weapon Damage;(5 items) Your fully charged Heavy Attacks deal ?? additional damage."},
{name="Sentry",bonuses={"Max Stamina","Weapon Damage","Weapon Critical"},hasJewelry=false,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Weapon Critical;(5 items) Damage dealt to Sneaking targets increased by 20%. Stealth detection radius increased by 20%."},
{name="Shadow Walker",bonuses={"Max Stamina","Weapon Damage","Stamina Recovery","Health Recovery"},hasJewelry=true,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Restore ?? Health and Stamina every second while hidden and not moving."},
{name="Shadow Dancer's Raimnet",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Greenshade",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Ignore movement speed penalty while sneaking. Adds 129 Stamina Recovery"},
{name="Shalidor's Curse",bonuses={"Max Health","Healing Taken","Healing"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Eyevea",traits=8,obtained={location="Any Mages Guild Portal - Eyevea"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) While you are below 50% Health, light attacks restore 559 Health."},
{name="Shield of the Valiant",bonuses={"Max Health","Healing Taken","Reduce Damage","Break Free"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds Max Health;(3 items) Adds 4% Healing Taken;(4 items) Reduces damage taken from players by 5%.;(5 items) Reduce the cost of Break Free by 40%."},
{name="Sheer Venom",bonuses={"Max Stamina","Weapon Damage","Poison Damage"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Dungeon Drop",dlc="Imperial City",zone="Cyrodiil",dungeons={"Imperial City Prison"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Weapon Damage;(5 items) Causing damage with an Execute ability infects the enemy, dealing 1204 Poison Damage every second for 6 seconds. The effect has a cool down of 6 seconds."},
{name="Shroud of the Lich",bonuses={"Magicka Recovery","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Imperial City",zone="Rivenspire",dungeons={"Crypt of Hearts I","Crypt of Hearts II"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) Once per minute, when below 33% Magicka, gain 1032 Magicka Recovery for 20.0 seconds"},
{name="Silks of the Sun",bonuses={"Max Health","Max Magicka","Spell Damage"},hasJewelry=false,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Stonefalls",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Flame Damage abilities."},
{name="Sithis' Touch",bonuses={"Max Health","Weapon Critical","Berserk"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Overland Set",dlc="Dark Brotherhood",zone="Gold Coast",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 688 Weapon Critical;(5 items) Using Blade of Woe grants Major Berserk for 6 seconds."},
{name="Shield Breaker",bonuses={"Max Stamina","Stamina Recovery","Weapon Damage","Damage Shield"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Weapon Damage;(5 items) Your Light and Heavy Attacks deal 2257 irresistible damage against enemies with a Damage Shield."},
{name="Spawn of Mephala",bonuses={"Max Stamina"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Stonefalls",dungeons={"Fungal Grotto II"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 1096 Max Stamina;(2 items) Fully charged heavy attacks have a 100% chance to create a web for 10 seconds. Web deals 1130 Magic Damage every 1.0 second and reduces Movement Speed by 50%."},
{name="Spectre's Eye",bonuses={"Max Magicka","Max Health","Evasion","Physical Resistance"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Coldharbour",traits=8,obtained={location="Coldharbour - Deathspinner's Lair"},displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1096 Max Magicka ;(4 items) Adds 1206 Max Health;(5 items) Gain Major Evasion for 3 seconds after casting a spell that costs Magicka. This effect can apply once every 6 seconds. Major Evasion increases Dodge chance by 15%."},
{name="SpellPower Cure",bonuses={"Max Magicka","Spell Damage","Weapon Damage","Courage"},hasJewelry=false,hasWeapons=false,weights={"Light"},type="Dungeon Drop",dlc="Imperial City",zone="Cyrodiil",dungeons={"White Gold Tower"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Healing an ally at 100% Health has a 50% chance of granting them 258 increased Weapon and Spell Damage for 10 seconds."},
{name="Spider Cultist Cowl",bonuses={"Max Magicka","Spell Damage","Max Health"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Stonefalls",dungeons={"Fungal Grotto I","Fungal Grotto II"},displayText="(2 items) Adds 1206 Max Health;3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your Destruction Staff abilities."},
{name="Song of Lamae",bonuses={"Physical Resistance","Max Health","Spell Resistance","Damage Shield"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=5,obtained={ad="Malabal Tor - Sleepy Senche Overlook",dc="Alik'r Desert - Rkulftzel",ep="Eastmarch - Tinkerer Tobin's Workshop",zones={"Malabal Tor","Alik'r Desert","Eastmarch"}},displayText="(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Max Health;(5 items) When Health drops below 30%, deal 5329 Magic Damage to the attacker and recover 3870 Health. This can only happen once every 30 seconds."},
{name="Stendarr's Embrace",bonuses={"Max Magicka","Magicka Recovery","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Eastmarch",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) When you heal a friendly target, you have a 50% chance to remove 5 negative effects from them. This can happen no more than once every 30 seconds."},
{name="Syrabane's Grip",bonuses={"Max Magicka","Magicka Recovery","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Grahtwood",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Magicka;(5 items) When you block a Flame, Frost, Shock or Magic Damage ability, you restore 860 Magicka. This effect can occur once every 1 second."},
{name="Tava's Favor",bonuses={"Max Health","Stamina Recovery","Magicka Recovery","Ultimate"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Thieves Guild",zone="Hew's Bane",traits=5,obtained={location="Hew's Bane - Forebear's Junction"},displayText="(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 129 Stamina Recovery;(4 Items) Adds 129 Magicka Recovery;(5 Items) When you dodge an attack you receive the blessing of Tava and gain 9 Ultimate over 3 seconds."},
{name="Thews of the Harbringer",bonuses={"Max Health","Spell Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Spell Damage;(5 items) When you successfully block an attack with no duration, you deal damage to your attacker equal to 4% of your Max Health."},
{name="Torug's Pact",bonuses={"Spell Damage","Max Health","Spell Resistance","Reduce Enchant Cooldown"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=2,obtained={ad="Grahtwood - Fisherman's Isle",dc="Stormhaven - Hammerdeath Workshop",ep="Deshaan - Lake Hiaalu Retreat",zones={"Grahtwood","Stormhaven","Deshaan"}},displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) Reduce weapon enchantment's internal cooldown by 1 second. Increases enchantment potency by 30%."},
{name="Treasure Hunter",bonuses={"Max Magicka","Spell Critical","Spell Damage","Prophecy"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="One Tamriel",zone="Rivenspire",dungeons={"Volenfell"},obtained={location="Volenfell"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 833 Spell Critical;(4 items) Adds 833 Spell Critical;(5 items) Gain Major Prophecy at all times, increasing your Spell Critical rating by 2191.;(5 items) Adds 100 Spell Damage"},
{name="Trinimac's Valor",bonuses={"Magicka Recovery","Max Magicka","Healing","Damage Shield"},hasJewelry=true,hasWeapons=false,weights={"Light"},type="Overland Set",dlc="Orsinium",zone="Wrothgar",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) 20% chance when you cast a Damage Shield on an ally to call down a fragment of Trinimac that heals allies and damages enemies in the area for 3667. Can only occur once every 3 seconds."},
{name="Trial by Fire",bonuses={"Max Health","Spell Resistance","Healing Taken","Elemental Resistance"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Orsinium",zone="Wrothgar",traits=3,obtained={location="Wrothgar - Malacath Statue"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 4% Healing Taken;(5 items) When you take elemental damage, gain 7727 Resistance to that element for 4 seconds. You can only be resistant to one element at a time."},
{name="Twice-Born Star",bonuses={"Max Health","Max Stamina","Max Magicka","Mundus Stone"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Craglorn",traits=9,obtained={location="Craglorn - Atelier of the Twice-Born Star"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) Allows you to have two Mundus Stone Boons at the same time."},
{name="Twilights Embrace",bonuses={"Max Health","Spell Critical","Spell Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=3,obtained={ad="Grahtwood - Vineshade Lodge",dc="StormHaven - Windridge Warehouse",ep="Deshaan - Avayan's Farm",zones={"Grahtwood","Deshaan","Stormhaven"}},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you are healed, gain 10% additional healing."},
{name="Twilights Remedy",bonuses={"Magicka Recovery","Aegis","Spell Damage","Force"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Thieves Guild",zone="Reaper's March",dungeons={"Maw of Lorkhaj"},displayText="(2 Items) Adds 129 Magicka Recovery;(3 Items) Grants Minor Aegis, causing you to take 5% less damage from Boss Monsters.;(4 Items) Adds 129 Spell Damage;(5 Items) When other players activate your synergies they are healed for 18920 over 10 seconds and gain Minor Force, increasing their Critical Strike damage by 12%."},
{name="Twin Sisters",bonuses={"Stamina Recovery","Max Stamina","Weapon Critical","Physical Damage"},hasJewelry=false,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Imperial City",zone="Auridon",displayText="(2 items) Adds 126 Stamina Recovery;(3 items) Adds 965 Max Stamina;(4 items) Adds 672 Weapon Critical;(5 items) When Blocking, 20% chance to cause attacker to bleed for 8820 Physical Damage over 8 seconds. Attacker must be within 5m."},
{name="Undaunted Infiltrator",bonuses={"Max Magicka","Weapon Critical","Heavy Attacks"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Imperial City",zone="Shadowfen",dungeons={"Arx Corinium"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 688 Weapon Critical;(5 items) After casting an ability that costs Magicka, Light Attacks deal 774 additional damage and Heavy Attacks deal 1161 additional damage for 10 seconds."},
{name="Valkyn Skoria",bonuses={"Max Health","Flame Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Base Game",zone="Greenshade",dungeons={"City of Ash II"},shouldersChest="Gilirion",displayText="(1 items) Adds 1206 Max Health;(2 items) 4% chance when damaging an enemy with a damage over time effect to call a meteor dealing 5805 Flame Damage to target and 3076 Flame Damage to other nearby enemies."},
{name="Vampire's Kiss",bonuses={"Health Recovery","Max Health","Healing Taken","Healing"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=5,obtained={ad="Malabal Tor - Matthild's Last Venture",dc="Alik'r Desert - Artisan's Oasisi",ep="Eastmarch - Crimson Kada's Crafting Cavern",zones={"Malabal Tor","Alik'r Desert","Eastmarch"}},displayText="(2 items) Adds 129 Health Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Killing an opponent heals you for 5160 over 6 seconds."},
{name="Vampire Lord",bonuses={"Max Magicka","Spell Damage","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Bangkorai",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) Adds 400 Spell Damage to your Vampire abilities. Reduces the cost of your Vampire abilities by 5%."},
{name="Varen's Legacy",bonuses={"Max Health","Max Stamina","Healing Taken"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dark Brotherhood",zone="Gold Coast",traits=7,obtained={location="Gold Coast - Strid River Artisan's Camp"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 4% Healing Taken;(5 items) 10% chance on Block that the next Area of Effect Attack you use will deal an additional 3450 Damage."},
{name="Vengeance Leech",bonuses={"Max Health","Healing","Magicka Recovery","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="Pvp Rewards/ Vendors"},displayText="(2 items) Adds 1206 Max Health;(3 items) When you kill an enemy, you heal for 1505 Health and restore 1505 Magicka and Stamina."},
{name="Vestements of the Warlock",bonuses={"Max Magicka","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Reaper's March",dungeons={"Selene's Web"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you fall below 33% Magicka, restore 9000 Magicka. This effect can occur once every 1 minute."},
{name="Vicecannon of Venom",bonuses={"Max Stamina","Weapon Damage","Stamina Recovery","Poison Damage","Healing"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Tel Var Set",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Your attacks from stealth inject a leeching poison that deals 13936 Poison Damage over 15 seconds and heals you for the damage done."},
{name="Vicious Death",bonuses={"Spell Damage","Max Magicka","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Thieves Guild",zone="Cyrodiil",displayText="(2 Items) Adds 129 Spell Damage;(3 Items) Adds 1096 Maximum Magicka;(4 Items) Adds 688 Spell Critical;(5 items) When you kill a player they violently explode for 16605 Flame Damage"},
{name="Vicious Serpent",bonuses={"Weapon Critical","Max Stamina","Reduce Stamina Cost","Weapon Damage","Expedition"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Trial Set",zone="Craglorn",dungeons={"Hel Ra Citidel","Aetherian Archive","Sanctum Ophidia"},dlc="Base Game",displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) Reduce the cost of Stamina abilities by 8%. When you kill an enemy, you restore 2075 Stamina and gain Major Expedition, increasing your Movement Speed by 30% for 8 seconds.;(5 items) Adds 129 Weapon Damage"},
{name="Ward of Cyrodiil",bonuses={"Stamina Recovery","Weapon Damage","Defile"},hasJewelry=false,hasWeapons=false,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Imperial City",zone="Cyrodiil",displayText="(2 items) Adds 129 Weapon Damage;(3 items) 129 Stamina Recovery;(4 items) 129 Stamina Recovery;(5 items) When you deal melee damage, you apply Major Defile to the enemy for 3 seconds, reducing their healing received and Health Recovery by 30%. This effect can occur once every 5 seconds."},
{name="Way of the Arena",bonuses={"Max Health","Max Magicka","Max Stamina","Break Free"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",zone="Craglorn",traits=8,obtained={location="Craglorn - Lanista's Waystation"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Stamina;(5 items) Reduce cost of Break Free by 40%."},
{name="Way of Martial Knowledge",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Base Game",zone="Craglorn",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage, you cause the enemy to take 10% additional damage from the next attack. This effect can occur once every 4 seconds."},
{name="Warrior's Fury",bonuses={"Max Health","Max Stamina","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Thieves Guild",zone="Cyrodiil",displayText="(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Stamina;(4 Items) Adds 129 Weapon Damage;(5 Items) When you take critical damage, your Weapon Damage is increased by 30 for 6 seconds. This effect can stack up to 25 times."},
{name="Willows Path",bonuses={"Magicka Recovery","Stamina Recovery","Health Recovery"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=6,obtained={ad="Reaper's March - Greenspeaker's Grove",dc="Bangkori - Viridian Hideaway",ep="The Rift - Smokefrost Vigil",zones={"Reaper's March","Bangkorai","The Rift"}},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Health Recovery;(5 items) Increase all recovery in combat by 15%."},
{name="Willpower",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="Imperial City",obtained={location="Bone Shards {Memorial}, Dark Ether {Arena}"},displayText="(2 items) Adds 1451 Max Magicka;(3 items) Adds 193 Spell Damage"},
{name="Winterborn",bonuses={"Magicka Recovery","Max Magicka","Spell Damage","Frost Damage"},hasJewelry=true,hasWeapons=false,weights={"Light"},type="Dungeon Drop",dlc="Orsinium",zone="Wrothgar",dungeons={"Maelstrom Arena"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage with a Cold Damage ability, you have an 8% chance to summon an ice pillar that deals 7967 Cold Damage to all enemies in a 3 meter radius. The ice pillar persists for 2 seconds and reduces the Movment Speed of all enemies within the radius by 60%."},
{name="Wise Mage",bonuses={"Spell Critical","Vulnerability"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",zone="Craglorn",dlc="Base Game",dungeons={"Sanctum Ophidia"},displayText="(2 items) Adds 833 Spell Critical;(3 items) Adds 833 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Enemies you damage with fully-charged Heavy Attacks are afflicted with Minor Vulnerability for 10 seconds, increasing their damage taken by 8%."},
{name="Whitestrake's Retribution",bonuses={"Max Health","Spell Resistance","Health Recovery","Damage Shield"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Base Game",traits=4,obtained={ad="Greenshade - Lenalda Pond",dc="Rivenspire - Westwind Lighthouse",ep="Shadowfen Weeping Wamasu Falls",zones={"Greenshade","Rivenspire","Shadowfen"}},displayText="(2 items) Adds 1206 Max Health ;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 129 Health Recovery;(5 items) If wearers Health is below 30%, gain a 10320 Damage Shield for 8 seconds. This effect can occur no more than once per 15 seconds."},
{name="Wrath of the Imperium",bonuses={"Spell Damage","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={},type="Accessory Set",dlc="One Tamriel",zone="Cyrodiil",obtained={location="PVP Rewards/ Vendors"},displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 833 Spell Critical"},
{name="Worm's Raiment",bonuses={"Spell Damage","Max Magicka","Healing Taken","Reduce Magic Cost"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Base Game",zone="Coldharbour",dungeons={"Vault's of Madness"},displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Magicka;(4 items) Adds 4% Healing Taken;(5 items) Reduce Magicka costs for up to 12 group members by 5%."},
{name="Ysgramor's Birthright",bonuses={"Max Health","Max Magicka","Spell Damage","Frost Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="One Tamriel",zone="The Rift",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Frost Damage abilities."},
{name="Netch's Touch",bonuses={"Max Magicka","Max Health","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="One Tamriel",zone="Deshaan",dungeons={"Darkshade Caverns I","Darkshade Caverns II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Shock Damage abilities."},
{name="Skooma Smuggler",bonuses={"Max Magicka","Magicka Recovery","Spell Damage","Expedition"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="One Tamriel",zone="Reaper's March",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 129 Spell Damage;(5 items) When you drink a potion, you gain Major Expedition for 30 seconds, increasing your Movement Speed by 30%."},
{name="Spinner's Garment's",bonuses={"Max Magicka","Spell Damage","Spell Penetration"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="One Tamriel",zone="Malabal Tor",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 3450 Spell Penetration"},
{name="Bone Pirate's Tatters",bonuses={"Max Stamina","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Bangkorai",dungeons={"Blackheart Haven"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) While you have a drink buff active, your Max Stamina is increased by 2000 and Stamina Recovery by 300."},
{name="Draugr Hulk",bonuses={"Max Stamina"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Eastmarch",dungeons={"Direfrost Keep"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;(5 items) Adds 2540 Max Stamina"},
{name="Jailbreaker",bonuses={"Max Stamina","Stamina Recovery","Expedition"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Auridon",dungeons={"Banished Cells I","Banished Cells II"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) Gain Minor Expedition at all times, increasing your Movement Speed by 10%."},
{name="Leviathan",bonuses={"Max Stamina","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Rivenspire",dungeons={"Crypt of Hearts I","Crypt of Hearts II"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Adds 1924 Weapon Critical"},
{name="Spelunker",bonuses={"Max Stamina","Max Health","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Glenumbra",dungeons={"Spindle Clutch I","Spindle Clutch II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon and Spell Damage to your Undaunted abilities. When an ally uses one of your Undaunted ability synergies you restore 1500 Stamina."},
{name="Spriggan's Thorns Set",bonuses={"Max Stamina","Weapon Damage","Physical Penetration"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Bangkorai",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 3450 Physical Penetration"},
{name="Strength of the Automaton",bonuses={"Max Stamina","Weapon Damage","Physical Damage","Max Health"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Deshaan",dungeons={"Darkshade Caverns I","Darkshade Caverns II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon Damage to your Physical Damage abilities."},
{name="Sword Singer",bonuses={"Max Stamina","Weapon Damage","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Alik'r Desert",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) Adds 400 Weapon Damage to your Two Handed abilities."},
{name="Sword Dancer",bonuses={"Max Stamina","Weapon Damage","Max Health"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="The Rift",dungeons={"Blessed Crucible"},displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 400 Weapon Damage to your Dual Wield abilities."},
{name="Toothrow",bonuses={"Max Stamina","Weapon Critical","Savagery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Stormhaven",dungeons={"Wayrest Sewers I","Wayrest Sewers II"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Gain Major Savagery at all times, increasing your Weapon Critical rating by 2191.;(5 items) Adds 100 Weapon Damage"},
{name="Armor of the Trainee",bonuses={"Max Stamina","Max Health","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Overland Set",dlc="One Tamriel",obtained={ad="Khenarthi's Roost",dc="Stros M'Kai Betnikh",ep="Bal Foyen",location="Starter Islands",zones={"Bal Foyen","Bleakrock Isle","Khenarthi's Roost","Stros M'Kai","Betnikh"}},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Stamina;(5 items) Increases your Max Health, Magicka and Stamina by 1250."},
{name="Beekeeper's Gear",bonuses={"Max Health","Health Recovery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Greenshade",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 129 Health Recovery;(5 items) Adds 400 Health Recovery"},
{name="Green Pact",bonuses={"Max Health","Health Recovery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Grahtwood",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 1206 Max Health;(5 items) While you have a food buff active, your Max Health is increased by 2500 and Health Recovery by 250."},
{name="Knight Errants Mail",bonuses={"Max Health","Max Stamina","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Bangkorai",dungeons={"Blackheart Haven"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) Adds 200 Weapon Damage to your One Hand and Shield abilities. When you use a One Hand and Shield ability, you heal for 1250 Health."},
{name="Medusa",bonuses={"Max Health","Max Magicka","Spell Damage","Force"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Shadowfen",dungeons={"Arx Corinium"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Gain Minor Force at all times, increasing your Critical Damage by 12%."},
{name="Order of Diagna",bonuses={"Max Health","Healing Taken","Vitality"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Alik'r Desert",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Gain Minor Vitality at all times, increasing your healing received by 8%."},
{name="Plague Doctor",bonuses={"Max Health","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Deshaan",displayText="(2 items) Adds 1206 Max Health;(2 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Adds 4000 Max Health"},
{name="Rattlecage",bonuses={"Max Health","Spell Damage","Sorcery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Coldharbour",dungeons={"Vault's of Madness"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Spell Damage;(5 items) Gain Major Sorcery at all times, increasing your Spell Damage by 20%.;(5 items) Adds 100 Spell Damage."},
{name="Shalk Exoskeleton",bonuses={"Max Health","Spell Damage","Ultimate","Heroism"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Stonefalls",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 688 Spell Critical;(5 items) Gain Minor Heroism at all times while in combat, generating 1.5 Ultimate every 1 seconds."},
{name="Vampire Cloak",bonuses={"Max Health","Spell Damage","Protection"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Rivenspire",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1206 Max Health;(5 items) Gain Minor Protection at all times, reducing your damage taken by 8%."},
{name="Chokethorn",bonuses={"Magicka Recovery","Healing"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Grahtwood",dungeons={"Elden Hollow I"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 129 Magica Recovery;(2 items) When you use a heal ability, you have a 15% chance to summon a strangler sapling that heals you or an ally for 19565 Health over 4 seconds. This effect can occur once every 10 seconds."},
{name="Grothdar",bonuses={"Max Magicka","Flame Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Coldharbour",dungeons={"Vault's of Madness"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Magicka;(2 items) When you deal damage, you have a 10% chance to create lava pools that swirl around you, dealing 2000 Flame Damage to all enemies within 8 meters of you every 1 second for 5 seconds. This effect can occur once every 10 seconds."},
{name="Iceheart",bonuses={"Spell Critical","Frost Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Eastmarch",dungeons={"Direfrost Keep"},shouldersChest="Gilirion",displayText="(1 items) Adds 688 Spell Critical;(2 items) When you deal Critical Damage, you have a 20% chance to gain a damage shield that absorbs 8600 damage for 6 seconds. While the damage shield holds, you deal 770 Frost Damage to all enemies within 5 meters of you every 1 second. This effect can occur once every 6 seconds."},
{name="Ilambris",bonuses={"Max Magicka","Flame Damage","Shock Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Rivenspire",dungeons={"Crypt of Hearts I"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Magicka;(2 items) When you deal Flame or Shock Damage, you have a 10% chance to summon a meteor shower of the damage type that deals 1300 Damage to all enemies within 4 meteres every 1 seconds for 5 seconds. Each effect can occur once every 8 seconds."},
{name="Infernal Gaurdian",bonuses={"Max Magicka","Flame Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Greenshade",dungeons={"City of Ash I"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Magicka;(2 items) When you use a damage shield ability, you have a 50% chance to lob 3 mortars over 2 seconds at the further enemy from you that each deal 5500 Flame Damage to all enemies within 5 meters of the blast area. This effect can occur once every 6 seconds."},
{name="Kra'gh",bonuses={"Physical Penetration","Physical Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Stonefalls",dungeons={"Fungal Grotto I"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 1935 Physical Penetration;(2 items) When you deal damage, you have a 10% chance to spawn dreugh limbs that create shockwaves in front of you dealing 1300 Physical Damage every 0.4 seconds for 1.2 seconds. This effect can occur once every 3 seconds."},
{name="Mighty Chudan",bonuses={"Spell Resistance","Physical Resistance","Max Health","Ward","Resolve"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Shadowfen",dungeons={"Ruins of Mazzatun"},shouldersChest="Urgalarg Chief-bane",obtained={location="Ruins of Mazzutun / Urgalarg Chief-bane"},displayText="(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) Gain Major Ward and Major Resolve at all times, increasing your Physical and Spell Resistance by 5280.;(2 items) Adds 1206 Max Health"},
{name="Pirate Skeleton",bonuses={"Physical Resistance","Spell Resistance","Protection","Defile"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Bangkorai",dungeons={"Blackheart Haven"},shouldersChest="Gilirion",displayText="(1 items) Adds 2975 Spell Resistance;(1 items) Adds 2975 Physical Resistance;(2 items) When you take damage, you have a 6% chance to transform into a skeleton and gain Major Protection and Minor Defile for 12 seconds, reducing your damage taken by 30% but reducing your healing received by 15%. This effect can occur once every 15 seconds."},
{name="Selene",bonuses={"Max Stamina","Physical Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Reaper's March",dungeons={"Selene's Web"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Stamina;(2 items) When you deal direct melee damage, you have a 15% chance to call on a primal spirit that mauls the closest enemy in front of you for 12000 Physical Damage. This effect can occur once every 4 seconds."},
{name="Sellistrix",bonuses={"Max Stamina","Physical Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Shadowfen",dungeons={"Arx Corinium"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Stamina;(2 items) When you deal damage, you have a 10% chance to create an earthquake under the enemy that errupts after 2 seconds, dealing 3870 Physical Damage to all enemies within 4 meters and stunning them for 3 seconds. This effect can occur once every 5 seconds."},
{name="Sentinel of Rkugamz",bonuses={"Healing","Stamina Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Deshaan",dungeons={"Darkshade Caverns I"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target, you have a 10% chance to summon a dwemer spider that heals for 1049 Health and restores 524 Stamina to you and your allies within 5 meters every 1 second for 8 seconds. This effect can occur once every 8 seconds."},
{name="Shadowrend",bonuses={"Magicka Recovery","Magic Damage","Maim"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Auridon",dungeons={"Banished Cells I"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 129 Magica Recovery;(2 items) When you deal damage, you have a 15% chance to summon a shadowy Clanfear for 15 seconds. The Clanfear's basic attack deals 3440 Magic Damage and apply Minor Maim to any enemy hit for 10 seconds, reducing their damage done by 15%. This effect can occur once every 15 seconds."},
{name="Slimecraw",bonuses={"Weapon Critical","Spell Critical","Berserk"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Stormhaven",dungeons={"Wayrest Sewers I"},shouldersChest="Maj Al-Ragath",displayText="(1 items) Adds 833 Weapon Critical;(1 items) Adds 833 Spell Critical;(2 items) Gain Minor Berserk at all times, increasing your damage done by 8%."},
{name="Stormfist",bonuses={"Stamina Recovery","Shock Damage","Physical Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Malabal Tor",dungeons={"Tempest Island"},shouldersChest="Gilirion",displayText="(1 items) Adds 129 Stamina Recovery;(2 items) When you deal damage, you have a 10% chance to create a thunderfist to crush the enemy, dealing 1500 Shock Damage every 1 second for 3 seconds to all enemies within 4 meters and a final 8000 Physical Damage when the fist closes. This effect can occur once every 8 seconds."},
{name="Swarm Mother",bonuses={"Stamina Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Glenumbra",dungeons={"Spindle Clutch I"},shouldersChest="Gilirion",displayText="(1 items) Adds 129 Stamina Recovery;(2 items) When you block an attack from an enemy that is further than 5 meters from you, you spin strands of spider silk to pull the enemy to you. This effect can occur once every 2 seconds."},
{name="Tremorscale",bonuses={"Max Stamina","Physical Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Rivenspire",dungeons={"Volenfell"},shouldersChest="Gilirion",displayText="(1 items) Adds 1096 Max Stamina;(2 items) When you taunt an enemy, you have a 50% chance to cause a duneripper to burst from the ground beneath them, dealing 6500 Physical Damage to all enemies within 4 meters after 1 second and reducing their Movement Speed by 70% for 3 seconds. This effect can occur once every 4 seconds."},
{name="Troll King",bonuses={"Health Recovery","Healing"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="The Rift",dungeons={"Blessed Crucible"},shouldersChest="Gilirion",displayText="(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target, if they are still below 60% Health, their Health Recovery is increased by 1548 for 10 seconds."},
{name="Velidreth",bonuses={"Weapon Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="One Tamriel",zone="Shadowfen",dungeons={"Cradle of Shadows"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 129 Weapon Damage;(2 items) When you deal damage, you have a 20% chance to spawn 3 disease spores in front of you that deal 10320 Disease Damage to the first enemy hit. This effect can occur once every 9 seconds."},
{name="Defending Warrior",bonuses={"Spell Resistance","Physical Resistance","Max Health","Magic Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Aetherian Archive"},displayText="(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1206 Maximum Health;(5 items) When you block an attack, you deal 4000 Magic Damage to all enemies within 10 meters of you and heal for 100% of the damage done. This effect can occur once every 10 seconds."},
{name="Healing Mage",bonuses={"Max Magicka","Magicka Recovery","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Aetherian Archive"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 2% Healing Done;(5 items) When you use an area of effect heal ability, you reduce the Weapon Damage of all enemies within 10 meters of you by 430 for 3 seconds."},
{name="Quick Serpent",bonuses={"Weapon Critical","Max Stamina","Reduce Cost","Expedition"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Aetherian Archive"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Stamina;(5 items) Reduces the cost of Stamina abilities by 8%. When you kill an enemy, you gain Major Expedition for 8 seconds, increasing your Movement Speed by 30%."},
{name="Twice-Fanged Serpent",bonuses={"Weapon Critical","Max Stamina","Weapon Damage","Physical Penetration"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Sanctum Ophidia"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage, your Physical Penetration is increased by 860 for 3 seconds, stacking up to 5 times."},
{name="Immortal Warrior",bonuses={"Healing Taken","Max Health","Resurrection"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Sanctum Ophidia"},displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you die, you instead turn into a statue for 3 seconds. While a statue, you are immune to all negative effects, but can still be healed. This effect can occur once every 20 minutes."},
{name="Poisonous Serpent",bonuses={"Max Stamina","Weapon Damage","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Hel Ra Citidel"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Max Stamina;(5 items) When you deal damage with a Light or Heavy Attack against an enemy who has a Poison Damage ability on them, you have a 50% chance to deal an additional 3400 Poison Damage."},
{name="Berserking Warrior",bonuses={"Weapon Damage","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="One Tamriel",zone="Craglorn",dungeons={"Hel Ra Citidel"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) When you deal melee damage, your Critical Strike rating is increased by 400 for 5 seconds, stacking up to 5 times."},
{name="Tormentor",bonuses={"Max Health","Healing Taken","Spell Resistance","Physical Resistance","Taunt"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Auridon",dungeons={"Banished Cells I","Banished Cells II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 4% Healing Taken;(5 items) When you deal damage with a Charge ability,you gain 3642 Physical and Spell Resistance and taunt the enemy to attack you for 15 seconds."},
{name="Undaunted Unweaver",bonuses={"Max Stamina","Spell Critical","Heavy Attacks"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="One Tamriel",zone="Bangkorai",dungeons={"Blackheart Haven"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Spell Critical;(5 items) When you use an ability that costs Stamina, your Light Attacks deal an additional 774 damage and Heavy Attacks deal an additional 1161 damage for 10 seconds."},
{name="Nikula's Heavy Armor",bonuses={"Spell Resistance","Max Health"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="The Rift",dungeons={"Blessed Crucible"},displayText="(2 items) Adds 1822 Spell Resistance;(3 items) Adds 1822 Spell Resistance;(4 items) Adds 1002 Max Health;(5 items) Blocking Projectile Spells has a 25% chance of Reflecting the spell on its caster."},
{name="Sunderflame",bonuses={"Max Stamina","Weapon Critical","Weapon Damage","Flame Damage","Reduce Enemy Physical Resistance"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Greenshade",dungeons={"City of Ash I","City of Ash II"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 688 Weapon Critical;(5 items) When you hit an enemy with a fully charged Heavy Attack, deal 4000 Flame Damage and applies Minor Breach and Minor Fracture to the enemy reduce target's Physical and Spell Resistance by 1320 for 8 seconds."},
{name="Embershield",bonuses={"Max Health","Spell Resistance","Flame Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Greenshade",dungeons={"City of Ash I","City of Ash II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Spell Resistance;(5 items) When you deal damage with a fully-charged Heavy Attack, you have a 50% chance to increase your Spell Resistance by 3440 and deal 1032 Flame Damage to all enemies within 5 meters every 1 second for 6 seconds."},
{name="Ebon Armory",bonuses={"Max Health","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Rivenspire",dungeons={"Crypt of Hearts I","Crypt of Hearts II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) Increase Max Health of up to 12 group members by 1118."},
{name="Armor of Truth",bonuses={"Weapon Critical","Max Stamina","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Deshaan",dungeons={"Darkshade Caverns I","Darkshade Caverns II"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you set an enemy off-balance, your Weapon Damage is increased by 450 for 10 seconds."},
{name="Ice Furnace",bonuses={"Max Magicka","Spell Critical","Weapon Damage","Flame Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Eastmarch",dungeons={"Direfrost Keep"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal direct damage with a Frost Damage ability, you have a 50% chance to deal an additional 1046 Flame Damage to all enemies within 8 meters around the initial target. This effect can occur once every 1 second."},
{name="Robes of Destruction Mastery",bonuses={"Max Magicka","Spell Critical","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="One Tamriel",zone="Craglorn",dungeons={"Dragon Star Arena"},displayText="(2 items) Adds 969 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) While you have a Destruction Staff equipped, your Max Magicka is increased by 2400."},
{name="Archer's Mind",bonuses={"Max Stamina","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Craglorn",dungeons={"Dragon Star Arena"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) Increases your Critical Damage done by 5%. Increases your Critical Damage done by an additional 10% when attacking from Sneak or invisibility."},
{name="Footmans Fortune",bonuses={"Max Health","Spell Resistance","Physical Resistance"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Craglorn",dungeons={"Dragon Star Arena"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) Increase block mitigation by 8%."},
{name="Undaunted Bastion",bonuses={"Max Health","Physical Resistance","Spell Resistance","Taunt"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Grahtwood",dungeons={"Elden Hollow I","Elden Hollow II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) When you taunt an enemy while you are under 60% Health, gain a damage shield that absorbs 13760 damage for 6 seconds. This effect can occur once every 10 seconds."},
{name="Barkskin",bonuses={"Max Health","Stamina Recovery","Physical Resistance","Healing"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Grahtwood",dungeons={"Elden Hollow I","Elden Hollow II"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1935 Physical Resistance;(5 items) Reduces the duration of immobilizations and snares on you by 50%. When an immobilization or snare is applied to you, heal for 2000 Health and restore 1000 Stamina. This effect can occur once every 5 seconds."},
{name="Viper's Sting",bonuses={"Weapon Critical","Max Stamina","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Grahtwood",dungeons={"Fungal Grotto I","Fungal Grotto II"},displayText="(2 items) Adds 672 Weapon Critical;(3 items) Adds 965 Max Stamina;(4 items) Adds 672 Weapon Critical;(5 items) Your Melee Attacks deal 6720 Poison damage over 4 seconds."},
{name="Hircine's Veneer",bonuses={"Max Stamina","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Reaper's March",dungeons={"Selene's Web"},displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost of all Stamina abilities by 4% for you and your group."},
{name="Durok's Bane",bonuses={"Max Health","Healing Taken","Health Recovery","Defile"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Reaper's March",dungeons={"Selene's Web"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 4% Healing Taken;(5 items) When you take damage, you apply Major Defile to the attacker for 4 seconds, reducing their healing received and Health Recovery by 30%. This effect can occur once every 8 seconds per enemy."},
{name="Storm Master",bonuses={"Weapon Critical","Weapon Damage","Shock Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Malabal Tor",dungeons={"Tempest Island"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal Critical Damage with a fully charged Heavy Attack, your Light Attacks deal additional 1333 Shock Damage for 20 seconds."},
{name="Jolting Arms",bonuses={"Max Health","Spell Resistance","Shock Damage","Spell Resistance"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="One Tamriel",zone="Malabal Tor",dungeons={"Tempest Island"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1935 Spell Resistance;(5 items) When you block an attack, you have a 50% chance to charge your arms, causing your next Bash attack to deal 5805 Shock Damage as well as granting yourself 6450 Spell Resistance for 6 seconds."},
{name="Oblivion's Edge",bonuses={"Weapon Critical","Weapon Damage","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="One Tamriel",zone="Coldharbour",dungeons={"Vault's of Madness"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) When killing an enemy, fill an empty Soul Gem and heal self for 1720;(5 items) Adds 129 Weapon Damage"},
{name="Syvarra's Scales",bonuses={"Max Health","Max Stamina","Max Magicka","Reduce Damage","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Overland Set",dlc="Thieves Guild",zone="Hew's Bane",displayText="(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Stamina;(3 Items) Reduces your damage taken from guards by 20%;(4 Items) Adds 1096 Maximum Magicka;(5 Items) When you deal damage, you have a 5% chance to cause a burst of lamia poison that deals 1096 Poison Damage in a 5 meter radius and an additional 5802 Poison Damage over 6 seconds to all enemies hit. This effect can occur once every 6.5 seconds."},
{name="Armor of the Veiled Heritance",bonuses={"Weapon Critical","Weapon Damage","Physical Resistance"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Auridon",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1935 Physical Resistance;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage, you have a 10% to increase your Weapon Damage by 400 for 5 seconds."},
{name="Seventh Legion Brute",bonuses={"Weapon Critical","Weapon Damage","Health Recovery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Bangkorai",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Health Recovery;(4 items) Adds 688 Weapon Critical;(5 items) When you take damage, you have a 10% chance to gain 500 Weapon Damage for 5 seconds and heal for 1260 Health."},
{name="Stygian",bonuses={"Spell Damage","Max Magicka","Max Stamina"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Coldharbour",displayText="(2 items) Adds 129 Spell Damage;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) While you are Sneaking or invisible, your Spell Damage and Max Magicka is increased by 20%."},
{name="Meridia's Blessed Armor",bonuses={"Physical Resistance","Spell Resistance","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Coldharbour",displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1935 Spell Resistance;(5 items) When you block an attack, you have a 33% chance to blind your attacker, causing them to miss all of their attacks for 5 seconds. This effect can occur once every 10 seconds."},
{name="Way of Air",bonuses={"Stamina Recovery","Weapon Damage","Spell Damage","Dodge"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Imperial City",zone="Craglorn",displayText="(2 items) Adds 126 Stamina Recovery;(3 items) Adds 126 Stamina Recovery;(4 items) Increases stealth detection radius by 2 meters;(5 items) When you use Roll Dodge, your Weapon and Spell Damage is increased by 344 for 6 seconds."},
{name="Way of Fire",bonuses={"Weapon Damage","Max Stamina","Weapon Critical","Flame Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Imperial City",zone="Craglorn",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage with a Weapon ability, you have a 20% chance to deal an additional 4000 Flame Damage. This effect can occur once every 2 seconds."},
{name="Fiord's Legacy",bonuses={"Weapon Critical","Weapon Damage","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Eastmarch",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Stamina Recovery;(5 items) Reduces the cost and increases the Movement Speed bonus of Sprint by 15%."},
{name="Akaviri Dragonguard",bonuses={"Magicka Recovery","Healing Taken","Max Health","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Eastmarch",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) Reduces the cost of Ultimate abilities by 15%."},
{name="Hide of the Werewolf",bonuses={"Max Health","Max Stamina","Weapon Damage","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Glenumbra",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Weapon Damage;(5 items) When you take damage, you generate 5 Ultimate. This effect can occur once every 5 seconds."},
{name="Wyrd Tree's Blessing",bonuses={"Magicka Recovery","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Glenumbra",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) Casting a spell has a 100% chance to remove 5 negative effect, this can occur every 15 seconds."},
{name="Ranger's Gait",bonuses={"Stamina Recovery","Max Stamina","Weapon Critical"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Grahtwood",displayText="(2 items) Adds 121 Stamina Recovery;(3 items) Adds 648 Weapon Critical;(4 items) Adds 911 Max Stamina;(5 items) Reduce the effectiveness of snares applied to you by 50%;(5 items) Adds 121 Stamina Recovery"},
{name="Wilderqueen's Arch",bonuses={"Stamina Recovery","Max Stamina","Weapon Critical","Bow"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Greenshade",displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) Bow attacks snare the target reducing their movement speed by 30% for 3 seconds."},
{name="Bahraha's Curse",bonuses={"Max Health","Max Magicka","Max Stamina","Reduce Damage","Magic Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Overland Set",dlc="Thieves Guild",zone="Hew's Bane",displayText="(2 Items) Adds 1206 Maximum Health;(3 Items) Adds 1096 Maximum Magicka;(4 Items) Take 40% less damage from traps;(4 Items) Adds 1096 Maximum Stamina;(5 Items) When you deal damage, you have a 25% chance to create desecrated ground for 5 seconds, which reduces the Movment Speed of enemies within by 70%, damages them for 1138 Magic Damage every 1 second and heals you for 100% of the damage done."},
{name="Salvation",bonuses={"Max Stamina","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Malabal Tor",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 1096 Max Stamina;(5 items) Savior's Hide Reduces cost of Werewolf Transformation by 33%. While in werewolf form Weapon Damage is increased by 150."},
{name="Thunderbug's Carapace",bonuses={"Physical Resistance","Spell Resistance","Spell Damage","Shock Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Malabal Tor",displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 129 Spell Damage;(5 items) When you take Physical Damage, you have a 50% chance to deal 5160 Shock Damage in a 5 meter radius around you. This effect can occur once every 3 seconds."},
{name="Soulshine",bonuses={"Max Magicka","Spell Critical","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Reaper's March",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Adds 450 Spell Damage to your cast time and channeled abilities."},
{name="Senche's Bite",bonuses={"Stamina Recovery","Max Stamina","Weapon Critical","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Reaper's March",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 688 Weapon Critical;(4 items) Adds 1096 Max Stamina;(5 items) When you use Roll Dodge, your Weapon Damage is increased by 420 and Weapon Critical by 657 for 5 seconds."},
{name="Swamp Raider",bonuses={"Max Stamina","Weapon Critical","Weapon Damage","Poison Damage","Disease Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Shadowfen",displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1096 Max Stamina;(5 items) Adds 400 Weapon Damage to your Poison and Disease Damage abilities."},
{name="Hatchling's Shell",bonuses={"Physical Resistance","Spell Resistance","Max Health","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Shadowfen",displayText="(2 items) Adds 1935 Physical Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1206 Max Health;(5 items) Gain a damage shield equal to 20% of your Max Health for 15 seconds every 15 seconds."},
{name="Shadow of the Red Mountain",bonuses={"Weapon Damage","Max Stamina","Weapon Critical","Flame Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Stonefalls",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When you deal damage with a Weapon ability, you have a 10% chance to deal an additional 8400 Flame Damage. This effect can occur once every 2 seconds."},
{name="Dreamer's Mantle",bonuses={"Max Health","Max Magicka","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="One Tamriel",zone="Stormhaven",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Magicka;(5 items) When you take damage while you are under 35% Health, you knockdown all enemies within 4 meters of you for 2 seconds and heal for 7000 Health. This effect can occur once every 20 seconds."},
{name="Night Terror",bonuses={"Max Stamina","Max Health","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="Stormhaven",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Reduces the radius you can be detected while Sneaking by 2 meters. Reduces the cost of Sneak cost by 26%;(4 items) Adds 1206 Max Health;(5 items) When you take melee damage, you deal 2000 Poison Damage to the attacker. This effect can occur once every 1 second."},
{name="Storm Knight's Plate",bonuses={"Spell Resistance","Max Health","Shock Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="One Tamriel",zone="Stormhaven",displayText="(2 items) Adds 1935 Spell Resistance;(3 items) Adds 1935 Spell Resistance;(4 items) Adds 1206 Max Health;(5 items) When you take non-physical damage, you have a 10% chance to deal 4374 Shock Damage all to all enemies within 5 meters of you every 2 seconds for 6 seconds. This effect can occur once every 6 seconds."},
{name="Witchman Armor",bonuses={"Stamina Recovery","Weapon Damage","Max Health","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="One Tamriel",zone="The Rift",displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 129 Weapon Damage;(4 items) Adds 1206 Max Health;(5 items) When you use an Ultimate ability, you heal for 30 Health and you restore 30 Stamina per point of the Ultimate's cost."},
{name="Amber Plasm",bonuses={"Max Magicka","Spell Critical","Spell Damage","Magicka Recovery","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Ruins of Mazzatun"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 688 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) Adds 250 Stamina Recovery;(5 items) Adds 250 Magicka Recovery"},
{name="Gossamer",bonuses={"Max Magicka","Magicka Recovery","Evasion"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Cradle of Shadows"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) When you heal a friendly target, you have a 10% chance to grant them Major Evasion, for 6 seconds, increaseing their dodge chance by 15%."},
{name="Heem-Jas' Retribution",bonuses={"Stamina Recovery","Max Stamina","Weapon Critical","Berserk"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Ruins of Mazzatun"},displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 688 Weapon Critical;(5 items) When an enemy within 28 meters of you dies, you gain Major Berserk, increasing your damage done by 25% for 3 seconds."},
{name="Widowmaker",bonuses={"Max Stamina","Weapon Critical","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Cradle of Shadows"},displayText="(2 items) Adds 688 Weapon Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 1096 Max Stamina;(5 items) When your alchemical poison fires, deal 7740 Poison Damage to all enemies within 5 meters of you."},
{name="Aspect of Mazzatun",bonuses={"Max Stamina","Max Health","Max Magicka","Healing"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Ruins of Mazzatun"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) When you fall below 30% Health, heal for 7052 Health and gain 6020 Magicka and Stamina. This effect can occur once every 45 seconds."},
{name="Hand of Mephala",bonuses={"Max Health","Healing Taken","Physical Resistance","Poison Damage","Fracture"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Shadows of the Hist",zone="Shadowfen",dungeons={"Cradle of Shadows"},displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 1935 Physical Resistance;(5 items) When you take damage, you have a 10% chance to cast a web around you for 5 seconds, reducing the Movement Speed of enemies within by 50%. After 5 seconds the web bursts in to venom, dealing 2580 Poison Damage and applying Minor Fracture to any enemy hit for 5 seconds, reducing their Physical Resistance by 1320."},
{name="Defiler",bonuses={"Weapon Damage","Weapon Critical","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Morrowind",zone="Vvardenfell",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 688 Weapon Critical;(4 items) Adds 688 Weapon Critical;(5 items) When you deal Critical Damage, you have an {8%} chance to summon a Hunger that spews poison to all enemies in front of it, dealing {9999} Poison Damage and stunning enemies hit for 5 seconds. This effect can occur once every 5 seconds."},
{name="War Maiden",bonuses={"Spell Critical","Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Morrowind",zone="Vvardenfell",displayText="(2 items) Adds 688 Spell Critical;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Spell Damage;(5 items) Adds 400 Spell Damage to your Magic Damage abilities"},
{name="Warrior-Poet",bonuses={"Max Health","Spell Resistance","Physical Resistance","Toughness"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Morrowind",zone="Vvardenfell",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 2??? Spell Resistance;(4 items) Adds 2??? Physical Resistance;(5 items) Gain Minor Toughness at all times, increasing your Max Health by 10%."},
{name="Assassin's Guile",bonuses={"Spell Critical","Weapon Critical","Spell Damage","Weapon Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Morrowind",zone="Vvardenfell",traits=3,obtained={location="Vvardenfell"},displayText="(2 items) Adds 688 Spell Critical;(3 items) Adds 688 Weapon Critical;(4 items) Adds 129 Spell Damage and Weapon Damage;(5 items) Increases the duration of your alchemical poisons by 4 seconds."},
{name="Shacklebreaker",bonuses={"Spell Damage","Weapon Damage","Magicka Recovery","Stamina Recovery","Max Stamina","Max Magicka"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",zone="Vvardenfell",dlc="Morrowind",traits=6,obtained={location="Vvardenfell"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery and Stamina Recovery;(5 items) Adds 2000 Max Magicka and Max Stamina."},
{name="Daedric Trickery",bonuses={"Max Health","Max Stamina","Max Magicka","Expedition","Mending","Protection","Heroism","Vitality"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Morrowind",zone="Vvardenfell",traits=8,obtained={location="Vvardenfell"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) While in combat you gain one of 5 random Major Buffs for 10 seconds every 20 seconds. Eligible buffs are Expedition, Protection, Mending, Heroism, or Vitality."},
{name="Coward's Gear",bonuses={"Max Health","Stamina Recovery","Expedition","Protection"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Battlegrounds Set",dlc="Morrowind",zone="Battlegrounds",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Stamina Recovery;(5 items) While Sprinting you gain Major Expedition and Major Protection, increasing your Movement Speed by 20% and reducing your damage taken by 30%."},
{name="Knight Slayer",bonuses={"Max Health","Spell Damage","Max Magicka","Oblivion Damage","Heavy Attacks"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Battlegrounds Set",dlc="Morrowind",zone="Battlegrounds",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1206 Max Health;(5 items) Your fully-charged Heavy Attacks against Players deal and additional 10% of their Max Health as Oblivion Damage."},
{name="Impregnable Armor",bonuses={"Max Health","Max Magicka","Max Stamina","Critical Resistance"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Battlegrounds Set",zone="Battlegrounds",dlc="Morrowind",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1096 Max Magicka;(5 items) Adds 2000 Critical Resistance."},
{name="Vanguard's Challenge",bonuses={"Max Health","Healing Taken","Taunt"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Battlegrounds Set",dlc="Morrowind",zone="Battlegrounds",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you taunt an enemy Player, they deal 50% less damage to all other Players but 100% more damage to you for 15 seconds."},
{name="Wizard's Riposte",bonuses={"Max Health","Spell Damage","Magicka Recovery","Maim"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Battlegrounds",dlc="Morrowind",zone="Vvardenfell",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 129 Magicka Recovery;(5 items) When you take direct Critical Damage you apply Minor Maim to the enemy for 5 seconds, reducing their damage done by 15%."},
{name="Automated Defense",bonuses={"Max Health","Aegis","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="Morrowind",zone="Vvardenfell",dungeons={"Halls of Fabrication"},displayText="(2 items) Adds 1206 Max Health;(3 items) Gain Minor Aegis at all times;(4 items) Adds 4% Healing Taken;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Aegis for 10 seconds, reducing your damage taken from Dungeons and Trials Monsters by 15%"},
{name="Inventor's Gaurd",bonuses={"Magicka Recovery","Aegis","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Morrowind",zone="Vvardenfell",dungeons={"Halls of Fabrication"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Gain Minor Aegis at all times;(4 items) Adds 2% Healing Done;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Aegis for 10 seconds, reducing your damage taken from Dungeons and Trials Monsters by 15%."},
{name="Master Architect",bonuses={"Max Magicka","Slayer","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Morrowind",zone="Vvardenfell",dungeons={"Halls of Fabrication"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Gain Minor Slayer at all times;(4 items) Adds 129 Spell Damage;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Slayer for 10 seconds, increasing your damage done to Dungeons and Trials Monsters by 15%."},
{name="War Machine",bonuses={"Max Stamina","Slayer","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Trial Set",dlc="Morrowind",zone="Vvardenfell",dungeons={"Halls of Fabrication"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Gain Minor Slayer at all times;(4 items) Adds 129 Weapon Damage;(5 items) When you use an Ultimate ability, you and the closest 2 allies within 28 meters of you gain Major Slayer for 10 seconds, increasing your damage done to Dungeons and Trials Monsters by 15%."},
{name="Draugr's Rest",bonuses={"Max Magicka","Magicka Recovery","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Falkreath Hold"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 2% Healing Done;(5 items) When you deal damage with a fully-charged Heavy Attack, you create a circle of consecrated ground that heals you and your allies within 5 meters for 11,000 Health over 10 seconds. This effect can occur once every 10 seconds."},
{name="Pillar of Nirn",bonuses={"Max Stamina","Weapon Critical","Weapon Damage","Physical Damage","Bleed"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Falkreath Hold"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 833 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) When you deal damage, you have a 10% chance to create a fissure underneath the enemy after 1 second, dealing 2,000 Physical Damage to all enemies within 2.5 meters and causing them to bleed for an additional 8,000 Physical Damage over 10 seconds. This effect can occur once every 10 seconds."},
{name="Ironblood",bonuses={"Max Health","Physical Resistance","Spell Resistance","Protection"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Falkreath Hold"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 2975 Physical Resistance;(4 items) Adds 2975 Spell Resistance;(5 items) When you take damage, you have an 8% chance to turn your blood into pure iron and gain Major Protection for 10 seconds, reducing your damage taken by 30%, but your Movement Speed is reduced by 50%. This effect can occur once every 15 seconds."},
{name="Domihaus",bonuses={"Max Stamina","Max Magicka","Flame Damage","Physical Damage","Spell Damage","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Monster Set",shouldersChest="Urgalarg Chief-bane",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Falkreath Hold"},displayText="(1 items) 1096 Max Stamina;(1 items) 1096 Max Magicka;(2 items) When you deal damage, you have a 15% chance to create either a ring of fire or a ring of molten earth around you for 10 seconds, which deals 1,000 Flame Damage or 1,000 Physical Damage every 1 second. Standing within the ring grants you 200 Spell Damage or 200 Weapon Damage. This effect can occur once every 15 seconds."},
{name="Flame Blossom",bonuses={"Max Magicka","Spell Damage","Spell Penetration","Flame Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Bloodroot Forge"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1487 Spell Penetration;(5 items) When you deal damage, you have a 10% chance to summon a line of flame that moves forward, dealing 8,000 Flame Damage to any enemy in its path. This effect can occur once every 10 seconds."},
{name="Blooddrinker",bonuses={"Weapon Critical","Weapon Damage","Bleed"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Bloodroot Forge"},displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 129 Weapon Damage;(4 items) Adds 833 Weapon Critical;(5) Increases the damage you deal with bleed damage over time effects by 20%."},
{name="Hagraven's Garden",bonuses={"Max Health","Health Recovery","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Bloodroot Forge"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Health Recovery;(4 items) Adds 4% Healing Taken;(5 items) When you take damage while under 50% Health, you summon a preservation of nature around you for 5 seconds. Any damage you take from enemies outside of the preservation is reduced by 50%, and the first time an enemy tries to enter the preservation they are knocked back 5 meters. This effect can occur once every 45 seconds."},
{name="Earthgore",bonuses={"Healing"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Monster Set",shouldersChest="Urgalarg Chief-bane",dlc="Horns of the Reach",zone="Vvardenfell",dungeons={"Bloodroot Forge"},displayText="(1 items) Adds 2% Healing Done;(2 items) When you heal a friendly target that is under 50% Health you conjure a pool of quenching blood underneath them, which soaks up 1 enemy placed effect instantly and heals all friendly targets in the area for 30000 Health over 6 seconds. This effect can occur once every 35 seconds."},
{name="Mad Tinkerer",bonuses={"Spell Critical","Spell Damage","Shock Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Clockwork City",zone="Clockwork City",displayText="(2 items) Adds 833 Spell Critical;(3 items) Adds 833 Spell Critical;(4 items) Adds 129 Spell Damage;(5 items) When you deal damage, you have a 10% chance to summon a Verminous Fabricant that charges the nearest enemy, dealing 10,000 Shock Damage to all enemies in its path, knocking them into the air, and stunning them for 2 seconds. This effect can occur once every 10 seconds."},
{name="Unfathomable Darkness",bonuses={"Weapon Critical","Physical Penetration","Weapon Damage","Physical Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Clockwork City",zone="Clockwork City",displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 1487 Physical Penetration;(4 items) Adds 129 Weapon Damage;(5 items) When you deal damage, you have a 10% chance to call a murder of crows around you for 12 seconds. Every 3 seconds a crow will be sent to peck the closest enemy within 12 meters of you, dealing 4000 Physical Damage. This effect can occur once every 15 seconds."},
{name="Livewire",bonuses={"Healing Taken","Max Health","Healing"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Clockwork City",zone="Clockwork City",displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you take damage, you have a 25% chance to overload your circuits, applying Concussion to enemies within 8 meters of you and healing for 1000 Health for each enemy hit. This effect can occur once every 10 seconds."},
{name="Innate Axiom",bonuses={"Max Stamina","Max Magicka","Spell Critical","Weapon Critical","Spell Damage","Weapon Damage"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Clockwork City",zone="Clockwork City",traits=2,obtained={location="The Refurbishing Yard - Clockwork City"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Stamina;(4 items) Adds 833 Spell Critical and 833 Weapon Critical.;(5 items) Adds 400 Spell and Weapon Damage to your Class abilities."},
{name="Fortified Brass",bonuses={"Max Health","Physical Resistance","Spell Resistance"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Clockwork City",zone="Clockwork City",traits=4,obtained={location="Restricted Brassworks - Clockwork City"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 2975 Physical Resistance;(4 items) Adds 2975 Spell Resistance.;(5 items) Adds 5170 Physical Resistance and 5170 Spell Resistance."},
{name="Mechanical Acuity",bonuses={"Weapon Damage","Spell Damage","Max Magicka","Max Stamina","Spell Critical","Weapon Critical"},hasJewelry=false,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Clockwork City",zone="Clockwork City",traits=6,obtained={location="Pavillion of Artifice - Clockwork City"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 129 Spell Damage;(4 items) Adds 1096 Max Stamina and 1096 Max Magicka.;(5 items) When you deal direct damage, you have a 15% chance to gain unerring mechanical vision for 5 seconds, causing your attacks to always be a Critical Strike. This effect can occur once every 18 seconds."},
{name="Caluurion's Legacy",bonuses={"Spell Critical","Spell Damage","Flame Damage","Shock Damage","Frost Damage","Disease Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Fang Lair"},displayText="(2 items) Adds 833 Spell Critical;(3 items) Adds 129 Spell Damage;(4 items) Adds 833 Spell Critical;(5 items) When you deal Critical Damage with a single target Magicka ability, you launch a Fire, Ice, Shock, or Disease ball at your target that deals 12,900 damage and applies a status effect. This effect can occur once every 10 seconds."},
{name="Jorvuld's Guidance",bonuses={"Magicka Recovery","Healing","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Scalecaller Peak"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 2% Healing Done;(5 items) Increases the duration of all Major buffs, Minor buffs, and damage shields you apply to yourself and allies by 40%."},
{name="Trappings of Invigoration",bonuses={"Stamina Recovery","Max Stamina"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Fang Lair"},displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) When you cast an ability while under 33% Stamina, you restore 9000 Stamina. This effect can occur once every 1 minute."},
{name="Plague Slinger",bonuses={"Weapon Damage","Max Health","Poison Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Scalecaller Peak"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Weapon Damage;(5 items) When you take damage, you summon a Skeever corpse which will launch a poison ball that deals 5160 Poison Damage every 1.5 seconds at the nearest enemy for 6 seconds. This effect can occur once every 15 seconds."},
{name="Ulfnor's Favor",bonuses={"Max Health","Magicka Recovery","Stamina Recovery","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Fang Lair"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Adds 4% Healing Taken;(5 items) Increases the Magicka or Stamina your Heavy Attacks restore by 30%."},
{name="Curse of Doylemish",bonuses={"Max Health","Spell Damage","Weapon Damage","Physical Damage","Taunt"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Dragon Bones",zone="",dungeons={"Scalecaller Peak"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 1206 Max Health;(4 items) Adds 129 Spell Damage;(4 items) Adds 129 Weapon Damage;(5 items) When you hit a taunted monster with a fully-charged Heavy Attack or any enemy that is stunned or immobilized with a fully-charged Heavy Attack, you deal an additional 12040 Physical Damage. This effect can occur once every 7 seconds."},
{name="Thurvokun",bonuses={"Max Health","Disease Damage","Maim","Defile"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Dragon Bones",zone="",dungeons={"Fang Lair"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 1206 Max Health;(2 items) When a nearby enemy damages you, summon a growing pool of desecrated bile for 8 seconds. Enemies in the bile receive 430 Disease Damage every 1 second and are afflicted with Minor Maim and Minor Defile, reducing their damage done and healing received by 15%. This effect can occur once every 8 seconds."},
{name="Zaan",bonuses={"Spell Critical","Flame Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Dragon Bones",zone="",dungeons={"Scalecaller Peak"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 833 Spell Critical;(2 items) When you deal Critical Damage with a Light or Heavy Attack to a nearby enemy, a beam of fire will connect you to your enemy. The beam deals 3440 Flame Damage every 1 second for 5 seconds. Every second, this damage increases by 50%. The beam is broken if the enemy moves 8 meters away from you. This effect can occur every 15 seconds."},
{name="Adept Rider",bonuses={"Spell Resistance","Physical Resistance","Max Health","Evasion","Physical Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Summerset",zone="Summerset Isle",traits=3,obtained={location="Northern Shimmerene Summerset Isle"},displayText="(2 Items) 2975 Spell Resist;(3 Items) 2975 Physical Resist;(4 Items) 1206 Max Health;(5 Items) While mounted, you gain Major Evasion, increasing your dodge chance by 15%. Dismounting spawns a dust cloud at your position for 12 seconds that deals 1436 Physical Damage every 1 second to enemies who stand inside it. You and group members inside the dust cloud gain Major Evasion. The dust cloud can be created once every 12 seconds."},
{name="Sload's Semblance",bonuses={"Max Magicka","Max Stamina","Spell Damage","Weapon Damage","Oblivion Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Summerset",zone="Artaeum",traits=6,obtained={location="Artaeum"},displayText="(2 items) Adds 1096 Maximum Magicka;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 129 Spell Damage;(4 items) Adds 129 Weapon Damage;(5 items) Damaging an enemy has a 10% chance to put a Leeching Shadow on them, dealing 853 Oblivion Damage every 1 second for 6 seconds. This effect can occur every 6 seconds."},
{name="Nocturnal's Favor",bonuses={"Stamina Recovery","Max Health","Dodge","Healing"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Summerset",zone="Summerset Isle",traits=9,obtained={location="Summerset Isle"},displayText="(2 items) Adds 129 Stamina Recovery;(3 items) Adds 1206 Max Health;(4 items) Adds 1206 Max Health;(5 items) Whenever you successfully Dodge, heal yourself for 4000. This effect can occur every 2 seconds."},
{name="Mantle of Siroria",bonuses={"Spell Damage","Slayer","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Summerset",zone="Summerset Isle",dungeons={"Cloudrest"},displayText="(2 items) Adds 129 Spell Damage;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%;(4 items) Adds 1096 Maximum Magicka;(5 items) Dealing direct damage to an enemy with a single target ability creates a ring of fire beneath you for 10 seconds. Standing in the ring grants you a stack of Siroria's Boon for 5 seconds. Each stack increases your Spell Damage by 30. 20 stacks max."},
{name="Vestment of Olorime",bonuses={"Magicka Recovery","Aegis","Courage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Trial Set",dlc="Summerset",zone="Summerset Isle",dungeons={"Cloudrest"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon and Trial Monsters by 5%;(4 items) Adds 129 Magicka Recovery;(5 items) Casting ground effect abilities in combat will create a circle of might on the ground for 10 seconds. You and your allies in the circle gain Major Courage for 30 seconds, increasing your Weapon and Spell Damage by 258 for 30 seconds. This effect can occur every 10 seconds."},
{name="Arms of Relequen",bonuses={"Weapon Critical","Slayer","Physical Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Trial Set",dlc="Summerset",zone="Summerset Isle",dungeons={"Cloudrest"},displayText="(2 items) Adds 833 Weapon Critical;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon and Trial Monsters by 5%;(4 items) Adds 833 Weapon Critical;(5 items) Your Light and Heavy attacks apply a stack of harmful winds to your target for 5 seconds. Harmful winds deal 378 Physical Damage every 1 second. Each stack increases the damage by 189 Physical Damage. 20 stacks max."},
{name="Aegis of Galanwe",bonuses={"Max Health","Aegis","Healing Taken"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Trial Set",dlc="Summerset",zone="Summerset Isle",dungeons={"Cloudrest"},displayText="(2 items) Adds 1206 Max Health;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon and Trial Monsters by 5%;(4 items) Adds 4% Healing Taken;(5 items) After successfully blocking, you have a 50% chance to grant Empower to 3 allies within 15 meters, increasing the damage of their next Light Attack by 40%. This effect can occur every 1 seconds."},
{name="Wisdom of Vanus",bonuses={"Max Magicka","Magicka Recovery","Mending"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Summerset",zone="Summerset Isle",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Magicka Recovery;(4 items) Adds 1096 Max Magicka;(5 items) After landing a Full Heavy Attack, gain Major Mending for 3 seconds, increasing your healing done by 25%. This duration is increased with each rank of the Restoration Staff Passive Essence Drain when using a Restoration Staff."},
{name="Gryphon's Ferocity",bonuses={"Weapon Critical","Weapon Damage","Force","Expedition"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Summerset",zone="Summerset Isle",displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 833 Weapon Critical;(4 items) Adds 129 Weapon Damage;(5 items) After dealing direct damage, gain Minor Force and Minor Expedition for 3 seconds, increasing your Critical Damage done by 10% and increasing your Movement Speed by 10%."},
{name="Grace of Gloom",bonuses={"Max Health","Evasion","Healing Taken","Healing"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Summerset",zone="Summerset Isle",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) When you take damage from a single target direct attack or ability, you have a 10% chance to become a living shadow, causing your light and heavy attacks to heal you for 3440 and gaining Major Evasion for 5 seconds, increasing your dodge chance by 15%. This effect can occur every 15 seconds."},
{name="Moon Hunter",bonuses={"Spell Damage","Spell Critical"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Wolfhunter",zone="Reaper's March",dungeons={"Moon Hunter Keep"},displayText="(2 items) 129 Spell Damage;(3 items) 129 Spell Damage;(4 items) 833 Spell Critical;(5 items) When your alchemical poison fires, increase your Spell Damage by 600 for 6 seconds."},
{name="Savage Werewolf",bonuses={"Max Stamina","Weapon Damage","Physical Damage","Bleed"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Wolfhunter",zone="Reaper's March",dungeons={"Moon Hunter Keep"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 129 Weapon Damage;(4 items) Adds 129 Stamina Recovery;(5 items) Your Light and Heavy Attacks rend flesh, causing your enemy to bleed for 1000 Physical Damage every 2 seconds for 6 seconds."},
{name="Jailer's Tenacity",bonuses={"Healing Taken","Max Health","Vitality"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Wolfhunter",zone="Reaper's March",dungeons={"Moon Hunter Keep"},displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) When you lose 7000 or more Health from a single attack, you gain Major Vitality for 6 seconds, increasing your healing received by 30%."},
{name="Vykosa",bonuses={"Healing Taken","Maim","Taunt"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Wolfhunter",zone="Reaper's March",dungeons={"Moon Hunter Keep"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 4% Healing Taken;(2 items) When you Bash an enemy you have taunted, you frighten them with a deafening howl, applying Major Maim to them for 3 seconds, lowering their damage done by 30%. This effect can occur once every 15 seconds."},
{name="Hanu's Compassion",bonuses={"Max Magicka","Magicka Recovery","Heroism"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dlc="Wolfhunter",zone="Greenshade",dungeons={"March of Sacrifices"},displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Magicka Recovery;(5 items) When you resurrect another player while in combat, you and the player gain Major Heroism for 15 seconds, granting you 3 Ultimate every 1.5 seconds."},
{name="Blood Moon",bonuses={"Weapon Critical","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dlc="Wolfhunter",zone="Greenshade",dungeons={"March of Sacrifices"},displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 833 Weapon Critical;(4 items) Adds 833 Weapon Critical;(5 items) When you deal Critical Damage with a melee Light Attack, you gain a stack of Blood Scent for 8 seconds. When you gain 5 stacks, you become Frenzied for 5 seconds, increasing your melee Light Attack damage by 30% and attack speed by 50%. This effect can occur every 18 seconds."},
{name="Haven of Ursus",bonuses={"Max Health","Healing Taken","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Dungeon Drop",dlc="Wolfhunter",zone="Greenshade",dungeons={"March of Sacrifices"},displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 4% Healing Taken;(4 items) Adds 1206 Max Health;(5 items) When you take damage while you are under 50% Health, summon Ursus's spirit for 6 seconds. You or an ally can activate a synergy on Ursus to grant you a shield that protects you and the activator from 13954 damage for 6 seconds. This effect can occur once every 12 seconds."},
{name="Balorgh",bonuses={"Weapon Damage","Spell Damage","Ultimate"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Wolfhunter",zone="Greenshade",dungeons={"March of Sacrifices"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 129 Weapon Damage;(1 items) Adds 129 Spell Damage;(2) When you use an Ultimate ability, you gain Weapon and Spell Damage for 10 seconds equal to twice the amount of total Ultimate consumed."},
{name="Bright-Throat's Boast",bonuses={"Max Magicka","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Murkmire",zone="Murkmire",displayText="(2 items) Adds 1096 Max Magicka ;(3 items) Adds 1096 Max Magicka;(4 items) 129 Magicka Recovery;(5 items) While you have a drink buff active, your Max Magicka is increased by 2000 and Magicka Recovery 150."},
{name="Dead-Water's Guile",bonuses={"Weapon Damage","Max Health","Max Stamina","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Murkmire",zone="Murkmire",displayText="(2 items) Adds 129 Weapon Damage ;(3 items) Adds 1206 Max Health;(4 items) 1096 Max Stamina;(5 items) When an enemy dies within 2 seconds of being damaged by you, you gain 5 Ultimate."},
{name="Champion of the Hist",bonuses={"Weapon Damage","Max Stamina","Heroism"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Murkmire",zone="Murkmire",displayText="(2 items) Adds 129 Weapon Damage ;(3 items) Adds 1096 Max Stamina;(4 items) 1096 Max Stamina;(5 items) Gain Minor Heroism at all times while you are in combat, generating 1 Ultimate every 1.5 seconds."},
{name="Grave-Stake Collector",bonuses={"Max Health","Max Magicka","Max Stamina","Magicka Recovery","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Murkmire",zone="Murkmire",traits="?",obtained={location="Murkmire"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Stamina;(4 items) Adds 1206 Max Health;(5 items) Enemies you've damaged have a 10% chance to drop a grave-stake for 6 seconds after they've died. Touching the grave-stake restores 6500 Stamina and Magicka. Only one grave-stake can appear at a time."},
{name="Naga Shaman",bonuses={"Healing Taken","Healing","Max Magicka","Mending","Vitality"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Murkmire",zone="Murkmire",traits="?",obtained={location="Murkmire"},displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 2% Healing Done;(4 items) Adds 1096 Max Magicka;(5 items) When you cast a damage shield ability, you gain Minor Mending and Minor Vitality for 6 seconds, increasing your healing done and healing received by 8%. This effect can occur once every 6 seconds."},
{name="Might of the Lost Legion",bonuses={"Max Stamina","Max Magicka","Weapon Damage","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Murkmire",zone="Murkmire",traits="?",obtained={location="Murkmire"},displayText="(2 items) Adds 1096 Max Stamina;(3 items) 1096 Max Magicka;(4 items) Adds 129 Weapon Damage;(5 items) After successfully blocking, gain 3 uses of Empower, increasing the damage of your next 3 Light Attacks by 40%."},
{name="Indomitable Fury",bonuses={"Protection","Heroism","Ultimate","Max Magicka","Stamina Recovery","Break Free"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Max Magicka;(3 items) Max Magicka; (4 items) Stamina Recovery;(5 items) After Breaking Free, gain Minor Protection and Minor Heroism for 7 seconds, reducing your damage taken by 8% and generating 1 Ultimate every 1.5 seconds."},
{name="Spell Strategist",bonuses={"Max Magicka","Spell Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Max Magicka; (3 items) Spell Damage;(4 items) Spell Damage;(5 items) When you deal damage with a Light Attack, you place a mark over your target for 5 seconds, granting you 500 Spell Damage against your marked target. This effect can occur every 5 seconds."},
{name="Battlefield Acrobat",bonuses={"Stamina Recovery","Max Stamina","Reduce Cost"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Stamina Recovery;(3 items) Stamina Recovery;(4 items) Max Stamina;(5 items) Reduces the cost of all your abilities by 6%."},
{name="Soldier of Anguish",bonuses={"Weapon Damage","Weapon Critical","Defile"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Weapon Damage;(3 items) Weapon Critical;(4 items) Weapon Damage;(5 items) Your melee light attacks have a 25% chance to place a ring on the ground that explodes after 1.25 seconds, applying 4800 Health Absorption to all enemies hit for 4 seconds, negating the next 4800 points of healing done. This effect can occur once every 6 seconds."},
{name="Steadfast Hero",bonuses={"Physical Resistance","Spell Resistance","Max Health","Protection"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Physical Resistance;(3 items) Spell Resistance;(4 items) Max Health;(5 items) When you cleanse a negative effect from yourself or an ally, gain Major Protection for 5 seconds, reducing your damage taken by 30%. This effect can occur once every 10 seconds."},
{name="Battalion Defender",bonuses={"Max Health","Max Stamina","Healing"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Cyrodiil Rewards / Vendor",dlc="Murkmire",zone="Cyrodiil",displayText="(2 items) Max Health;(3 items) Max Stamina;(4 items) Healing Done;(5 items) After successfully blocking, heal yourself or a group member within 15 meters of you for 2000 health. This effect can occur every 1 second."},
{name="Icy Conjuror",bonuses={"Max Magicka","Spell Damage","Spell Penetration","Frost Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Dungeon Drop",dungeons={"Frostvault"},dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 129 Spell Damage;(4 items) Adds 1487 Spell Penetration;(5 items) Applying a minor debuff to your enemy summons a non- reflectable Ice Wraith that will charge into your enemy, dealing 18920 Frost Damage over 8 seconds.This effect can occur every 12 seconds."},
{name="Tzogvinâ€™s Warband",bonuses={"Weapon Critical","Physical Penetration","Force"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Dungeon Drop",dungeons={"Frostvault"},dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 833 Weapon Critical;(4 items) Adds 1487 Physical Penetration;(5 items) When you deal critical damage with a Light or Heavy attack, you gain a stack of Precision, increasing your Weapon Critical by 129 for 10 seconds, up to 10 stacks max.At max stacks, you also gain Minor Force, increasing your Critical Damage done by 10%."},
{name="Mighty Glacier",bonuses={"Max Stamina","Max Magicka","Stamina Recovery","Magicka Recovery","Resolve","Ward"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},dungeons={"Frostvault"},type="Dungeon Drop",dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1096 Max Magicka;(4 items) Adds 129 Stamina Recovery;(4 items) Adds 129 Magicka Recovery;(5 items) When you cast a snare or immobilize ability, or hit a target with a snare or immobilize ability, you and up to 11 group members gain Major Resolve and Major Ward for 15 seconds, increasing your Physical and Spell Resistances by 5280. This effect can occur once every 10 seconds."},
{name="Stonekeeper",bonuses={"Max Stamina","Max Magicka","Max Health","Healing"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Wrathstone",zone="Gold Coast",dungeons={"Frostvault"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 548 Max Stamina;(1 items) Adds 548 Max Magicka;(1 items) Adds 603 Max Health;(2 items) When you block an attack, you gain an energy Charge stack, up to one stack per second.When you gain 6 Charges, you release the energy, restoring 5350 Stamina and Magicka, and healing for 5350. After releasing the Charges, you cannot regain new Charges for 14 seconds."},
{name="Auroran's Thunder",bonuses={"Max Health","Spell Damage","Spell Penetration","Shock Damage"},hasJewelry=true,hasWeapons=true,weights={"Light"},dungeons={"Depths of Malatar"},type="Dungeon Drop",dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 1206 Max Health;(3 items) Adds 129 Spell Damage;(4 items) Adds 1487 Spell Penetration;(5 items) When you damage a nearby enemy with a single target ability, you summon a cone of lightning from your chest for 3 seconds, dealing 1285 Shock Damage every 0.5 seconds to enemies in the cone.This effect can occur every 6 seconds."},
{name="Scavenging Demise",bonuses={"Weapon Damage","Weapon Critical","Poison Damage","Vulnerability"},hasJewelry=true,hasWeapons=true,weights={"Medium"},dungeons={"Depths of Malatar"},type="Dungeon Drop",dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Adds 833 Weapon Critical;(4 items) Adds 833 Weapon Critical;(5 items) When you deal Critical Poison Damage to an enemy, summon the Scavenging Maw who, after 2 seconds, attacks the enemy, dealing 7210 Poison damage and inflicting Minor Vulnerability for 15 seconds, increasing their Damage Taken by 8%.This effect can occur every 10 seconds."},
{name="Frozen Watcher",bonuses={"Max Stamina","Max Health","Frost Damage"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},dungeons={"Depths of Malatar"},type="Dungeon Drop",dlc="Wrathstone",zone="Gold Coast",displayText="(2 items) Adds 1096 Max Stamina;(3 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Stamina;(5 items) Summon a blizzard around you while blocking, inflicting 1030 Frost Damage every 1 second to enemies within your blizzard.Your blizzard has a 15% chance of inflicting Chilled on enemies damage."},
{name="Symphony of Blades",bonuses={"Healing","Stamina Recovery","Magicka Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Wrathstone",zone="Gold Coast",dungeons={"Depths of Malatar"},shouldersChest="Urgalarg Chief-bane",displayText="(1 items) Adds 4% Healing Done;(2 items) When you heal an ally whose primary resource is under 50%, grant them Meridiaâ€™s Favor, restoring 2325 of that resource every 1 second for 6 seconds. 18 second cooldown."},
{name="Crafty Alfiq",bonuses={"Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc=" Elsweyr",zone="Northern Elsweyr",displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Magicka;(4 items) Adds 1096 Max Magicka;(5 items) Adds 2560 Max Magicka"},
{name="Vesture of Darloc Brae",bonuses={"Magicka Recovery","Stamina Recovery","Reduce Cost","Healing"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc=" Elsweyr",zone="Northern Elsweyr",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Adds 129 Stamina Recovery;(4 items) Reduces the radius you can be detected while Sneaking by 2 meters.Reduces the cost of Sneak by 10%.;(5 items) While crouching, you restore 670 Magicka and Stamina and heal for 670 Health every second."},
{name="Call of the Undertaker",bonuses={"Healing Taken","Max Health","Healing"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc=" Elsweyr",zone="Northern Elsweyr",displayText="(2 items) Adds 4% Healing Taken;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Done;(5 items) Adds 1206 Max Health;(5 items) When you deal damage with a light attack, you apply Minor Lifesteal to your enemy for 8 seconds, healing you and your allies for 600 health every 1 second.This effect can occur once every 8 seconds."},
{name="Senche-raht's Grit",bonuses={"Healing","Max Health","Healing Taken","Physical Resistance","Spell Resistance"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc=" Elsweyr",zone="Northern Elsweyr",traits=8,obtained={location="Starlight Adeptorium"},displayText="(2 items) Adds 4% Healing Done;(3 items) Adds 1206 Max Health;(4 items) Adds 4% Healing Taken;(5 items) After being damaged by a damage over time ability, increase your Healing Received by 6% and your Physical and Spell Resistance by 2585 for 3 seconds."},
{name="Vastarie's Tutelage",bonuses={"Max Stamina","Max Health","Max Magicka","Magicka Recovery","Stamina Recovery","Weapon Damage","Spell Damage","Reduce Cost"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc=" Elsweyr",zone="Northern Elsweyr",traits=3,obtained={location="Rimmen Masterworks"},displayText="(2 items) Adds 1096 Max Stamina;(2 items) Adds 1206 Max Health;(4 items) Adds 1096 Max Magicka;(5 items) Adds 129 Magicka Recovery;(5 items) Adds 129 Stamina Recovery;(5 items) When you resurrect an ally, you and your ally gain 258 Weapon and Spell Damage and 10% cost reduction to all abilities for 10 seconds."},
{name="Coldharbour's Favorite",bonuses={"Max Magicka","Max Stamina","Spell Damage","Weapon Damage","Healing","Magic Damage"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc=" Elsweyr",zone="Northern Elsweyr",traits=8,obtained={location="Valenwood Border Artisan Camp"},displayText="(2 items) Adds 1096 Max Magicka;(3 items) Adds 1096 Max Stamina;(4 items) Adds 129 Spell Damage;(4 items) Adds 129 Weapon Damage;(5 item) When you heal yourself or an ally, summon Cadwellâ€™s noble mount â€“ Honor - who after 2 seconds, casts a healing spell on you and allies around him that heals for 12, 190 Health over 4 seconds.When you damage an enemy, summon Cadwellâ€™s noble mount â€“ Honor - who after 2 seconds, explodes, damaging enemies around him for 12, 190 Magic Damage over 4 seconds.Honor can only be summoned every 10 seconds."},
{name="False God's Devotion",bonuses={"Spell Critical","Slayer","Spell Critical","Reduce Cost","Expedition","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Light"},dungeons={"Sunspire"},type="Dungeon Drop",dlc=" Elsweyr",zone=" Elsweyr",displayText="(2 items) Adds 833 Spell Critical;(3 item) Gain Minor Slayer at all times, increasing your damage done to Dungeon, Trial, and Arena Monsters by 5%.;(4 items) Adds 833 Spell Critical;(5 items) Adds 129 Spell Damage;(5 items) Reduces the cost of your Magicka abilities by 8%.When you kill an enemy, you restore 2150 Magicka and gain Major Expedition for 8 seconds, increasing your Movement Speed by 30%."},
{name="Eye of Nahviintaas",bonuses={"Magicka Recovery","Aegis","Max Magicka","Reduce Cost","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Light"},dungeons={"Sunspire"},type="Dungeon Drop",dlc=" Elsweyr",zone=" Elsweyr",displayText="(2 items) Adds 129 Magicka Recovery;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon, Trial, and Arena Monsters by 5%.;(4 items) Adds 1096 Max Magicka;(5 items) When an ally activates one of your synergies, you and the ally who activated the synergy get 12% cost reduction for non - Ultimate abilities for 3 seconds.This effect can occur every 6 seconds."},
{name="Tooth of Lokkestiiz",bonuses={"Weapon Damage","Slayer"},hasJewelry=true,hasWeapons=true,weights={"Medium"},dungeons={"Sunspire"},type="Dungeon Drop",dlc=" Elsweyr",zone=" Elsweyr",displayText="(2 items) Adds 129 Weapon Damage;(3 items) Gain Minor Slayer at all times, increasing your damage done to Dungeon, Trial, and Arena Monsters by 5%.;(4 items) Adds 129 Weapon Damage;(5 items) When you activate a synergy, gain Major Slayer for 15 seconds, increasing your damage done to Dungeon and Trial monsters by 15%."},
{name="Claw of Yolnakhriin",bonuses={"Max Health","Aegis","Max Stamina","Courage","Taunt"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},dungeons={"Sunspire"},type="Dungeon Drop",dlc=" Elsweyr",zone=" Elsweyr",displayText="(2 items) Adds 1206 Max Health;(3 items) Gain Minor Aegis at all times, reducing your damage taken from Dungeon, Trial, and Arena Monsters by 5%.;(4 items) Adds 1096 Max Stamina;(5 items) When you taunt an enemy, you give yourself and 11 group members Minor Courage for 15 seconds, increasing your Weapon and Spell Damage by 129. This effect can occur once every 8 seconds."},
{name="Hollowfang Thirst",bonuses={"Spell Critical","Max Magicka","Magicka Recovery","Vitality"},hasJewelry=true,hasWeapons=true,weights={"Light"},dungeons={"Moongrave Fane"},type="Dungeon Drop",dlc="Scalebreaker",zone="Northern Elsweyr",displayText="(2 items) Adds 833 spell critical;(3 items) Adds 1096 Maximum Magicka;(4 items) Adds 833 spell critical;(5 items) Whenever you critically heal or critically damage a target, spawn a ball of Hemoglobin at their location.After 2 seconds the ball explodes, restoring 3000 Magicka and applying Minor Vitality to you and your allies within 6 meters of the ball for 9 seconds, increasing their healing received by 8%.This effect can occur once every 9 seconds."},
{name="Dro'Zakar's Claw",bonuses={"Physical Penetration","Weapon Critical","Stamina Recovery","Bleed","Weapon Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},dungeons={"Moongrave Fane"},type="Dungeon Drop",dlc="Scalebreaker",zone="Northern Elsweyr",displayText="(2 items) Adds 1487 Physical Penetration;(3 items) Adds 833 Weapon Critical;(4 items) Adds 129 Stamina Recovery;(5 items) For every bleed effect you have on an enemy, increase your Weapon Damage by 133 against them."},
{name="Renald's Resolve",bonuses={"Max Health","Healing Taken","Physical Resistance","Spell Resistance"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},dungeons={"Moongrave Fane"},type="Dungeon Drop",dlc="Scalebreaker",zone="Northern Elsweyr",displayText="(2 Items) 1206 Maximum Health;(3 Items) 4% Healing Taken;(4 Items) 1206 Maximum Health;(5 Items) Whenever you deal direct damage, gain a stack of Resolve for 10 seconds.Each stack increases your Healing Taken by 1% and your Physical and Spell Resistance by 420. You can only gain one stack of Resolve every 1 second.You can only have up to 8 stacks of Resolve."},
{name="Grundwulf",bonuses={"Weapon Critical","Spell Critical","Magicka Recovery","Stamina Recovery"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Scalebreaker",zone="Northern Elsweyr",dungeons={"Moongrave Fane"},shouldersChest="Urgalarg Chief-bane",displayText="(1 item) Adds 833 Weapon Critical;(1 item) Adds 833 Spell Critical;(2 item) Whenever you deal critical damage, restore 1000 Magicka or Stamina, whichever maximum is higher.You also gain 500 of the other resource.This effect can occur once every 5 seconds"},
{name="Maarselok Set",bonuses={"Max Stamina","Disease Damage"},hasJewelry=false,hasWeapons=false,weights={"Light","Medium","Heavy"},type="Monster Set",dlc="Scalebreaker",zone="Grahtwood",dungeons={"Lair of Maarselok"},shouldersChest="Urgalarg Chief-bane",displayText="(1 item) 1096 Maximum Stamina;(2 items) When you bash an enemy, you spew a cone of corruption, dealing 8000 Disease Damage to enemies.This damage is increased by 5% for each negative effect the enemies have, up to 150% additional damage.This effect can occur once every 7 seconds."},
{name="Azureblight Reaper",bonuses={"Weapon Critical","Max Stamina","Stamina Recovery","Disease Damage"},hasJewelry=true,hasWeapons=true,weights={"Medium"},dungeons={"Lair of Maarselok"},type="Dungeon Drop",dlc="Scalebreaker",zone="Grahtwood",displayText="(2 items) Adds 833 Weapon Critical;(3 items) Adds 1096 Maximum Stamina;(4 items) Adds 129 Stamina Recovery;(5 items) When you deal damage with a damage over time effect, you apply a stack of blight seed to your target for 5 seconds.At 20 stacks, the Blight Seeds explode, dealing 11100 Disease Damage to the target and nearby enemies.An enemy that has reached 20 stacks cannot be infected with Blight Seed for 2 seconds."},
{name="Z'en's Redress",bonuses={"Magicka Recovery","Spell Damage","Max Magicka"},hasJewelry=true,hasWeapons=true,weights={"Light"},dungeons={"Lair of Maarselok"},type="Dungeon Drop",dlc="Scalebreaker",zone="Grahtwood",displayText="(2 items)129 Magicka Recovery;(3 items) 129 spell damage;(4 items) 1096 Maximum Magicka;(5 items) Your Light Attacks apply the Eye of Zâ€™en on enemies for 20 seconds.Enemies with the Eye of Zâ€™en take an additional 1% more damage for each damage over time effect youâ€™ve placed on them, up to 5%."},
{name="Dragon's Defilement",bonuses={"Max Stamina","Max Health","Fracture","Spell Resistance","Physical Resistance"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},dungeons={"Lair of Maarselok"},type="Dungeon Drop",dlc="Scalebreaker",zone="Grahtwood",displayText=" (2 Items) 1096 Maximum Stamina;(3 Items) 1096 Maximum Stamina;(4 Items) 1206 Maximum Health;(5 Items) When you take damage from a melee attack, gain a corrupting aura for 5 seconds that applies Minor Fracture and Minor Breach to all enemies near you, lowering their Physical and Spell Resistance by 1320. This effect can occur every 5 seconds."},
{name="Marauder's Haste",bonuses={"Magicka Recovery","Max Magicka","Expedition","Damage Shield"},hasJewelry=true,hasWeapons=true,weights={"Light"},type="Overland Set",dlc="Dragon Hold",zone="Southern Elsweyer",displayText="(2 items) 129 Magicka Recovery;(3 items) 1096 Max Magicka;(4 items) 129 Magicka Recovery;(5 items) When you cast a damage shield ability, increase your Movement Speed by 20% for 9 seconds."},
{name="Dragonguard Elite",bonuses={"Weapon Critical","Weapon Damage","Stamina Recovery"},hasJewelry=true,hasWeapons=true,weights={"Medium"},type="Overland Set",dlc="Dragon Hold",zone="Southern Elsweyer",displayText="(2 items) 833 Weapon Critical;(3 items) 129 Weapon Damage;(4 items) 129 Stamina Recovery;(5 items) You gain a stack of Dragonguard Tactics for 5 seconds when you deal direct damage to an enemy from the front or sides, up to 5 stacks.Each stack of Dragonguard Tactics increases your Weapon Critical by 476. You can only gain one stack every 1 second."},
{name="Senchal Defender",bonuses={"Max Stamina","Max Health","Max Magicka","Stamina Recovery","Magicka Recovery"},hasJewelry=true,hasWeapons=true,weights={"Heavy"},type="Overland Set",dlc="Dragon Hold",zone="Southern Elsweyer",displayText="(2 items) 1096 Max Stamina;(3 items) 1206 Max Health;(4 items) 1096 Max Magicka;(5 items) Dealing direct damage with a non- Heavy Attack grants you one persistent stack of Senchalâ€™s Duty, up to 10 stacks.After dealing damage with a fully - charged Heavy Attack, restore 666 Stamina and Magicka for each stack of Senchalâ€™s Duty and consume them.You can only gain one stack of Senchalâ€™s Duty every 1 second."},
{name="Ancient Dragonguard",bonuses={"Max Health","Weapon Damage","Spell Damage","Weapon Critical","Spell Critical","Physical Resistance","Spell Resistance"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dragon Hold",zone="Southern Elsweyer",traits=9,obtained={location="Southern Elsweyer"},displayText="(2 items) 1206 Max Health;(3 items) 129 Weapon Damage and Spell Damage;(4 items) 833 Weapon Critical and Spell Critical;(5 items) Gain 300 Weapon Damage and Spell Damage while health is over 50%.Gain 3460 bonus Physical Resistance and Spell Resistance while health is 50% or less."},
{name="Daring Corsair",bonuses={"Stamina Recovery","Magicka Recovery","Weapon Critical","Spell Critical","Reduce Cost","Heroism","Ultimate"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dragon Hold",zone="Southern Elsweyer",traits=3,obtained={location="Southern Elsweyer"},displayText="(2 items) 129 Stamina Recovery;(3 items) 129 Magicka Recovery;(4 items) 833 Weapon and Spell Critical;(5 items) Reduce the cost of your Weapon abilities by 10% Magicka or Stamina.After casting a Weapon ability, gain Minor Heroism for 8 seconds, generating 1 Ultimate every 1.5 seconds while in combat.This effect can occur every 8 seconds."},
{name="New Moon Acolyte",bonuses={"Weapon Critical","Spell Critical","Weapon Damage","Spell Damage","Physical Penetration","Spell Penetration"},hasJewelry=true,hasWeapons=true,weights={"Light","Medium","Heavy"},type="Crafted Set",dlc="Dragon Hold",zone="Southern Elsweyer",traits=9,obtained={location="Southern Elsweyer"},displayText="(2 items) 833 Weapon Critical and Spell Critical;(3 items) 129 Weapon Damage and Spell Damage;(4 items) 1487 Physical Penetration and Spell Penetration;(5 items) Adds 481 Weapon and Spell Damage.Increase the cost of your active abilities by 5%."}}
   
  
        

  








end

-- end InitSets()